@iscript

class Kappa_mask_thumbnail_image_producer extends Kappa_widget_image_producer
	{
		var m_aobj_img_src;

		function Kappa_mask_thumbnail_image_producer()
			{
				super.Kappa_widget_image_producer();
				{
					var i;
					var u_images           = this.u_images;
					var aobj_virtual_frame = this.aobj_virtual_frame;

					m_u_draws = 1;

					for (i = 0; i < u_images; i++)
						aobj_virtual_frame[i].set(0 / 800, 0 / 600, 800 / 800, 600 / 600, 0, 0);
				}
			}

		function finalize()
			{
				super.finalize(*);
				on_cache_unload();
			}

		function on_paint_items(obj_img, u_width, u_height, obj_layer)
			{
				var obj_img_src = new Kappa_image();
				obj_img_src.load_image("thumbnail_mask.tlg");
				obj_img.set_image_size(u_width, u_height);
				strech_src_copy(obj_img, 0, 0, u_width, u_height, obj_img_src);
				invalidate obj_img_src;
			}

		function on_get_id(b_focused, b_enter, b_pushed, b_enabled, u_state=0)
			{
				return 0;
			}

		function on_get_image_cookie(obj_layer, u_width, u_height)
			{
				return "%s_%dx%d".sprintf(str_specify, u_width, u_height);
			}

		property str_specify
			{
				getter
					{
						return "mask_thumbnail";
					}
			}

		property aobj_img_src
			{
				getter
					{
						return m_aobj_img_src;
					}
			}
	}

class Kappa_bookmark_item_thumbnail extends Kappa_picture_box
	{
		var m_obj_producer;
		var m_obj_img_mask;
		var m_u_num;
		var m_u_no_data_bg_color;
		var m_b_enabled;

		function Kappa_bookmark_item_thumbnail(window, parent, b_notify=false)
			{
				super.Kappa_picture_box(window, parent, b_notify=false);
				type = ltAlpha;
				{
					var d_thumbnai_size = kag.calcThumbnailSize();
					m_obj_img_mask = new global.Kappa_picture_box(window, g_obj_omit_layer, false);
					m_obj_producer = g_obj_kappa_share_image.obj_mask_thumbnail_image_producer;
					set_image_size(d_thumbnai_size.width, d_thumbnai_size.height);
					set_size(d_thumbnai_size.width, d_thumbnai_size.height);
					m_obj_producer.checkin(m_obj_img_mask, d_thumbnai_size.width, d_thumbnai_size.height);
					invalidate d_thumbnai_size;
				}
			}

		function finalize()
			{
				m_obj_producer.checkout(m_obj_img_mask) if ((m_obj_producer !== void) && (m_obj_producer isvalid));
				invalidate m_obj_img_mask;
				super.finalize(*);
			}

		function load_by_num(u_num, b_enabled, u_no_data_bg_color = 0x00000000)
			{
				m_u_num = u_num;
				m_b_enabled = b_enabled;
				m_u_no_data_bg_color = u_no_data_bg_color;

				if (u_num == 0xffffffff)
					{
						var obj_img_main = new Kappa_image();

						obj_img_main.setImageSize(width, height);
						obj_img_main.stretchCopy(0, 0, width, height, kag.snapshotLayer,
							0, 0, kag.snapshotLayer.imageWidth, kag.snapshotLayer.imageHeight, stLinear);

						copyRect(0, 0, m_obj_img_mask, 0, 0, width, height);
						face      = dfOpaque;
						holdAlpha = true;
						copyRect(0, 0, obj_img_main, 0, 0, width, height);
						face      = dfAuto;
						holdAlpha = false;

						invalidate obj_img_main;
					}
				else if (u_num == 0xfffffffe)
					{
						var obj_img_logo = new Kappa_image();
						obj_img_logo.type = ltAlpha;
						obj_img_logo.loadImages("logo.tlg");
						height = width;
						stretchCopy(0, 0, width, height, obj_img_logo, 0, 0, obj_img_logo.imageWidth, obj_img_logo.imageHeight, stCubic);
						invalidate obj_img_logo;
					}
				else
					{
 						var str_thumbnail_storage;

						if (fnc_is_existed_bookmark_item_by_num(u_num))
 							str_thumbnail_storage = fnc_get_bookmark_item_filename_by_num(u_num);
						else
							str_thumbnail_storage = void;

						if ((str_thumbnail_storage !== void) && Storages.isExistentStorage(str_thumbnail_storage))
							{
								var obj_img_main = new Kappa_image();

								obj_img_main.load_image(str_thumbnail_storage);

								copyRect(0, 0, m_obj_img_mask, 0, 0, width, height);
								face      = dfOpaque;
								holdAlpha = true;
								copyRect(0, 0, obj_img_main, 0, 0, width, height);
								face      = dfAuto;
								holdAlpha = false;

								invalidate obj_img_main;
							}
						else
							{
								var str_desc = "No Data";

								font.height = 28;
								font.face   = "font_01_28";

								if (u_no_data_bg_color !== 0x00000000)
									{
										copyRect(0, 0, m_obj_img_mask, 0, 0, width, height);
										face      = dfOpaque;
										holdAlpha = true;
										fillRect(0, 0, width, height, u_no_data_bg_color & 0xffffff);
										face      = dfAuto;
										holdAlpha = false;
									}
								else
									{
										fillRect(0, 0, width, height, u_no_data_bg_color);
									}

								drawText(
									(width  - font.getTextWidth(str_desc))  \ 2,
									(height - font.getTextHeight(str_desc)) \ 2,
									str_desc, 0xffffff);
							}
					}

				if (!b_enabled)
					doGrayScale();
			}

		function paste(obj_layer, i_top, i_left, b_enabled)
			{
				if (b_enabled)
					{
						obj_layer.operateRect(i_top, i_left, this, 0, 0, width, height);
					}
				else
					{
						var obj_img_thumbnail = new Kappa_image();
						obj_img_thumbnail.type = ltAlpha;

						obj_img_thumbnail.set_image_size(width, height);
						obj_img_thumbnail.copyRect(0, 0, this, 0, 0, width, height);
						obj_img_thumbnail.doGrayScale();
						obj_layer.operateRect(i_top, i_left, obj_img_thumbnail, 0, 0, width, height);

						invalidate obj_img_thumbnail;
					}
			}

		property b_enabled
			{
				setter(param)
					{
						var b_param = (+param) ? true : false;

						if (m_b_enabled != b_param)
							{
								m_b_enabled = b_param;
								update();
							}

						load_by_num(m_u_num, m_b_enabled, m_u_no_data_bg_color);
					}
				getter
					{
						return m_b_enabled;
					}
			}
	}


class Kappa_bookmark_item_data extends Kappa_object_interface
	{
		var m_d_data;
		var m_obj_img_thumbnail;
		var m_d_thumbnail_size;

		function Kappa_bookmark_item_data()
			{
				m_obj_img_thumbnail = new Kappa_image();
				m_d_thumbnail_size = kag.calcThumbnailSize();
			}

		function finalize()
			{
				invalidate m_d_data if ((m_d_data !== void) && (m_d_data isvalid));
				invalidate m_d_thumbnail_size;
				invalidate m_obj_img_thumbnail;
				super.finalize(*);
			}

		function load(str_storage)
			{
				var str_mode;

				invalidate m_d_data if ((m_d_data !== void) && (m_d_data isvalid));

				try
					{
						if (!Storages.isExistentStorage(str_storage))
							return false;

						str_mode += "o" + m_d_thumbnail_size.size;
						m_d_data = Scripts.evalStorage(str_storage, str_mode);

						if(m_d_data.id != kag.saveDataID)
							{
								System.inform("̃VXẽf[^ǂݍƂ܂", "G[");
								return false;
							}
					}
				catch(e)
					{
						System.inform("xǂݍ߂ȂAx"
							"Ă邩A邢͑̌`̞xf[^"
							"ł(" + e.message + ")", "G[");
						return false;
					}

				m_obj_img_thumbnail.load_image(str_storage);
				return true;
			}

		function save(str_storage)
			{
				try
					{
						var str_mode = kag.saveDataMode;

						m_obj_img_thumbnail.saveLayerImage(str_storage, "bmp" + kag.thumbnailDepth);

						str_mode += "o" + m_d_thumbnail_size.size;
						(Dictionary.saveStruct incontextof m_d_data)(str_storage, str_mode);
					}
				catch(e)
					{
						System.inform("t@Cɕۑł܂ (t@CJȂA"
							"݋֎~ł)");
						return false;
					}

				return true;
			}

		function load_by_num(u_num)
			{
				return load(fnc_get_bookmark_item_filename_by_num(u_num));
			}

		function save_by_num(u_num)
			{
				return save(fnc_get_bookmark_item_filename_by_num(u_num));
			}

		function copy(str_src_storage, str_dst_storage)
			{
				if (!load(str_src_storage))
					return false;
				if (!save(str_dst_storage))
					return false;

				return true;
			}

		function copy_by_num(u_src_num, u_dst_num)
			{
				fnc_set_write_protected_bookmark_item_by_num(u_dst_num, false);

				if (!copy(
					fnc_get_bookmark_item_filename_by_num(u_src_num),
					fnc_get_bookmark_item_filename_by_num(u_dst_num)))
					return false;

				kag.getBookMarkInfoFromData(m_d_data.core, u_dst_num);

				sf.astr_bookmark_note[u_dst_num] = sf.astr_bookmark_note[u_src_num];
				sf.astr_bookmark_date[u_dst_num] = sf.astr_bookmark_date[u_src_num];
				return true;
			}

		property d_data
			{
				getter
					{
						return m_d_data;
					}
			}
	}

function fnc_copy_bookmark_item_by_num(u_src_num, u_dst_num)
	{
		if (fnc_is_existed_bookmark_item_by_num(u_src_num))
			{
				var obj_data = new Kappa_bookmark_item_data();

				if (!obj_data.copy_by_num(u_src_num, u_dst_num))
					{
						invalidate obj_data;
						return false;
					}

				invalidate obj_data;
				g_obj_kappa_system.notify_bookmark_item_changed(u_dst_num);
			}
		else
			{
				if (!fnc_remove_bookmark_item_by_num(u_dst_num))
					return false;
			}

		return true;
	}

function fnc_copy_bookmark_item_by_num_with_ask(u_src_num, u_dst_num, b_ask, d_param)
	{
		var obj_proc = new Kappa_bookmark_copy_procedure(u_src_num, u_dst_num, b_ask, d_param);
		obj_proc.begin_procedure();
	}

function fnc_move_bookmark_item_by_num(u_src_num, u_dst_num)
	{
		var b_state = true;

		if (fnc_is_existed_bookmark_item_by_num(u_src_num))
			{
				if (!fnc_copy_bookmark_item_by_num(u_src_num, u_dst_num))
					return false;

				fnc_set_write_protected_bookmark_item_by_num(u_dst_num, fnc_is_write_protected_bookmark_item_by_num(u_src_num));
				g_obj_kappa_system.notify_bookmark_item_changed(u_dst_num);

				if (!fnc_remove_bookmark_item_by_num(u_src_num))
					return false;
			}
		else
			{
				if (!fnc_remove_bookmark_item_by_num(u_dst_num))
					return false;
			}
		return true;
	}

function fnc_move_bookmark_item_by_num_with_ask(u_src_num, u_dst_num, b_ask, d_param)
	{
		var obj_proc = new Kappa_bookmark_move_procedure(u_src_num, u_dst_num, b_ask, d_param);
		obj_proc.begin_procedure();
	}

function fnc_swap_bookmark_item_by_num(u_num_1, u_num_2)
	{
		var b_existed_1 = fnc_is_existed_bookmark_item_by_num(u_num_1);
		var b_existed_2 = fnc_is_existed_bookmark_item_by_num(u_num_2);

		if (!b_existed_1 && !b_existed_2)
			{
				return true;
			}
		else if (b_existed_1 && !b_existed_2)
			{
				return fnc_move_bookmark_item_by_num(u_num_1, u_num_2);
			}
		else if (!b_existed_1 && b_existed_2)
			{
				return fnc_move_bookmark_item_by_num(u_num_2, u_num_1);
			}
		else
			{
				var obj_data_1 = new Kappa_bookmark_item_data();
				var obj_data_2 = new Kappa_bookmark_item_data();
				var b_book_mark_protected_states_1 = fnc_is_write_protected_bookmark_item_by_num(u_num_1);
				var b_book_mark_protected_states_2 = fnc_is_write_protected_bookmark_item_by_num(u_num_2);
				var str_tmp;

				if (!obj_data_1.load_by_num(u_num_1))
					{
						invalidate obj_data_1;
						invalidate obj_data_2;
						return false;
					}

				if (!obj_data_2.load_by_num(u_num_2))
					{
						invalidate obj_data_1;
						invalidate obj_data_2;
						return false;
					}

				if (!obj_data_1.save_by_num(u_num_2))
					{
						invalidate obj_data_1;
						invalidate obj_data_2;
						return false;
					}

				if (!obj_data_2.save_by_num(u_num_1))
					{
						invalidate obj_data_1;
						invalidate obj_data_2;
						return false;
					}

				kag.getBookMarkInfoFromData(obj_data_2.d_data.core, u_num_1);
				kag.getBookMarkInfoFromData(obj_data_1.d_data.core, u_num_2);

				str_tmp = sf.astr_bookmark_note[u_num_1];
				sf.astr_bookmark_note[u_num_1] = sf.astr_bookmark_note[u_num_2];
				sf.astr_bookmark_note[u_num_2] = str_tmp;

				str_tmp = sf.astr_bookmark_date[u_num_1];
				sf.astr_bookmark_date[u_num_1] = sf.astr_bookmark_date[u_num_2];
				sf.astr_bookmark_date[u_num_2] = str_tmp;

				fnc_set_write_protected_bookmark_item_by_num(u_num_1, b_book_mark_protected_states_2);
				fnc_set_write_protected_bookmark_item_by_num(u_num_2, b_book_mark_protected_states_1);

				g_obj_kappa_system.notify_bookmark_item_changed(u_num_1);
				g_obj_kappa_system.notify_bookmark_item_changed(u_num_2);

				invalidate obj_data_1;
				invalidate obj_data_2;
				return true;
			}
	}

function fnc_swap_bookmark_item_by_num_with_ask(u_num_1, u_num_2, b_ask, d_param)
	{
		var obj_proc = new Kappa_bookmark_swap_procedure(u_num_1, u_num_2, b_ask, d_param);
		obj_proc.begin_procedure();
	}

function fnc_remove_bookmark_item_by_num(u_num)
	{
		fnc_set_write_protected_bookmark_item_by_num(u_num, false);
		kag.eraseBookMark(*);
		sf.astr_bookmark_note[u_num] = void;
		sf.astr_bookmark_date[u_num] = void;
		g_obj_kappa_system.notify_bookmark_item_changed(u_num);
		return true;
	}

function fnc_remove_bookmark_item_by_num_with_ask(u_num, b_ask, d_param)
	{
		var obj_proc = new Kappa_bookmark_remove_procedure(u_num, b_ask, d_param);
		obj_proc.begin_procedure();
	}

function fnc_save_bookmark_item_by_num(u_num)
	{
		var b_state;
		var obj_date = new Date();

		sf.astr_bookmark_date[u_num] = "%04d-%02d-%02d(%s) %02d:%02d:%02d".sprintf(
			obj_date.getYear(), obj_date.getMonth() + 1, obj_date.getDate(), fnc_to_short_weekday_En(obj_date.getDay()),
			obj_date.getHours(), obj_date.getMinutes(), obj_date.getSeconds());

		invalidate obj_date;

		sf.astr_bookmark_note[u_num] = f.str_bookmark_note;
		b_state = kag.saveBookMark(*);
		g_obj_kappa_system.notify_bookmark_item_changed(u_num);
		return b_state;
	}

function fnc_save_bookmark_item_by_num_with_ask(u_num, b_ask, d_param)
	{
		var obj_proc = new Kappa_bookmark_save_procedure(u_num, b_ask, d_param);
		obj_proc.begin_procedure();
	}

function fnc_load_bookmark_item_by_num(u_num)
	{
		var b_state = kag.loadBookMark(u_num);

		if (!b_state)
			return false;

		g_obj_kappa_tray.unlock_widget();
		g_obj_kappa_system.notify_bookmark_item_loaded(u_num);
		return true;
	}

function fnc_load_bookmark_item_by_num_with_ask(u_num, b_ask, d_param)
	{
		var obj_proc = new Kappa_bookmark_load_procedure(u_num, b_ask, d_param);
		obj_proc.begin_procedure();
	}

function fnc_is_existed_bookmark_item_by_num(u_num)
	{
		return (kag.getBookMarkDate(u_num) != "");
	}

function fnc_set_write_protected_bookmark_item_by_num(u_num, b_protected)
	{
		kag.setBookMarkProtectedState(u_num, b_protected);
	}

function fnc_is_write_protected_bookmark_item_by_num(u_num)
	{
		return (kag.bookMarkProtectedStates[u_num] == true);
	}

function fnc_get_bookmark_item_filename_by_num(u_num)
	{
		return kag.getBookMarkFileNameAtNum(u_num);
	}

function fnc_get_bookmark_item_subject_by_num(u_num)
	{
		return kag.getBookMarkPageName(u_num);
	}

function fnc_get_bookmark_item_name(u_num, u_mode)
	{
		if (u_num)
			{
				return " #%02d".sprintf(u_num);
			}
		else
			{
				switch (u_mode)
					{
						case 1:
							return "Q-Load";
						case 2:
							return "Q-Save";
						default:
							return "(`)";
					}
			}
	}

class Kappa_bookmark_operation extends Kappa_object_interface
	{
		var m_ad_undo_code = []; // LILO
		var m_ad_redo_code = []; // LILO
		var m_ab_undo_data_alloc = [];
		var m_u_undo_data_num  = 100;

		function Kappa_bookmark_operation()
			{
			}

		function finalize()
			{
				clear_undo();
				clear_redo();
				invalidate m_ad_undo_code if (m_ad_undo_code isvalid);
				invalidate m_ad_redo_code if (m_ad_redo_code isvalid);
				super.finalize(*);
			}

		function undo()
			{
				var au_update_num;
				var d_undo_code = __get_undo_code();

				switch (d_undo_code.str_opecode)
					{
						case "item_remove":

							au_update_num = __undo_item_remove(d_undo_code);
							break;

						default:
							break;
					}

				__pop_undo_code();
				return au_update_num;
			}

		function item_remove(u_num)
			{
				var au_update_num = __item_remove(u_num);
				clear_redo();
				return au_update_num;
			}

		function get_undo_hint(u_mode)
			{
				var d_undo_code;

				if (!m_ad_undo_code.count)
					return void;

				d_undo_code = __get_undo_code();

				switch (d_undo_code.str_opecode)
					{
						case "item_remove":
							return "폜 %s ɂǂ܂".sprintf(fnc_get_bookmark_item_name(d_undo_code.u_num, u_mode));

						default:
							return void;
					}
			}

		function get_redo_hint()
			{
				var d_redo_code;

				if (!m_ad_redo_code.count)
					return void;

				d_redo_code = __get_redo_code();

				switch (d_redo_code.str_opecode)
					{
						case "item_remove":
							return "%s ̍폜Ȃ܂".sprintf(fnc_get_bookmark_item_name(d_redo_code.u_num));

						default:
							return void;
					}
			}

		function __item_remove(u_num)
			{
				var d_undo_code;
				var au_update_num = [];
				var u_undo_data_num = __alloc_undo_data_num();

				if (!fnc_copy_bookmark_item_by_num(u_num, u_undo_data_num))
					return au_update_num;

				if (!fnc_item_remove_bookmark_item_by_num(u_num))
					return au_update_num;

				au_update_num[0] = u_num;

				d_undo_code = %[];
				d_undo_code.str_opecode = "item_remove";
				d_undo_code.u_num = u_num;
				d_undo_code.u_undo_data_num = u_undo_data_num;
				__push_undo_code(d_undo_code);

				return au_update_num;
			}

		function __undo_item_remove(d_undo_code)
			{
				var d_redo_code;
				var au_update_num = [];

				if (!fnc_copy_bookmark_item_by_num(d_undo_code.u_undo_data_num, d_undo_code.u_num))
					return au_update_num;

				au_update_num[0] = d_undo_code.u_num;

				__free_undo_data_num(d_undo_code.u_undo_data_num);

				d_redo_code = %[];
				d_redo_code.str_opecode = "item_remove";
				d_redo_code.u_num = d_undo_code.u_num;
				__push_redo_code(d_redo_code);

				return au_update_num;
			}

		function __redo_item_remove(d_redo_code)
			{
				return __item_remove(d_redo_code.u_num);
			}







		function __alloc_undo_data_num()
			{
				m_ab_undo_data_alloc[m_u_undo_data_num] = true;
				m_u_undo_data_num++;
				return m_u_undo_data_num;
			}
		function __free_undo_data_num(u_undo_data_num)
			{
				m_u_undo_data_num--;
			}

		function __push_undo_code(d_undo_code)
			{
				m_ad_undo_code.add(d_undo_code);
			}
		function __get_undo_code()
			{
				return m_ad_undo_code[m_ad_undo_code.count - 1];
			}
		function __pop_undo_code()
			{
				invalidate m_ad_undo_code[m_ad_undo_code.count - 1];
				m_ad_undo_code.count = m_ad_undo_code.count - 1;
			}
		function clear_undo()
			{
				fnc_object_array_free(m_ad_undo_code);
				m_ad_undo_code.count = 0;
			}

		function __push_redo_code(d_redo_code)
			{
				m_ad_redo_code.add(d_redo_code);
			}
		function __get_redo_code()
			{
				return m_ad_redo_code[m_ad_redo_code.count - 1];
			}
		function __pop_redo_code()
			{
				invalidate m_ad_redo_code[m_ad_redo_code.count - 1];
				m_ad_redo_code.count = m_ad_redo_code.count - 1;
			}
		function clear_redo()
			{
				fnc_object_array_free(m_ad_redo_code);
				m_ad_redo_code.count = 0;
			}
	}

@endscript
@endif
@return
