@iscript

class Kappa_button_interface extends Kappa_widget_ctrl_interface
	{
		var m_obj_commit_trigger;

		function Kappa_button_interface(obj_super_layer, b_notify_parent)
			{
				Kappa_widget_ctrl_interface(obj_super_layer, b_notify_parent);
				cursor = kag.cursorPointed;
				m_str_commit_up_se_storage = "se_999.wav";
				m_u_commit_up_se_stream_seq = 2;
			}

		function finalize()
			{
				invalidate m_obj_commit_trigger if ((m_obj_commit_trigger !== void) && (m_obj_commit_trigger isvalid));
				super.finalize(*);
			}

		function commit()
			{
				if (m_obj_commit_trigger !== void)
					return;

				var f_trigger = function()
					{
						invalidate m_obj_commit_trigger if ((m_obj_commit_trigger !== void) && (m_obj_commit_trigger isvalid));
						m_obj_commit_trigger = void;

						if (on_commit())
							notify_commit() if (this isvalid);
					} incontextof this;

				m_obj_commit_trigger = new AsyncTrigger(f_trigger, "");
				m_obj_commit_trigger.mode = atmAtIdle;
				m_obj_commit_trigger.trigger();
			}

		function on_commit_button_down(i_x, i_y, button, u_shift)
			{
				update();
				return super.on_commit_button_down(*);
			}

		function on_commit_button_up(i_x, i_y, button, u_shift)
			{
				update();
				return super.on_commit_button_up(*);
			}

		function on_commit_key_down(key, u_shift, b_process)
			{
				if (b_process)
					{
						update();
						super_key_down(key, u_shift, false) if (this isvalid);
						return false;
					}

				return super.on_commit_key_down(*);
			}

		function on_commit_key_up(key, u_shift, b_process)
			{
				if (b_process)
					{
						update();
						super_key_up(key, u_shift, false) if (this isvalid);
						return false;
					}

				return super.on_commit_key_up(*);
			}

		function on_is_commit_key(key, u_shift)
			{
				switch(key)
					{
						case VK_RETURN:
						case VK_SPACE:
							return true;

						default:
							return false;
					}
			}

		function on_is_commit_button(button, u_shift)
			{
				switch(button)
					{
						case mbLeft:
							return true;

						default:
							return false;
					}
			}
	}


class Kappa_image_button_interface extends Kappa_button_interface, Kappa_widget_draw_image_interface
	{
		function Kappa_image_button_interface(obj_super_layer, b_notify, obj_proucer)
			{
				Kappa_button_interface(obj_super_layer, b_notify);
				Kappa_widget_draw_image_interface(global.Kappa_button_interface, obj_proucer);
			}

		function finalize()
			{
				global.Kappa_button_interface.finalize(*);
				global.Kappa_widget_draw_image_interface.finalize(*);
			}

		function on_set_option(elm)
			{
				global.Kappa_button_interface.on_set_option(*);
				global.Kappa_widget_draw_image_interface.on_set_option(*);
			}

		function on_serialize(b_out, str_spec, f)
			{
				global.Kappa_button_interface.on_serialize(*);
				global.Kappa_widget_draw_image_interface.on_serialize(*);
			}
	}

class Kappa_image_button extends KAGLayer, Kappa_image_button_interface
	{
		function Kappa_image_button(window, parent, b_notify=true, obj_proucer)
			{
				KAGLayer(window, parent);
				Kappa_image_button_interface(global.KAGLayer, b_notify, obj_proucer);
			}

		function finalize()
			{
				global.Kappa_image_button_interface.finalize(*);
				global.KAGLayer.finalize(*);
			}

		function assign(obj_src)
			{
				global.KAGLayer.assign(*);
				global.Kappa_image_button_interface.assign(*);
			}
	}

class Kappa_application_button_image_producer extends Kappa_widget_image_producer
	{
		var m_aobj_img_src;

		function Kappa_application_button_image_producer()
			{
				super.Kappa_widget_image_producer();
				{
					var i;
					var u_images           = this.u_images;
					var aobj_virtual_frame = this.aobj_virtual_frame;

					for (i = 0; i < u_images; i++)
						aobj_virtual_frame[i].set(2 / 256, 0 / 128, 240 / 256, 98 / 128, 0, 0.100);

					aobj_virtual_frame[4].r_left += 12 / 256;
					aobj_virtual_frame[4].r_top  += 12 / 128;
				}
			}

		function finalize()
			{
				super.finalize(*);
				on_cache_unload();
			}

		function on_cache_load()
			{
				if (m_aobj_img_src === void)
					{
						m_aobj_img_src = [];

						m_aobj_img_src[0] = new Kappa_image();
						m_aobj_img_src[0].load_image("button_00.tlg");

						m_aobj_img_src[1] = new Kappa_image();
						m_aobj_img_src[1].load_image("button_01.tlg");
					}
			}

		function on_cache_unload()
			{
				if (m_aobj_img_src !== void)
					{
						fnc_object_array_free(m_aobj_img_src);
						invalidate m_aobj_img_src;
						m_aobj_img_src = void;
					}
			}

		function on_paint_image(u_id, obj_img, i_left, i_top, u_width, u_height, obj_layer)
			{
				switch (u_id)
					{
						case 4:// id = 4, push
							colored_strech_src_copy(u_id, obj_img, i_left, i_top, u_width, u_height, m_aobj_img_src[1]);
							break;
						case 0:	// id = 0, normal, focus = false
						case 1: // id = 1, normal, focus = true
						case 2: // id = 2, enter, focus = false
						case 3: // id = 3, enter, focus = true
						case 5: // id = 5, disable
							colored_strech_src_copy(u_id, obj_img, i_left, i_top, u_width, u_height, m_aobj_img_src[0]);
							break;
					}

			}

		property str_specify
			{
				getter
					{
						return "button";
					}
			}

		property aobj_img_src
			{
				getter
					{
						return m_aobj_img_src;
					}
			}
	}


class Kappa_application_button extends Kappa_image_button
	{
		function Kappa_application_button(window, parent, b_notify)
			{
				super.Kappa_image_button(window, parent, b_notify, g_obj_kappa_share_image.obj_button_image_producer);
			}

		function finalize()
			{
				super.finalize(*);
			}

		property height
			{
				setter(param)
					{
						super.height = param;
						u_left_inner_pad = super.height \ 4;
						u_right_inner_pad = super.height \ 4;
					}
				getter
					{
						return super.height;
					}
			}
	}


class Kappa_application_call_button extends Kappa_application_button
	{
		var m_str_callback_storage;
		var m_str_callback_target;
		var m_str_callback_script;
		var m_str_enabled_flag;
		var m_b_wait_cursor = true;
		var m_b_enabled_flag = true;

		function Kappa_application_call_button(window, parent, b_notify)
			{
				super.Kappa_application_button(window, parent, b_notify);
			}

		function finalize()
			{
				super.finalize(*);
			}

		function update_enabled()
			{
				if (m_str_enabled_flag != "")
					{
						m_b_enabled_flag = Scripts.eval(m_str_enabled_flag);
						enabled = m_b_enabled_flag;
					}
			}

		function on_set_option(elm)
			{
				if (elm.callback_storage !== void)
					m_str_callback_storage = elm.callback_storage;

				if (elm.callback_target !== void)
					m_str_callback_target = elm.callback_target;

				if (elm.callback_script !== void)
					m_str_callback_script = elm.callback_script;

				if (elm.enabled_flag !== void)
					m_str_enabled_flag = elm.enabled_flag;

				if (elm.wait_cursor !== void)
					m_b_wait_cursor = +elm.wait_cursor;

				super.on_set_option(*);
			}

		function on_serialize(b_out, str_spec, f)
			{
				serialize_atom(b_out, str_spec, f, "m_str_callback_storage");
				serialize_atom(b_out, str_spec, f, "m_str_callback_target");
				serialize_atom(b_out, str_spec, f, "m_str_callback_script");
				serialize_atom(b_out, str_spec, f, "m_str_enabled_flag");
				serialize_atom(b_out, str_spec, f, "m_b_wait_cursor");
				serialize_atom(b_out, str_spec, f, "m_b_enabled_flag");
				super.on_serialize(*);
			}

		function commit()
			{
				f.b_run = m_b_wait_cursor;
				super.commit();
			}

		function on_commit()
			{
				if (m_str_callback_script != "")
					Scripts.exec(m_str_callback_script);
				if ((m_str_callback_storage != "") || (m_str_callback_target != ""))
					kag.callExtraConductor(m_str_callback_storage, m_str_callback_target);

				return super.on_commit();
			}

		function on_get_id()
			{
				return super.on_get_id();
			}

		property str_callback_storage
			{
				setter(param)
					{
						m_str_callback_storage = (string)param;
					}
				getter
					{
						return m_str_callback_storage;
					}
			}

		property str_callback_target
			{
				setter(param)
					{
						m_str_callback_target = (string)param;
					}
				getter
					{
						return m_str_callback_target;
					}
			}

		property str_callback_script
			{
				setter(param)
					{
						m_str_callback_script = (string)param;
					}
				getter
					{
						return m_str_callback_script;
					}
			}

		property str_enabled_flag
			{
				setter(param)
					{
						m_str_enabled_flag = (string)param;
						update();
					}
				getter
					{
						return m_str_enabled_flag;
					}
			}
	}


@endscript

@return


