@iscript

class Kappa_color_h_slider extends Kappa_slider
	{
		function Kappa_color_h_slider(window, parent, b_notify)
			{
				super.Kappa_slider(window, parent, b_notify);
				hitThreshold = 0x00;
				fillRect(0, 0, width, height, 0x00000000);
			}

		function finalize()
			{
				super.finalize(*);
			}

		function notify_color_updated(obj_sender_layer)
			{
				on_notify_color_updated(*);
			}

		function draw_caption(u_id, i_left, i_top, u_width, u_height, str_caption, u_color)
			{
				var u_text_width;
				var u_text_height;

				font.height = (int)Math.ceil(height / 1.75);
				font.face = "MS UI Gothic";
				u_text_width = font.getTextWidth(str_caption);
				u_text_height = font.getTextHeight(str_caption);

				if (u_color === void)
					{
						m_obj_tmb.obj_producer.draw_text(u_id, this, i_left + (u_width - u_text_width) \ 2, i_top + (u_height - u_text_height) \ 2, str_caption);
					}
				else
					{
						var u_shadow_cookie = font.height \ 16;

						drawText(i_left + (u_width - u_text_width) \ 2, i_top + (u_height - u_text_height) \ 2, str_caption,
							u_color & 0xffffff, (u_color >> 24) & 0xff, true,
							u_shadow_cookie * 0x100, 0x000000, u_shadow_cookie * 2, u_shadow_cookie, u_shadow_cookie);
					}
			}

		function on_draw_image(u_id, i_left, i_top, u_width, u_height)
			{
				var u_h_thumb_width = m_obj_tmb.width;

				on_draw_sample_image(u_id, i_left + u_h_thumb_width \ 2, i_top + (int)(u_height * 0.15), u_width - u_h_thumb_width, (int)(u_height * 0.70));
				on_draw_caption(u_id, i_left, i_top, u_width, u_height);
			}

		function on_draw_sample_image(u_id, i_left, i_top, u_width, u_height)
			{
			}

		function on_draw_caption(u_id, i_left, i_top, u_width, u_height)
			{
				var str_desc = "%s: %.1f%%".sprintf(str_text, m_i_value * 100.0 / m_i_max_value);
				draw_caption(u_id, i_left, i_top, u_width, u_height, str_desc);
			}

		function on_notify_color_updated(obj_sender_layer)
			{
				if (obj_sender_layer !== this)
					update();
			}

		function on_is_must_update_paint(u_id)
			{
				return true;
			}

		function on_create_thumb()
			{
				return new Kappa_application_h_thumb(window, this);
			}
	}

function fnc_get_v_value(u_color)
	{
		var u_r = ((u_color >> 16) & 0xff);
		var u_g = ((u_color >> 8) & 0xff);
		var u_b = (u_color & 0xff);

		u_r = u_g if (u_r < u_g);
		u_r = u_b if (u_r < u_b);

		return u_r;
	}

function fnc_rgb_to_hsv(u_color)
	{
		var u_r = (u_color >> 16) & 0xff;
		var u_g = (u_color >> 8) & 0xff;
		var u_b = (u_color & 0xff);

		var u_min = u_r;
		var u_max = u_r;
		var r_s;
		var u_s;
		var r_h;

		u_min = u_g if (u_min > u_g);
		u_min = u_b if (u_min > u_b);
		u_max = u_g if (u_max < u_g);
		u_max = u_b if (u_max < u_b);

		u_s = u_max - u_min;

		if (!u_s)
			{
			   r_h = void;
			   r_s = 0;
			}
		else
			{
				r_s = u_s / u_max;

				if (u_r == u_max)
					r_h = 60 * (u_g - u_b) / u_s;
				if (u_g == u_max)
					r_h = 60 * (u_b - u_r) / u_s + 120;
				if (u_b == u_max)
					r_h = 60 * (u_r - u_g) / u_s + 240;

				r_h += 360 if r_h < 0;
			}
		return %["r_h" => r_h, "r_s" => r_s, "u_v" => u_max];
	}

function fnc_hsv_to_rgb(r_h, r_s, u_v)
	{
		if (r_h >= 360)
			r_h -= 360;

		if (r_s == 0 || u_v == 0)
			{
				return ((u_v << 16) | (u_v << 8) | u_v);
			}
		else
			{
				var i_h = (int)(r_h / 60) % 6;
				var r_f = r_h / 60 - i_h;

				switch (i_h)
					{
						case 0:
							return (u_v << 16) | (((int)(u_v * (1 - (1 - r_f) * r_s))) << 8) | ((int)(u_v * (1 - r_s)));

						case 1:
							return (((int)(u_v * (1 - r_f * r_s))) << 16) | (u_v << 8) | ((int)(u_v * (1 - r_s)));

						case 2:
							return (((int)(u_v * (1 - r_s))) << 16) | (u_v << 8) | ((int)(u_v * (1 - (1 - r_f) * r_s)));

						case 3:
							return (((int)(u_v * (1 - r_s))) << 16) | (((int)(u_v * (1 - r_f * r_s))) << 8) | u_v;

						case 4:
							return (((int)(u_v * (1 - (1 - r_f) * r_s))) << 16) | (((int)(u_v * (1 - r_s))) << 8) | u_v;

						case 5:
							return (u_v << 16) | (((int)(u_v * (1 - r_s))) << 8) | ((int)(u_v * (1 - r_f * r_s)));
					}
			}
	}


class Kappa_color_rgb_h_slider extends Kappa_color_h_slider
	{
		var m_u_inv_mask;
		var m_u_bit_pos;
		var m_u_color = -1;
		var m_obj_img_grad;
		var m_obj_img_color_grad;

		function Kappa_color_rgb_h_slider(window, parent, b_notify, u_bit_pos)
			{
				super.Kappa_color_h_slider(window, parent, b_notify);
				m_u_bit_pos = u_bit_pos;
				m_u_inv_mask = (~(0xff << u_bit_pos)) & 0x00ffffff;
				m_u_page_size = 0x10;
				m_i_min_value = 0;
				m_i_max_value = 0xff;
				m_i_value = (parent.m_u_color_rgb >> m_u_bit_pos) & 0xff;

			}

		function finalize()
			{
				invalidate m_obj_img_color_grad if (m_obj_img_color_grad !== void);
				invalidate m_obj_img_grad if (m_obj_img_grad !== void);
				super.finalize(*);
			}

		function on_draw_sample_image(u_id, i_left, i_top, u_width, u_height)
			{
				var u_color = (parent.m_u_color_rgb & m_u_inv_mask);

				if (m_obj_img_grad === void)
					{
						var obj_img_color = new Kappa_image();
						obj_img_color.face = dfOpaque;
						obj_img_color.type = ltOpaque;
						obj_img_color.holdAlpha = false;

						m_obj_img_grad = new Kappa_image();
						m_obj_img_grad.face = dfAlpha;
						m_obj_img_grad.type = ltAlpha;
						m_obj_img_grad.holdAlpha = false;

						obj_img_color.fill_rect((0xff << m_u_bit_pos), u_width, u_height);
						m_obj_img_grad.copy_rect(parent.get_gradient_image(0, u_width, u_height));
						m_obj_img_grad.face = dfOpaque;
						m_obj_img_grad.holdAlpha = true;
						m_obj_img_grad.operate_rect(obj_img_color, omSubtractive);
						m_obj_img_grad.holdAlpha = false;
						m_obj_img_grad.face = dfAlpha;
						invalidate obj_img_color;
					}

				if (u_color !== m_u_color)
					{
						if (m_obj_img_color_grad === void)
							{
								m_obj_img_color_grad = new Kappa_image();
								m_obj_img_color_grad.face = dfAlpha;
								m_obj_img_color_grad.type = ltAlpha;
								m_obj_img_color_grad.holdAlpha = false;
								m_obj_img_color_grad.copy_rect(parent.get_gradient_image(0, u_width, u_height));
							}

						m_u_color = u_color;
						m_obj_img_color_grad.type = ltAlpha;
						m_obj_img_color_grad.face = dfOpaque;
						m_obj_img_grad.holdAlpha = true;
						m_obj_img_color_grad.fill_rect(u_color, u_width, u_height);
						m_obj_img_grad.holdAlpha = false;
						m_obj_img_color_grad.face = dfAlpha;
						m_obj_img_color_grad.operate_rect(m_obj_img_grad, omAdditive);
						m_obj_img_color_grad.face = dfAddAlpha;
						m_obj_img_color_grad.type = ltAddAlpha;
						m_obj_img_color_grad.convertType(dfAlpha);
						m_obj_img_color_grad.face = dfAuto;
					}

				copyRect(i_left, i_top, m_obj_img_color_grad, 0, 0, u_width, u_height);
			}

		function on_commit()
			{
				parent.m_u_color_rgb = (parent.m_u_color_rgb & 0xff000000) | (parent.m_u_color_rgb & m_u_inv_mask) | (i_value << m_u_bit_pos);
				parent.conv_rgb_to_hsv();
				update();
				parent.notify_color_updated(this);
				return super.on_commit();
			}

		function on_notify_color_updated(obj_sender_layer)
			{
				if (obj_sender_layer !== this)
					{
						i_value = (parent.m_u_color_rgb >> m_u_bit_pos) & 0xff;
						update();
					}
			}
	}

class Kappa_color_a_h_slider extends Kappa_color_h_slider
	{
		var m_u_color = -1;
		var m_obj_img_color_grad;

		function Kappa_color_a_h_slider(window, parent, b_notify)
			{
				super.Kappa_color_h_slider(window, parent, b_notify);
				m_u_page_size = 0x10;
				m_i_min_value = 0;
				m_i_max_value = 0xff;
				m_b_inverted = true;
				i_value = (parent.m_u_color_rgb >> 24) & 0xff;
			}

		function finalize()
			{
				invalidate m_obj_img_color_grad if (m_obj_img_color_grad !== void);
				super.finalize(*);
			}

		function on_draw_sample_image(u_id, i_left, i_top, u_width, u_height)
			{
				var u_color = parent.m_u_color_rgb & 0xffffff;

				if (u_color !== m_u_color)
					{
						if (m_obj_img_color_grad === void)
							{
								m_obj_img_color_grad = new Kappa_image();
								m_obj_img_color_grad.face = dfAlpha;
								m_obj_img_color_grad.type = ltAlpha;
								m_obj_img_color_grad.holdAlpha = false;
								m_obj_img_color_grad.copy_rect(parent.get_gradient_image(5, u_width, u_height));
							}

						m_u_color = u_color;
						m_obj_img_color_grad.type = ltAlpha;
						m_obj_img_color_grad.face = dfOpaque;
						m_obj_img_color_grad.holdAlpha = true;
						m_obj_img_color_grad.fill_rect(u_color, u_width, u_height);
						m_obj_img_color_grad.holdAlpha = false;
						m_obj_img_color_grad.face = dfAddAlpha;
						m_obj_img_color_grad.type = ltAddAlpha;
						m_obj_img_color_grad.convertType(dfAlpha);
						m_obj_img_color_grad.face = dfAuto;
					}

				copyRect(i_left, i_top, m_obj_img_color_grad, 0, 0, u_width, u_height);
			}

		function on_commit()
			{
				parent.m_u_color_rgb = (parent.m_u_color_rgb & 0x00ffffff) | (i_value << 24);
				parent.update_color_sample();
				update();
				return super.on_commit();
			}

		function on_notify_color_updated(obj_sender_layer)
			{
				if (obj_sender_layer !== this)
					{
						i_value = (parent.m_u_color_rgb >> 24) & 0xff;
						update();
					}
			}
	}

class Kappa_color_h_h_slider extends Kappa_color_h_slider
	{
		var m_u_color = -1;
		var m_obj_img_color_grad;

		function Kappa_color_h_h_slider(window, parent, b_notify)
			{
				super.Kappa_color_h_slider(window, parent, b_notify);
				m_u_page_size = 15;
				m_i_min_value = 0;
				m_i_max_value = 360;
				m_i_value = (int)parent.m_r_h;
				focusable = true;
			}

		function finalize()
			{
				invalidate m_obj_img_color_grad if (m_obj_img_color_grad !== void);
				super.finalize(*);
			}

		function on_draw_sample_image(u_id, i_left, i_top, u_width, u_height)
			{
				var u_min = (int)(parent.m_u_v - parent.m_r_s * parent.m_u_v);
				var u_strong = (int)(0xff - parent.m_r_s * parent.m_u_v);
				var u_color = (u_strong << 24) | (u_min << 16) | (u_min << 8) | u_min;

				if (u_color !== m_u_color)
					{
						if (m_obj_img_color_grad === void)
							{
								m_obj_img_color_grad = new Kappa_image();
								m_obj_img_color_grad.face = dfAlpha;
								m_obj_img_color_grad.type = ltAlpha;
								m_obj_img_color_grad.holdAlpha = false;
							}

						m_u_color = u_color;
						m_obj_img_color_grad.type = ltAlpha;
						m_obj_img_color_grad.face = dfAlpha;
						m_obj_img_color_grad.copy_rect(parent.get_gradient_image(2, u_width, u_height));
						m_obj_img_color_grad.face = dfOpaque;
						m_obj_img_color_grad.holdAlpha = true;
						m_obj_img_color_grad.color_rect(u_color, u_width, u_height);
						m_obj_img_color_grad.holdAlpha = false;
						m_obj_img_color_grad.face = dfAddAlpha;
						m_obj_img_color_grad.type = ltAddAlpha;
						m_obj_img_color_grad.convertType(dfAlpha);
						m_obj_img_color_grad.face = dfAuto;
					}

				copyRect(i_left, i_top, m_obj_img_color_grad, 0, 0, u_width, u_height);
			}

		function on_draw_caption(u_id, i_left, i_top, u_width, u_height)
			{
				var str_desc = "%s: %d".sprintf(str_text, m_i_value);
				draw_caption(u_id, i_left, i_top, u_width, u_height, str_desc);
			}

		function on_commit()
			{
				parent.m_r_h = i_value;
				parent.conv_hsv_to_rgb();
				update();
				parent.notify_color_updated(this);
				return super.on_commit();
			}

		function on_notify_color_updated(obj_sender_layer)
			{
				if (obj_sender_layer !== this)
					{
						i_value = (int)parent.m_r_h;
						update();
					}
			}
	}

class Kappa_color_s_h_slider extends Kappa_color_h_slider
	{
		var m_u_color = -1;
		var m_obj_img_color_grad;
		var m_u_v = -1;
		var m_obj_img_v_grad;

		function Kappa_color_s_h_slider(window, parent, b_notify)
			{
				super.Kappa_color_h_slider(window, parent, b_notify);
				m_u_page_size = 5;
				m_i_min_value = 0;
				m_i_max_value = 100;

				i_value = (int)Math.ceil(parent.m_r_s * 100);
			}

		function finalize()
			{
				invalidate m_obj_img_v_grad if (m_obj_img_v_grad !== void);
				invalidate m_obj_img_color_grad if (m_obj_img_color_grad !== void);
				super.finalize(*);
			}

		function on_draw_sample_image(u_id, i_left, i_top, u_width, u_height)
			{
				var u_v = parent.m_u_v;
				var u_color = fnc_hsv_to_rgb(parent.m_r_h, 1.0, 0xff);

				if (u_color !== m_u_color)
					{
						if (m_obj_img_color_grad === void)
							{
								m_obj_img_color_grad = new Kappa_image();
								m_obj_img_color_grad.face = dfAlpha;
								m_obj_img_color_grad.type = ltAlpha;
								m_obj_img_color_grad.holdAlpha = false;
								m_obj_img_color_grad.copy_rect(parent.get_gradient_image(1, u_width, u_height));
							}

						m_obj_img_color_grad.type = ltAlpha;
						m_obj_img_color_grad.face = dfOpaque;
						m_obj_img_color_grad.holdAlpha = true;
						m_obj_img_color_grad.fill_rect(u_color, u_width, u_height);
						m_obj_img_color_grad.holdAlpha = false;
						m_obj_img_color_grad.face = dfAlpha;
					}

				if ((u_color !== m_u_color) || (u_v !== m_u_v))
					{
						if (m_obj_img_v_grad === void)
							{
								m_obj_img_v_grad = new Kappa_image();
								m_obj_img_v_grad.face = dfAlpha;
								m_obj_img_v_grad.type = ltAlpha;
								m_obj_img_v_grad.holdAlpha = false;
							}

						m_u_v = u_v;
						m_u_color = u_color;
						m_obj_img_v_grad.type = ltAlpha;
						m_obj_img_v_grad.face = dfAlpha;
						m_obj_img_v_grad.copy_rect(parent.get_gradient_image(1, u_width, u_height));
						m_obj_img_v_grad.face = dfOpaque;
						m_obj_img_v_grad.holdAlpha = true;
						m_obj_img_v_grad.operate_rect(m_obj_img_color_grad, omAdditive);
						m_obj_img_v_grad.holdAlpha = false;
						m_obj_img_v_grad.face = dfAlpha;
						m_obj_img_v_grad.adjustGamma(1.0, 0, u_v, 1.0, 0, u_v, 1.0, 0, u_v);
						m_obj_img_v_grad.face = dfAddAlpha;
						m_obj_img_v_grad.type = ltAddAlpha;
						m_obj_img_v_grad.convertType(dfAlpha);
						m_obj_img_v_grad.face = dfAuto;
					}

				copyRect(i_left, i_top, m_obj_img_v_grad, 0, 0, u_width, u_height);
			}

		function on_draw_caption(u_id, i_left, i_top, u_width, u_height)
			{
				var str_desc = "%s: %d%%".sprintf(str_text, m_i_value);
				draw_caption(u_id, i_left, i_top, u_width, u_height, str_desc);
			}

		function on_commit()
			{
				parent.m_r_s = i_value / 100;
				parent.conv_hsv_to_rgb();
				update();
				parent.notify_color_updated(this);
				return super.on_commit();
			}

		function on_notify_color_updated(obj_sender_layer)
			{
				if (obj_sender_layer !== this)
					{
						i_value = (int)Math.ceil(parent.m_r_s * 100);
						update();
					}
			}
	}

class Kappa_color_v_h_slider extends Kappa_color_h_slider
	{
		var m_u_color = -1;
		var m_obj_img_color_grad;
		var m_obj_img_color;

		function Kappa_color_v_h_slider(window, parent, b_notify)
			{
				super.Kappa_color_h_slider(window, parent, b_notify);
				m_u_page_size = 0x10;
				m_i_min_value = 0;
				m_i_max_value = 0xff;
				i_value = parent.m_u_v;
			}

		function finalize()
			{
				invalidate m_obj_img_color if (m_obj_img_color !== void);
				invalidate m_obj_img_color_grad if (m_obj_img_color_grad !== void);
				super.finalize(*);
			}

		function on_draw_sample_image(u_id, i_left, i_top, u_width, u_height)
			{
				var u_color = fnc_hsv_to_rgb(parent.m_r_h, parent.m_r_s, 0xff);

				if (u_color !== m_u_color)
					{
						if (m_obj_img_color === void)
							{
								m_obj_img_color = new Kappa_image();
								m_obj_img_color.face = dfAlpha;
								m_obj_img_color.type = ltAlpha;
								m_obj_img_color.holdAlpha = false;
								m_obj_img_color.copy_rect(parent.get_gradient_image(0, u_width, u_height));
							}

						if (m_obj_img_color_grad === void)
							{
								m_obj_img_color_grad = new Kappa_image();
								m_obj_img_color_grad.face = dfAlpha;
								m_obj_img_color_grad.type = ltAlpha;
								m_obj_img_color_grad.holdAlpha = false;
							}

						m_u_color = u_color;
						m_obj_img_color.type = ltAlpha;
						m_obj_img_color.face = dfOpaque;
						m_obj_img_color.holdAlpha = true;
						m_obj_img_color.fill_rect(u_color, u_width, u_height);

						m_obj_img_color_grad.type = ltAlpha;
						m_obj_img_color_grad.face = dfAlpha;
						m_obj_img_color_grad.copy_rect(parent.get_gradient_image(0, u_width, u_height));
						m_obj_img_color_grad.face = dfOpaque;
						m_obj_img_color_grad.holdAlpha = true;
						m_obj_img_color_grad.operate_rect(m_obj_img_color, omSubtractive);
						m_obj_img_color_grad.holdAlpha = false;
						m_obj_img_color_grad.face = dfAddAlpha;
						m_obj_img_color_grad.type = ltAddAlpha;
						m_obj_img_color_grad.convertType(dfAlpha);
						m_obj_img_color_grad.face = dfAuto;
					}

				copyRect(i_left, i_top, m_obj_img_color_grad, 0, 0, u_width, u_height);
			}

		function on_commit()
			{
				parent.m_u_v = i_value;
				parent.conv_hsv_to_rgb();
				update();
				parent.notify_color_updated(this);
				return super.on_commit();
			}

		function on_notify_color_updated(obj_sender_layer)
			{
				if (obj_sender_layer !== this)
					{
						i_value = parent.m_u_v;
						update();
					}
			}
	}

class Kappa_color_dialog_sheet extends Kappa_application_dialog_sheet
	{
		var m_obj_sld_r;
		var m_obj_sld_g;
		var m_obj_sld_b;
		var m_obj_sld_h;
		var m_obj_sld_s;
		var m_obj_sld_v;
		var m_obj_sld_a;
		var m_obj_lbl_color;
		var m_obj_pic_color_sample;
		var m_obj_img_color;
		var m_obj_pic_board;

		var m_aobj_img_grad = [];

		var m_u_color_rgb = 0xff808080;
		var m_b_alpha = true;

		var m_r_h = 0;
		var m_r_s;
		var m_u_v;

		function Kappa_color_dialog_sheet(window, parent, b_notify, d_param)
			{
				d_param.str_ok = "OK" if (d_param.str_ok === void);
				d_param.str_cancel = "LZ" if (d_param.str_cancel === void);
				super.Kappa_application_dialog_sheet(window, parent, b_notify, d_param);
				{
					var i_xpos;
					var i_ypos;
					var i_ypad = 2;
					var obj_img_color_sample;

					if (d_param !== void)
						{
							m_u_color_rgb = d_param.u_color if (d_param.u_color !== void);
							m_b_alpha = d_param.b_alpha if (d_param.b_alpha !== void);
						}

					i_xpos  = m_cu_left_pad + 8;

					conv_rgb_to_hsv();

					if (m_b_alpha)
						i_ypos = m_cu_top_pad + (m_cu_v_height - (28 * 7 + i_ypad * 6)) \ 2;
					else
						i_ypos = m_cu_top_pad + (m_cu_v_height - (28 * 6 + i_ypad * 5)) \ 2;

					m_obj_sld_h = new Kappa_color_h_h_slider(window, this, 0);
					register_child(m_obj_sld_h);
					i_ypos = i_ypad + init_color_sld(m_obj_sld_h, i_xpos, i_ypos, "F", "F𒲐܂");
					m_obj_sld_s = new Kappa_color_s_h_slider(window, this, 0);
					register_child(m_obj_sld_s);
					i_ypos = i_ypad + init_color_sld(m_obj_sld_s, i_xpos, i_ypos, "ʓx", "ʓx𒲐܂");
					m_obj_sld_v = new Kappa_color_v_h_slider(window, this, 0);
					register_child(m_obj_sld_v);
					i_ypos = i_ypad + init_color_sld(m_obj_sld_v, i_xpos, i_ypos, "x", "x𒲐܂");
					m_obj_sld_r = new Kappa_color_rgb_h_slider(window, this, false, 16);
					register_child(m_obj_sld_r);
					i_ypos = i_ypad + init_color_sld(m_obj_sld_r, i_xpos, i_ypos, "", "Ԃ̋𒲐܂");
					m_obj_sld_g = new Kappa_color_rgb_h_slider(window, this, false, 8);
					register_child(m_obj_sld_g);
					i_ypos = i_ypad + init_color_sld(m_obj_sld_g, i_xpos, i_ypos, "", "΂̋𒲐܂");
					m_obj_sld_b = new Kappa_color_rgb_h_slider(window, this, 0);
					register_child(m_obj_sld_b);
					i_ypos = i_ypad + init_color_sld(m_obj_sld_b, i_xpos, i_ypos, "", "̋𒲐܂");

					if (m_b_alpha)
						{
							m_obj_sld_a = new Kappa_color_a_h_slider(window, this, 0);
							register_child(m_obj_sld_a);
							i_ypos = i_ypad + init_color_sld(m_obj_sld_a, i_xpos, i_ypos, "x", "x̋𒲐܂");
						}

					m_obj_pic_board = create_picture_box(0, 0);
					m_obj_pic_board.type = ltAddAlpha;
					m_obj_pic_board.loadImages("board_color_sample.tlg");
					m_obj_pic_board.setSizeToImageSize();
					m_obj_pic_board.set_position(
						m_cu_left_pad + m_cu_v_width - m_obj_pic_board.width - 12,
						m_cu_top_pad + (m_cu_v_height - m_obj_pic_board.height) \ 2);

					obj_img_color_sample = get_gradient_image(3, 64, void);

					m_obj_pic_color_sample = create_picture_box(
						m_obj_pic_board.left + (m_obj_pic_board.width - obj_img_color_sample.width) \ 2,
						m_obj_pic_board.top + (m_obj_pic_board.height - obj_img_color_sample.height) \ 2);
					m_obj_pic_color_sample.type = ltAlpha;

					m_obj_img_color = new Kappa_image();
					m_obj_img_color.type = ltAlpha;
					m_obj_img_color.copy_rect(obj_img_color_sample);

					m_obj_lbl_color = new Kappa_application_label(window, this);
					register_child(m_obj_lbl_color);
					m_obj_lbl_color.b_no_cache_image = true;
					m_obj_lbl_color.font.face = "lr SVbN";
					m_obj_lbl_color.font.height = 16;
					
					if (m_b_alpha)
						m_obj_lbl_color.str_text = "#%08X".sprintf(m_u_color_rgb);
					else
						m_obj_lbl_color.str_text = "#%06X".sprintf(m_u_color_rgb & 0xffffff);

					m_obj_lbl_color.fit_size();
					m_obj_lbl_color.set_position((m_obj_btn_ok.left + m_cu_left_pad - m_obj_lbl_color.width) \ 2, (m_cu_bottom_pad - m_obj_lbl_color.height) \ 2 + m_cu_top_pad + m_cu_v_height);
					m_obj_lbl_color.visible = true;

					update_color_sample();
				}
			}

		function finalize()
			{
				invalidate m_obj_img_color if m_obj_img_color isvalid;
				fnc_object_array_free(m_aobj_img_grad);
				invalidate m_aobj_img_grad;

				super.finalize(*);
			}

		function init_color_sld(obj_sld, i_left, i_top, str_caption, str_desc)
			{
				obj_sld.set_rect(i_left, i_top, 266, 28);
				obj_sld.str_text = str_caption;
				obj_sld.hint = str_desc;
				obj_sld.visible = true;
				return (i_top + obj_sld.height);
			}

		function get_gradient_image(u_id, u_width, u_height)
			{

				if (m_aobj_img_grad[u_id] === void)
					{
						var str_storage;
						var obj_img_src = new Kappa_image();
						var b_flip = false;
						var b_no_shrink = false;
						var obj_img_grad;

						obj_img_grad = m_aobj_img_grad[u_id] = new Kappa_image();

						switch (u_id)
							{
								case 0:
									str_storage = "gradient_00.tlg";
									break;

								case 1:
									b_flip = true;
									str_storage = "gradient_00.tlg";
									break;

								case 2:
									str_storage = "gradient_01.tlg";
									break;

								case 3:
									str_storage = "color_sample.tlg";
									break;

								case 5:
									str_storage = "gradient_02.tlg";
									break;

								case 6:
									str_storage = "gradient_03.tlg";
									break;

								default:
									str_storage = "gradient_00.tlg";
									break;
							}

						obj_img_src.load_image(str_storage);

						if ((u_width === void) && u_height === void)
							{
								u_width  = obj_img_src.imageWidth;
								u_height = obj_img_src.imageHeight;
							}
						else if (u_width === void)
							{
								// keep aspect
								u_width = (int)(u_height * obj_img_src.imageWidth / obj_img_src.imageHeight);
							}
						else if (u_height === void)
							{
								// keep aspect
								u_height = (int)(u_width * obj_img_src.imageHeight / obj_img_src.imageWidth);
							}

						if (b_no_shrink)
							{
								obj_img_grad.setSize(u_width, u_height);
								obj_img_grad.copyRect(0, 0, obj_img_src,
									(obj_img_src.width - u_width) \ 2, (obj_img_src.height - u_height) \ 2,
									u_width, u_height);
							}
						else
							obj_img_grad.stretch_copy(obj_img_src, u_width, u_height);

						obj_img_grad.flipLR() if (b_flip);

						invalidate obj_img_src;
					}


				return m_aobj_img_grad[u_id];
			}

		function conv_rgb_to_hsv()
			{
				var d_hsv = fnc_rgb_to_hsv(m_u_color_rgb);
				m_r_h = d_hsv.r_h if (d_hsv.r_h !== void);
				m_r_s = d_hsv.r_s;
				m_u_v = d_hsv.u_v;
				invalidate d_hsv;
			}

		function conv_hsv_to_rgb()
			{
				m_u_color_rgb = (m_u_color_rgb & 0xff000000) | fnc_hsv_to_rgb(m_r_h, m_r_s, m_u_v);
			}

		function update_color_sample()
			{
				var obj_img = get_gradient_image(3, 64, void);
				m_obj_img_color.holdAlpha = true;
				m_obj_img_color.face = dfOpaque;
				m_obj_img_color.fill_rect(m_u_color_rgb & 0xffffff, m_obj_img_color.width, m_obj_img_color.height);
				m_obj_img_color.face = dfAlpha;
				m_obj_img_color.holdAlpha = false;

				m_obj_pic_color_sample.set_size(obj_img.width, obj_img.height);
				m_obj_pic_color_sample.set_image_size(obj_img.width, obj_img.height);
				m_obj_pic_color_sample.type = ltAlpha;
				m_obj_pic_color_sample.face = dfAlpha;
				m_obj_pic_color_sample.copyRect(0, 0, obj_img, 0, 0, obj_img.width, obj_img.height);
				m_obj_pic_color_sample.operateRect(0, 0, m_obj_img_color, 0, 0, m_obj_img_color.width, m_obj_img_color.height, omPsOverlay);
				m_obj_pic_color_sample.face = dfAddAlpha;
				m_obj_pic_color_sample.type = ltAddAlpha;
				m_obj_pic_color_sample.convertType(dfAlpha);
				m_obj_pic_color_sample.face = dfAuto;
				m_obj_pic_color_sample.opacity = (m_u_color_rgb >> 24) & 0xff;

				if (m_b_alpha)
					m_obj_lbl_color.str_text = "#%08X".sprintf(m_u_color_rgb);
				else
					m_obj_lbl_color.str_text = "#%06X".sprintf(m_u_color_rgb & 0xffffff);

				d_cookie.f_on_update(parent, m_u_color_rgb, d_cookie.cookie) if (d_cookie.f_on_update !== void);
			}

		function notify_color_updated(obj_sender_layer)
			{
				update_color_sample();
				m_obj_sld_r.notify_color_updated(obj_sender_layer);
				m_obj_sld_g.notify_color_updated(obj_sender_layer);
				m_obj_sld_b.notify_color_updated(obj_sender_layer);
				m_obj_sld_h.notify_color_updated(obj_sender_layer);
				m_obj_sld_s.notify_color_updated(obj_sender_layer);
				m_obj_sld_v.notify_color_updated(obj_sender_layer);

				if (m_b_alpha)
					m_obj_sld_a.notify_color_updated(obj_sender_layer);
			}

		function on_commit_ok(obj_sender_layer)
			{
				m_i_state = 1;

				if (d_cookie.f_on_ok !== void)
					{
						if (!d_cookie.f_on_ok(parent, m_u_color_rgb, d_cookie.cookie))
							return;
					}

				parent.hide(void, void);
			}

		property u_color
			{
				getter
					{
						return m_u_color_rgb;
					}
			}
	}

class Kappa_color_dialog extends Kappa_dialog
	{
		var m_u_color;
		var m_b_alpha;

		function Kappa_color_dialog(window, parent, b_notify=false, d_param)
			{
				super.Kappa_dialog(window, parent, b_notify, d_param);
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_create_sheet(d_param)
			{
				return new Kappa_color_dialog_sheet(window, this, false, d_param);
			}
	}

@endscript


@return

