@iscript


class Kappa_dialog_plugin extends KAGPlugin
	{
		var m_obj_dialog;

		function Kappa_dialog_plugin(obj_dialog)
			{
				m_obj_dialog = obj_dialog;
			}

		function finalize()
			{
				super.finalize(*);
			}

		function onExchangeForeBack()
			{
				if (m_obj_dialog.parent == kag.fore.base)
					m_obj_dialog.parent = kag.back.base;
				else
					m_obj_dialog.parent = kag.fore.base;
			}
	}

class Kappa_dialog_interface extends Kappa_form_interface
	{
		var m_obj_original_focus_layer;
		var m_i_original_cursor_x;
		var m_i_original_cursor_y;

		var m_obj_sheet;
		var m_obj_plugin;

		function Kappa_dialog_interface(obj_super_layer, b_notify=false, d_param)
			{
				super.Kappa_form_interface(obj_super_layer, b_notify=false);
				{
					var i_xpos;
					var i_ypos;
					var u_button_area_width = 0;
					var u_button_area_height = 0;

					focusable = false;
					hitType = htMask;
					hitThreshold = 0x00;
					hasImage = false;

					neutralColor = 0x00000000;
					absolute     = 5000000;

					absolute = absolute + g_aobj_dialog.count;

					set_size(kag.scWidth, kag.scHeight);
					m_obj_sheet = on_create_sheet(d_param);
					register_child(m_obj_sheet);
					m_obj_sheet.left = (width - m_obj_sheet.width) \ 2;
					m_obj_sheet.top = (height - m_obj_sheet.height) \ 2;

					m_obj_original_focus_layer = window.focusedLayer;
					m_i_original_cursor_x = cursorX;
					m_i_original_cursor_y = cursorY;

					m_obj_plugin = new Kappa_dialog_plugin(this);
					kag.addPlugin(m_obj_plugin);
					g_aobj_dialog.add(this);
				}
			}

		function finalize()
			{
				g_aobj_dialog.remove(this);
				kag.removePlugin(m_obj_plugin) if (kag isvalid);
				invalidate m_obj_plugin if (m_obj_plugin isvalid);
				super.finalize(*);
			}

		function show(elm, d_param)
			{
				visible = true;
				m_obj_sheet.show(*);
			}

		function hide(elm, d_param)
			{
				if (!g_b_begin_exit_process)
					fnc_begin_cursor_move(parent, m_i_original_cursor_x, m_i_original_cursor_y, (int)(sf.cu_system_trans_time * 0.75), 0) if (!m_obj_sheet.i_state && sf.b_pseudo_smart_pointer);

				m_obj_sheet.hide(*);
			}

		function on_end_hide_transition()
			{
				if ((m_obj_original_focus_layer !== null) && (m_obj_original_focus_layer isvalid))
					{
						var obj_layer = m_obj_original_focus_layer;

						if (!obj_layer.enabled)
							obj_layer = obj_layer.nextFocusable;

						if ((obj_layer !== null) && !obj_layer.focused)
							obj_layer.focus();
					}

				cursorX++;
				cursorY++;
				cursorX--;
				cursorY--;

				visible = false;
				destroy();
				super.on_end_hide_transition();
			}

		function on_destroy()
			{
				g_b_begin_exit_process = false;
			}

		function on_create_sheet(d_param)
			{
				return new Kappa_dialog_sheet(window, this, false, d_param);
			}

		function on_key_down(key, u_shift, b_process)
			{
				if (key == VK_ESCAPE)
					{
						close();
						return false;
					}

				return super.on_key_down(*);
			}

		function on_mouse_left_down(i_x, i_y, u_shift)
			{
				fnc_stop();
				return super.on_mouse_left_down(*);
			}

		function on_mouse_right_down(obj_sender_layer, i_x, i_y, u_shift)
			{
				fnc_stop();
				close();
				super.on_notify_mouse_right_down(*);
			}

		function on_notify_commit(obj_sender_layer)
			{
				if (obj_sender_layer.d_cookie.f_on_commit !== void)
					obj_sender_layer.d_cookie.f_on_commit(obj_sender_layer);

				super.on_notify_commit(obj_sender_layer);
			}

		function close()
			{
				on_close();
			}

		function on_close()
			{
				if (m_obj_sheet.visible)
					m_obj_sheet.obj_btn_cancel.commit() if (m_obj_sheet.obj_btn_cancel !== void);
			}

		property obj_sht
			{
				getter
					{
						return m_obj_sheet;
					}
			}
	}

class Kappa_dialog extends KAGLayer, Kappa_dialog_interface
	{
		function Kappa_dialog(window, parent, b_notify=false, d_param)
			{
				KAGLayer(window, parent);
				Kappa_dialog_interface(global.KAGLayer, b_notify, d_param);
			}

		function finalize()
			{
				global.Kappa_dialog_interface.finalize(*);
				global.KAGLayer.finalize(*);
			}

		function assign(obj_src)
			{
				global.KAGLayer.assign(*);
				global.Kappa_dialog_interface.assign(*);
			}
	}

class Kappa_dialog_sheet_interface extends Kappa_sheet_interface
	{
		var m_i_state = 0;
		var m_obj_btn_ok;
		var m_obj_btn_cancel;
		var m_i_begin_drag_xpos = void;
		var m_i_begin_drag_ypos = void;

		function Kappa_dialog_sheet_interface(obj_super_layer, b_notify=false, d_param)
			{
				super.Kappa_sheet_interface(obj_super_layer, b_notify);

				if (d_param !== void)
					(Dictionary.assign incontextof m_d_cookie)(d_param);

				if (d_cookie.str_ok !== void)
					m_obj_btn_ok = create_large_button(0, 0, d_cookie.str_ok, d_cookie.str_ok_hint, on_commit_ok);
				if (d_cookie.str_cancel !== void)
					m_obj_btn_cancel = create_large_button(0, 0, d_cookie.str_cancel, d_cookie.str_cancel_hint, on_commit_cancel);
			}

		function finalize()
			{
				super.finalize(*);
			}

		function show(elm, d_param)
			{
				visible = true;

				if ((m_obj_btn_ok !== void) && (m_obj_btn_cancel !== void))
					{
						fnc_begin_cursor_move(m_obj_btn_cancel, -2, m_obj_btn_cancel.height \ 2, (int)(sf.cu_system_trans_time * 0.75), 0) if (sf.b_pseudo_smart_pointer);
						m_obj_btn_cancel.focus();
					}
				else if (m_obj_btn_cancel !== void)
					{
						fnc_begin_cursor_move(m_obj_btn_cancel, m_obj_btn_cancel.width \ 2, m_obj_btn_cancel.height \ 2, (int)(sf.cu_system_trans_time * 0.75), 0) if (sf.b_pseudo_smart_pointer);
						m_obj_btn_cancel.focus();
					}
				else if (m_obj_btn_ok !== void)
					{
						fnc_begin_cursor_move(m_obj_btn_ok, m_obj_btn_ok.width \ 2, m_obj_btn_cancel.height \ 2, (int)(sf.cu_system_trans_time * 0.75), 0) if (sf.b_pseudo_smart_pointer);
						m_obj_btn_ok.focus();
					}

				visible = false;
				super.show(*);
			}

		function on_end_show_transition()
			{
				d_cookie.f_on_end_show_transition(parent, d_cookie.cookie) if (d_cookie.f_on_end_show_transition !== void);
				parent.on_end_show_transition();
				super.on_end_show_transition();
			}

		function on_end_hide_transition()
			{
				d_cookie.f_on_end_hide_transition(parent, d_cookie.cookie) if (d_cookie.f_on_end_hide_transition !== void);
				parent.on_end_hide_transition();
				super.on_end_hide_transition();
			}

		function on_paint()
			{
				fillRect(0, 0, 400, 300, 0xff000000);
				fillRect(15, 15, 370, 238, 0xffffffff);
			}

		function on_commit_ok(obj_sender_layer)
			{
				m_i_state = 1;

				if (d_cookie.f_on_ok !== void)
					{
						if (!d_cookie.f_on_ok(parent, d_cookie.cookie))
							return;
					}

				parent.hide(void, void);
			}

		function on_commit_cancel(obj_sender_layer)
			{
				m_i_state = 0;

				if (d_cookie.f_on_cancel !== void)
					{
						if (!d_cookie.f_on_cancel(parent, d_cookie.cookie))
							return;
					}

				parent.hide(void, void);
			}

		function on_mouse_left_down(i_x, i_y, u_shift)
			{
				m_i_begin_drag_xpos = i_x;
				m_i_begin_drag_ypos = i_y;
				cursor = kag.cursorDraggable;
				return super.on_mouse_left_down(*);
			}

		function on_mouse_left_up(i_x, i_y, u_shift)
			{
				cursor = window.cursorDefault;
				m_i_begin_drag_xpos = void;
				m_i_begin_drag_ypos = void;
				return super.on_mouse_left_up(*);
			}

		function on_cursor_move(i_x, i_y, u_shift)
			{
				if (m_i_begin_drag_xpos !== void)
					{
						left = (int)(i_x - m_i_begin_drag_xpos + left);
						top  = (int)(i_y - m_i_begin_drag_ypos + top);
/*
						if (left < 0)
							left = 0;
						if (left > kag.scWidth - width)
							left = kag.scWidth - width;
						if (top < 0)
							top = 0;
						if (top > kag.scHeight - height)
							top = kag.scHeight - height;
*/
						if (left < (0x80 - width))
							left = 0x80 - width;
						if (left > (kag.scWidth - 0x80))
							left = kag.scWidth - 0x80;

						if (top < (0x80 - height))
							top = 0x80 - height;
						if (top > (kag.scHeight - 0x80))
							top = kag.scHeight - 0x80;
					}

				return super.on_cursor_move(*);
			}

		property i_state
			{
				getter
					{
						return m_i_state;
					}
			}

		property obj_btn_ok
			{
				getter
					{
						return m_obj_btn_ok;
					}
			}

		property obj_btn_cancel
			{
				getter
					{
						return m_obj_btn_cancel;
					}
			}
	}

class Kappa_image_dialog_sheet_interface extends Kappa_dialog_sheet_interface
	{
		var m_obj_producer;

		function Kappa_image_dialog_sheet_interface(obj_super_layer, b_notify=false, d_param, obj_proucer, u_width, u_height)
			{
				super.Kappa_dialog_sheet_interface(obj_super_layer, b_notify, d_param);
				{
					m_obj_producer = obj_proucer;
					m_obj_producer.checkin(this, u_width, u_height);
					setSizeToImageSize();
				}
			}

		function finalize()
			{
				m_obj_producer.checkout(this) if ((m_obj_producer !== void) && (m_obj_producer isvalid));
				super.finalize(*);
			}
	}

class Kappa_application_message_dialog_image_producer extends Kappa_widget_image_producer
	{
		var m_aobj_img_src;

		function Kappa_application_message_dialog_image_producer()
			{
				super.Kappa_widget_image_producer();
				{
					var i;
					var u_images           = this.u_images;
					var aobj_virtual_frame = this.aobj_virtual_frame;

					m_u_draws = 1;

					for (i = 0; i < u_images; i++)
						aobj_virtual_frame[i].set(15 / 400, 15 / 300, 370 / 400, 238 / 300, 0, 0);
				}
			}

		function finalize()
			{
				super.finalize(*);
				on_cache_unload();
			}

		function on_paint_items(obj_img, u_width, u_height, obj_layer)
			{
				var obj_img_logo = new Kappa_image();
				var obj_img_small_logo = new Kappa_image();
				var u_v_width  = 400 - 15 - 15;
				var u_v_height = 300 - 15 - 47;
				var r_pad_ratio = 0.05;
				var u_v_pad;
				var r_scale;

				obj_img_logo.load_image("logo_question.tlg");

				if (u_v_width > u_v_height)
					r_scale = (u_v_height - (u_v_height * r_pad_ratio) * 2) / obj_img_logo.height;
				else
					r_scale = (u_v_width - (u_v_width * r_pad_ratio) * 2) / obj_img_logo.width;

				obj_img_small_logo.stretch_copy(obj_img_logo, (obj_img_logo.width * r_scale), (obj_img_logo.height * r_scale));
				invalidate obj_img_logo;

				obj_img.loadImages("dialog_message_01.tlg");
				colored_image(0, obj_img, 0, 0, obj_img.imageWidth, obj_img.imageHeight);

				obj_img.operateRect(
					(u_v_width - obj_img_small_logo.width) \ 2 + 15, (u_v_height - obj_img_small_logo.height) \ 2 + 15,
					obj_img_small_logo,
					0, 0, obj_img_small_logo.imageWidth, obj_img_small_logo.imageHeight, omAlpha, 0x20);
				invalidate obj_img_small_logo;
			}

		function on_get_id(b_focused, b_enter, b_pushed, b_enabled, u_state=0)
			{
				return 0;
			}

		function on_get_image_cookie(obj_layer, u_width, u_height)
			{
				return "%s_%dx%d".sprintf(str_specify, u_width, u_height);
			}

		property str_specify
			{
				getter
					{
						return "message_dialog";
					}
			}

		property aobj_img_src
			{
				getter
					{
						return m_aobj_img_src;
					}
			}
	}

class Kappa_image_dialog_sheet extends KAGLayer, Kappa_image_dialog_sheet_interface
	{
		function Kappa_image_dialog_sheet(window, parent, b_notify=false, d_param, obj_proucer, u_width, u_height)
			{
				KAGLayer(window, parent);
				Kappa_image_dialog_sheet_interface(global.KAGLayer, b_notify, d_param, obj_proucer, u_width, u_height);
			}

		function finalize()
			{
				global.Kappa_image_dialog_sheet_interface.finalize(*);
				global.KAGLayer.finalize(*);
			}

		function assign(obj_src)
			{
				global.KAGLayer.assign(*);
				global.Kappa_image_dialog_sheet_interface.assign(*);
			}
	}

class Kappa_application_dialog_sheet extends Kappa_image_dialog_sheet
	{
		var m_cu_width      = 400;
		var m_cu_height     = 300;
		var m_cu_left_pad   = 15;
		var m_cu_right_pad  = 15;
		var m_cu_top_pad    = 15;
		var m_cu_bottom_pad = 47;
		var m_cu_v_width    = 400 - 15 - 15;
		var m_cu_v_height   = 300 - 15 - 47;

		function Kappa_application_dialog_sheet(window, parent, b_notify=false, d_param)
			{
				super.Kappa_image_dialog_sheet(window, parent, b_notify, d_param,
					g_obj_kappa_share_image.obj_message_dialog_image_producer, 400, 300);
				{
					var i_xpos;
					var i_ypos;
					var u_button_area_width = 0;
					var u_button_area_height = 0;

					if (m_obj_btn_ok !== void)
						{
							u_button_area_width += m_obj_btn_ok.width;
							u_button_area_height = m_obj_btn_ok.height;
						}

					if (m_obj_btn_cancel !== void)
						{
							u_button_area_width += 4 if (u_button_area_width);
							u_button_area_width += m_obj_btn_cancel.width;
							u_button_area_height = m_obj_btn_cancel.height;
						}

					i_xpos = (m_cu_width + m_cu_left_pad - m_cu_right_pad - u_button_area_width) \ 2;
					i_ypos = m_cu_height - (m_cu_bottom_pad + u_button_area_height) \ 2;

					if (m_obj_btn_ok !== void)
						{
							m_obj_btn_ok.set_position(i_xpos, i_ypos);
							i_xpos += m_obj_btn_ok.width + 4;
						}

					if (m_obj_btn_cancel !== void)
						{
							m_obj_btn_cancel.set_position(i_xpos, i_ypos);
						}
				}
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_notify_commit(obj_sender_layer)
			{
				if (obj_sender_layer.d_cookie.f_on_commit !== void)
					obj_sender_layer.d_cookie.f_on_commit(obj_sender_layer);

				super.on_notify_commit(obj_sender_layer);
			}
	}


@endscript

@return
