@iscript


class Kappa_form_interface extends Kappa_widget_interface
	{
		var m_obj_focus_child_layer = null;
		var m_u_absolute;

		function Kappa_form_interface(obj_super_layer, b_notify=false)
			{
				super.Kappa_widget_interface(obj_super_layer, b_notify);
				m_u_absolute = absolute;
				focusable    = false;
				hitType      = htMask;
				hitThreshold = 0x00;
				cursor       = crArrow;
				neutralColor = 0x00000000;
				str_cursor_enter_se_storage = "";
			}

		function finalize()
			{
				super.finalize(*);
			}

		function focus_child()
			{
				if (visible && enabled && (m_obj_focus_child_layer !== null))
					m_obj_focus_child_layer.focus();
			}

		function create_static_label(i_left, i_top, str_text)
			{
				var obj_lbl = new Kappa_application_static_label(window, this);
				register_child(obj_lbl);

				obj_lbl.set_position(i_left, i_top);
				obj_lbl.font.height = 22;
				obj_lbl.str_text = str_text;
				obj_lbl.fit_size();
				obj_lbl.visible = true;

				return obj_lbl;
			}

		function create_button(i_left, i_top, str_text, str_hint, f_on_commit)
			{
				var obj_btn = new Kappa_application_button(window, this);
				register_child(obj_btn);

				obj_btn.set_position(i_left, i_top);
				obj_btn.font.height = 12;
				obj_btn.str_text = str_text;
				obj_btn.fit_size();
				obj_btn.hint     = str_hint;
				obj_btn.d_cookie.f_on_commit = f_on_commit;
				obj_btn.visible  = true;

				return obj_btn;
			}

		function create_symbol_button(i_left, i_top, str_text, str_hint, f_on_commit)
			{
				var obj_btn = new Kappa_application_button(window, this);
				register_child(obj_btn);

				obj_btn.set_position(i_left, i_top);
				obj_btn.font.face = "symbol_00_12";
				obj_btn.font.height = 12;
				obj_btn.str_text = str_text;
				obj_btn.fit_size();
				obj_btn.hint     = str_hint;
				obj_btn.d_cookie.f_on_commit = f_on_commit;
				obj_btn.visible  = true;

				return obj_btn;
			}

		function create_check_button(i_left, i_top, str_text, str_hint, b_state, f_on_commit)
			{
				var obj_chk = new Kappa_application_2state_check_button(window, this);
				register_child(obj_chk);

				obj_chk.set_position(i_left, i_top);
				obj_chk.font.height = 16;
				obj_chk.str_text = str_text;
				obj_chk.fit_size();
				obj_chk.hint = str_hint;
				obj_chk.u_state = b_state;
				obj_chk.d_cookie.f_on_commit = f_on_commit;
				obj_chk.visible = true;

				return obj_chk;
			}

		function create_2state_base_radio_button(obj_grp, i_left, i_top, str_text, str_hint, f_on_commit)
			{
				var obj_rdo = new Kappa_application_2state_base_radio_button(window, this);
				register_child(obj_rdo);

				obj_rdo.set_position(i_left, i_top);
				obj_rdo.font.height = 12;
				obj_rdo.str_text = str_text;
				obj_rdo.fit_size();
				obj_rdo.hint = str_hint;
				obj_rdo.d_cookie.f_on_commit = f_on_commit;
				obj_rdo.add_group(obj_grp);
				obj_rdo.visible = true;

				return obj_rdo;
			}

		function create_2state_radio_button(obj_grp, i_left, i_top, str_text, str_hint, f_on_commit)
			{
				var obj_rdo = new Kappa_application_2state_radio_button(window, this);
				register_child(obj_rdo);

				obj_rdo.set_position(i_left, i_top);
				obj_rdo.font.height = 12;
				obj_rdo.str_text = str_text;
				obj_rdo.fit_size();
				obj_rdo.hint     = str_hint;
				obj_rdo.d_cookie.f_on_commit = f_on_commit;
				obj_rdo.add_group(obj_grp);
				obj_rdo.visible = true;

				return obj_rdo;
			}

		function create_base_tab_button(obj_grp, i_left, i_top, str_text, str_hint, f_on_commit)
			{
				var obj_tab = new Kappa_application_base_tab_button(window, this);
				register_child(obj_tab);

				obj_tab.set_position(i_left, i_top);
				obj_tab.font.height = 12;
				obj_tab.str_text = str_text;
				obj_tab.fit_size();
				obj_tab.hint     = str_hint;
				obj_tab.d_cookie.f_on_commit = f_on_commit;
				obj_tab.add_group(obj_grp);
				obj_tab.visible  = true;

				return obj_tab;
			}

		function create_spin_button(i_left, i_top, str_text, str_hint, f_on_spin, u_range_size)
			{
				var obj_btn = new Kappa_application_spin_button(window, this);
				register_child(obj_btn);

				obj_btn.set_position(i_left, i_top);
				obj_btn.font.height = 12;
				obj_btn.str_text = str_text;
				obj_btn.fit_size();
				obj_btn.hint     = str_hint;
				obj_btn.u_range_size = u_range_size;
				obj_btn.d_cookie.f_on_spin = f_on_spin;
				obj_btn.visible  = true;

				return obj_btn;
			}

		function create_symbol_spin_button(i_left, i_top, str_text, str_hint, f_on_spin, u_range_size)
			{
				var obj_btn = new Kappa_application_spin_button(window, this);
				register_child(obj_btn);

				obj_btn.set_position(i_left, i_top);
				obj_btn.font.face = "symbol_00_12";
				obj_btn.font.height = 12;
				obj_btn.str_text = str_text;
				obj_btn.fit_size();
				obj_btn.hint     = str_hint;
				obj_btn.u_range_size = u_range_size;
				obj_btn.d_cookie.f_on_spin = f_on_spin;
				obj_btn.visible  = true;

				return obj_btn;
			}

		function create_medium_2state_radio_button(obj_grp, i_left, i_top, str_text, str_hint, f_on_commit)
			{
				var obj_rdo = new Kappa_application_2state_radio_button(window, this);
				register_child(obj_rdo);

				obj_rdo.set_position(i_left, i_top);
				obj_rdo.font.height = 16;
				obj_rdo.str_text = str_text;
				obj_rdo.fit_size();
				obj_rdo.hint     = str_hint;
				obj_rdo.d_cookie.f_on_commit = f_on_commit;
				obj_rdo.add_group(obj_grp);
				obj_rdo.visible = true;

				return obj_rdo;
			}

		function create_medium_2state_base_radio_button(obj_grp, i_left, i_top, str_text, str_hint, f_on_commit)
			{
				var obj_rdo = new Kappa_application_2state_base_radio_button(window, this);
				register_child(obj_rdo);

				obj_rdo.set_position(i_left, i_top);
				obj_rdo.font.height = 16;
				obj_rdo.str_text = str_text;
				obj_rdo.fit_size();
				obj_rdo.hint = str_hint;
				obj_rdo.d_cookie.f_on_commit = f_on_commit;
				obj_rdo.add_group(obj_grp);
				obj_rdo.visible = true;

				return obj_rdo;
			}

		function create_large_button(i_left, i_top, str_text, str_hint, f_on_commit)
			{
				var obj_btn = new Kappa_application_button(window, this);
				register_child(obj_btn);

				obj_btn.set_position(i_left, i_top);
				obj_btn.font.height = 19;
				obj_btn.str_text = str_text;
				obj_btn.fit_size();
				obj_btn.hint     = str_hint;
				obj_btn.d_cookie.f_on_commit = f_on_commit;
				obj_btn.visible  = true;

				return obj_btn;
			}

		function create_v_slider(i_left, i_top, u_height, str_hint, i_min_value, i_max_value, u_page_size, i_value, f_on_commit)
			{
				var obj_sld = new Kappa_application_v_slider(window, this);
				register_child(obj_sld);

				obj_sld.set_rect(i_left, i_top, 28, u_height);
				obj_sld.i_min_value = i_min_value;
				obj_sld.i_max_value = i_max_value;
				obj_sld.u_page_size = u_page_size;
				obj_sld.hint = str_hint;
				obj_sld.d_cookie.f_on_commit = f_on_commit;
				obj_sld.i_value = i_value;
				obj_sld.recalc_layout();
				obj_sld.visible = true;

				return obj_sld;
			}

		function create_volume_h_slider(i_left, i_top, u_width, str_hint, u_volume, f_on_commit)
			{
				var obj_sld = new Kappa_decorated_h_slider(window, this);
				register_child(obj_sld);

				obj_sld.set_rect(i_left, i_top, u_width, 28);
				obj_sld.i_min_value = 0;
				obj_sld.i_max_value = 100;
				obj_sld.u_page_size = 10;
				obj_sld.str_prefix = " : ";
				obj_sld.str_suffix = "%";
				obj_sld.str_left = "W";
				obj_sld.u_left_color = 0xffffffff;
				obj_sld.str_right = "X";
				obj_sld.u_right_color = 0xffffff00;
				obj_sld.hint = str_hint;
				obj_sld.d_cookie.f_on_commit = f_on_commit;
				obj_sld.i_value = u_volume;
				obj_sld.recalc_layout();
				obj_sld.visible = true;

				return obj_sld;
			}

		function create_wait_time_h_slider(i_left, i_top, u_width, str_prefix, str_suffix, str_hint, u_wait_time, u_max_wait_time, f_on_commit, r_ratio = 1, u_floor = 0)
			{
				var obj_sld = new Kappa_decorated_h_slider(window, this);
				register_child(obj_sld);

				obj_sld.set_rect(i_left, i_top, u_width, 28);
				obj_sld.b_inverted = true;
				obj_sld.i_min_value = 0;
				obj_sld.i_max_value = u_max_wait_time;
				obj_sld.u_page_size = u_max_wait_time \ 10;
				obj_sld.str_prefix = str_prefix + " : ";
				obj_sld.str_suffix = str_suffix;
				obj_sld.str_left = "4";
				obj_sld.u_left_color = 0xffffffff;
				obj_sld.str_right = "8";
				obj_sld.u_right_color = 0xffffff00;
				obj_sld.hint = str_hint;
				obj_sld.d_cookie.f_on_commit = f_on_commit;
				obj_sld.i_value = u_wait_time;
				obj_sld.r_ratio = r_ratio;
				obj_sld.u_floor = u_floor;
				obj_sld.recalc_layout();
				obj_sld.visible = true;

				return obj_sld;
			}

		function create_picture_box(i_left, i_top)
			{
				var obj_pic = new Kappa_picture_box(window, this);
				register_child(obj_pic);

				obj_pic.set_position(i_left, i_top);
				obj_pic.visible = true;
				return obj_pic;
			}

		function create_bookmark_item_thumbnail(i_left, i_top)
			{
				var obj_pic = new Kappa_bookmark_item_thumbnail(window, this);
				register_child(obj_pic);

				obj_pic.set_position(i_left, i_top);
				obj_pic.visible = true;
				return obj_pic;
			}

		function on_notify_focus(obj_sender_layer, obj_focused_layer, b_direction)
			{
				m_obj_focus_child_layer = obj_sender_layer;
				super.on_notify_focus(*);
			}

		property enabled
			{
				setter(param)
					{
						var b_param = (+param !== 0);

						if (b_param != super.enabled)
							{
								if (b_param)
									{
										super.enabled = b_param;
										focus_child();
									}
								else
									{
										if (visible)
											{
												var obj_focus_child_layer = fnc_get_focus_child_layer(this, true);
												m_obj_focus_child_layer = obj_focus_child_layer if (obj_focus_child_layer !== null);
											}

										super.enabled = b_param;
									}
							}
					}
				getter
					{
						return super.enabled;
					}
			}

		property visible
			{
				setter(param)
					{
						var b_param = (+param !== 0);

						if (b_param != m_obj_super_layer.visible)
							{
								if (b_param)
									{
										m_obj_super_layer.visible = b_param;
										focus_child();
									}
								else
									{
										if (enabled)
											{
												var obj_focus_child_layer = fnc_get_focus_child_layer(this, true);
												m_obj_focus_child_layer = obj_focus_child_layer if (obj_focus_child_layer !== null);
											}

										m_obj_super_layer.visible = b_param;
									}
							}
					}
				getter
					{
						return m_obj_super_layer.visible;
					}
			}

		property absolute
			{
				setter(param)
					{
						var u_param = (int)param;

						if (m_obj_super_layer.absolute !== u_param)
							{
								m_u_absolute = u_param;

								if (visible && enabled)
									{
										var obj_focus_child_layer = fnc_get_focus_child_layer(this, true);
										m_obj_super_layer.absolute = m_u_absolute;

										if ((obj_focus_child_layer !== null) && (window.focusedLayer === null))
											{
												m_obj_focus_child_layer = obj_focus_child_layer;
												obj_focus_child_layer.focus();
											}
									}
								else
									{
										m_obj_super_layer.absolute = m_u_absolute;
									}
							}
					}
				getter
					{
						return m_obj_super_layer.absolute;
					}
			}

		property parent
			{
				setter(param)
					{
						if (m_obj_super_layer.parent !== param)
							{
								if (visible && enabled)
									{
										var obj_focus_child_layer = fnc_get_focus_child_layer(this, true);

										m_obj_super_layer.parent = param;
										absolute = m_u_absolute;

										if ((obj_focus_child_layer !== null) && (window.focusedLayer === null))
											{
												m_obj_focus_child_layer = obj_focus_child_layer;
												obj_focus_child_layer.focus();
											}
									}
								else
									{
										m_obj_super_layer.parent = param;
										absolute = m_u_absolute;
									}
							}
					}
				getter
					{
						return m_obj_super_layer.parent;
					}
			}
	}

class Kappa_form extends KAGLayer, Kappa_form_interface
	{
		function Kappa_form(window, parent, b_notify=true)
			{
				KAGLayer(window, parent);
				Kappa_form_interface(global.KAGLayer, b_notify);
			}

		function finalize()
			{
				global.Kappa_form_interface.finalize(*);
				global.KAGLayer.finalize(*);
			}

		function assign(obj_src)
			{
				global.KAGLayer.assign(*);
				global.Kappa_form_interface.assign(*);
			}
	}

class Kappa_application_form extends Kappa_form
	{

		function Kappa_application_form(window, parent, b_notify)
			{
				super.Kappa_form(window, parent, b_notify);
			}

		function finalize()
			{
				super.finalize(*);
			}

		function close()
			{
				on_close();
			}

		function on_key_down(key, u_shift, b_process)
			{
				if (key == VK_ESCAPE)
					{
						fnc_stop();
						close();
						super_key_down(key, u_shift, false);
						return false;
					}

				return super.on_key_down(*);
			}

		function on_mouse_left_down(i_x, i_y, u_shift)
			{
				fnc_stop();
				return super.on_mouse_left_down(*);
			}

		function on_mouse_right_down(i_x, i_y, u_shift)
			{
				fnc_stop();
				close();
				return super.on_mouse_right_down(*);
			}

		function on_notify_commit(obj_sender_layer)
			{
				if (obj_sender_layer.d_cookie.f_on_commit !== void)
					obj_sender_layer.d_cookie.f_on_commit(*);

				super.on_notify_commit(obj_sender_layer);
			}

		function on_notify_spin(obj_sender_layer, key, u_delta)
			{
				if (obj_sender_layer.d_cookie.f_on_spin !== void)
					obj_sender_layer.d_cookie.f_on_spin(*);

				super.on_notify_spin(*);
			}

		function on_close()
			{
			}
	}



@endscript

@return
