@iscript

class Kappa_image extends Layer
	{
		function Kappa_image(window, parent)
			{
				super.Layer((window === void) ? kag : window, (parent === void) ? g_obj_omit_layer : parent);

				focusable    = false;
				neutralColor = 0x00000000;
				hitType      = htMask;
				hitThreshold = 0x100;
				face = dfAuto;
				type = ltAddAlpha;

			}

		function finalize()
			{
				super.finalize(*);
			}

		function assign_font(obj_font_src)
			{
				var obj_font_dst = font;

				obj_font_dst.angle = obj_font_src.angle;
				obj_font_dst.bold = obj_font_src.bold;
				obj_font_dst.face = obj_font_src.face;
				obj_font_dst.height = obj_font_src.height;
				obj_font_dst.italic = obj_font_src.italic;
				obj_font_dst.strikeout = obj_font_src.strikeout;
				obj_font_dst.underline = obj_font_src.underline;
			}

		function clear()
			{
				fillRect(0, 0, width, height, 0x00000000);
			}

		function load_image(str_storage)
			{
				loadImages(str_storage);
				if ((width != imageWidth) || (height != imageHeight))
					setSizeToImageSize();
			}

		function set_image_size(u_width, u_height)
			{
				if ((imageWidth != u_width) || (imageHeight != u_height))
					setImageSize(u_width, u_height);
				if ((width != u_width) || (height != u_height))
					setSizeToImageSize();
			}

		function stretch_copy(obj_img_src, u_width, u_height)
			{
				set_image_size(u_width, u_height);
				stretchCopy(0, 0, width, height,
					obj_img_src,
					0, 0, obj_img_src.width, obj_img_src.height, stCubic);
			}

		function fill_rect(u_color, u_width, u_height)
			{
				set_image_size(u_width, u_height);
				fillRect(0, 0, u_width, u_height, u_color);
			}

		function color_rect(u_color, u_width, u_height)
			{
				set_image_size(u_width, u_height);
				colorRect(0, 0, u_width, u_height, u_color & 0xffffff, (u_color >> 24) & 0xff);
			}

		function copy_rect(obj_img_src)
			{
				set_image_size(obj_img_src.width, obj_img_src.height);
				copyRect(0, 0, obj_img_src, 0, 0, width, height);
			}

		function operate_rect(obj_img_src, mode=omAuto, opa=255)
			{
				set_image_size(obj_img_src.width, obj_img_src.height);
				operateRect(0, 0, obj_img_src, 0, 0, width, height, mode, opa);
			}
	}


class Kappa_picture_box_interface extends Kappa_widget_ctrl_interface
	{
		function Kappa_picture_box_interface(obj_super_layer, b_notify_parent)
			{
				Kappa_widget_ctrl_interface(obj_super_layer, b_notify_parent);
				cursor = kag.cursorDefault;
				focusable    = false;
				neutralColor = 0x00000000;
				hitType      = htMask;
				hitThreshold = 0x100;
				face = dfAuto;
				type = ltAddAlpha;
			}

		function finalize()
			{
				super.finalize(*);
			}
	}

class Kappa_picture_box extends KAGLayer, Kappa_picture_box_interface
	{
		function Kappa_picture_box(window, parent, b_notify=false)
			{
				KAGLayer(window, parent);
				Kappa_picture_box_interface(global.KAGLayer, b_notify);
			}

		function finalize()
			{
				global.Kappa_picture_box_interface.finalize(*);
				global.KAGLayer.finalize(*);
			}

		function assign(obj_src)
			{
				global.KAGLayer.assign(*);
				global.Kappa_picture_box_interface.assign(*);
			}
	}



@endscript

@return


