@iscript

class Kappa_label_interface extends Kappa_widget_ctrl_interface
	{
		function Kappa_label_interface(obj_super_layer, b_notify_parent = false)
			{
				Kappa_widget_ctrl_interface(obj_super_layer, b_notify_parent);

				hitType      = htMask;
				opacity      = 0xff;
				hitThreshold = 0x100;
				focusable    = false;
			}

		function finalize()
			{
				super.finalize(*);
			}
	}

class Kappa_image_label_interface extends Kappa_label_interface, Kappa_widget_draw_image_interface
	{
		var m_u_color;
		var m_u_color_strong;
		var m_u_light;
		var m_u_light_strong;
		var m_u_opacity;

		function Kappa_image_label_interface(obj_super_layer, b_notify, obj_proucer)
			{
				Kappa_label_interface(obj_super_layer, b_notify);
				Kappa_widget_draw_image_interface(global.Kappa_label_interface, obj_proucer);
			}

		function finalize()
			{
				global.Kappa_label_interface.finalize(*);
				global.Kappa_widget_draw_image_interface.finalize(*);
			}

		function on_set_option(elm)
			{
				global.Kappa_label_interface.on_set_option(*);
				global.Kappa_widget_draw_image_interface.on_set_option(*);
			}

		function on_serialize(b_out, str_spec, f)
			{
				global.Kappa_label_interface.on_serialize(*);
				global.Kappa_widget_draw_image_interface.on_serialize(*);
			}

		function apply_producer_draw(obj_producer, u_id)
			{
				m_u_color = obj_producer.get_text_color(u_id);
				m_u_color_strong = obj_producer.get_text_color_strong(u_id);
				m_u_light = obj_producer.get_text_light(u_id);
				m_u_light_strong = obj_producer.get_text_light_strong(u_id);
				m_u_opacity = obj_producer.get_text_opacity(u_id);
				update();
			}

		property u_color
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != m_u_color)
							{
								m_u_color = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return m_u_color;
					}
			}

		property u_color_strong
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != m_u_color_strong)
							{
								m_u_color_strong = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return m_u_color_strong;
					}
			}

		property u_light
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != m_u_light)
							{
								m_u_light = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return m_u_light;
					}
			}

		property u_light_strong
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != m_u_light_strong)
							{
								m_u_light_strong = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return m_u_light_strong;
					}
			}

		property u_opacity
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != m_u_opacity)
							{
								m_u_opacity = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return m_u_opacity;
					}
			}
	}

class Kappa_image_label extends KAGLayer, Kappa_image_label_interface
	{
		function Kappa_image_label(window, parent, b_notify=false, obj_proucer)
			{
				KAGLayer(window, parent);
				Kappa_image_label_interface(global.KAGLayer, b_notify, obj_proucer);
			}

		function finalize()
			{
				global.Kappa_image_label_interface.finalize(*);
				global.KAGLayer.finalize(*);
			}

		function assign(obj_src)
			{
				global.KAGLayer.assign(*);
				global.Kappa_image_label_interface.assign(*);
			}
	}

class Kappa_label_image_producer extends Kappa_widget_image_producer
	{
		function Kappa_label_image_producer()
			{
				super.Kappa_widget_image_producer();
				m_u_draws = 2;
				{
					var i;
					var u_images           = this.u_images;
					var aobj_virtual_frame = this.aobj_virtual_frame;

					for (i = 0; i < u_images; i++)
						aobj_virtual_frame[i].set(0.0, 0.0, 1.0, 1.0, 0.0, 0.0);
				}
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_paint_text(u_id, obj_img, i_left, i_top, u_width, u_height, obj_layer)
			{
				if (obj_layer.str_text != "")
					{
						i_left += Math.ceil((u_width  - obj_layer.font.getTextWidth(obj_layer.str_text))  / 2);
						i_top  += Math.ceil((u_height - obj_layer.font.getTextHeight(obj_layer.str_text)) / 2);

						obj_img.assign_font(obj_layer.font);

						if (u_id === 1)
							draw_text(5, obj_img, i_left, i_top, obj_layer.str_text);
						else
							fnc_draw_text(obj_img, obj_layer.str_text, i_left, i_top,
								(obj_layer.u_color === void) ? get_text_color(u_id) : obj_layer.u_color,
								(obj_layer.u_color_strong === void) ? get_text_color_strong(u_id) : obj_layer.u_color_strong,
								(obj_layer.u_light === void) ? get_text_light(u_id) : obj_layer.u_light,
								(obj_layer.u_light_strong === void) ? get_text_light_strong(u_id) : obj_layer.u_light_strong,
								(obj_layer.u_opacity === void) ? get_text_opacity(u_id) : obj_layer.u_opacity);
					}
			}

		function on_get_image_cookie(obj_layer, u_width, u_height)
			{
				return super.on_get_image_cookie(*) +
					"_%X_%X_%X_%X_%X".sprintf(
					obj_layer.u_color, obj_layer.u_color_strong,
					obj_layer.u_light, obj_layer.u_light_strong,
					obj_layer.u_opacity);
			}

		function on_get_id(b_focused, b_enter, b_pushed, b_enabled, u_state=0)
			{
				var u_id = super.on_get_id(*);

				if (u_id == 5)
					return 1;

				return 0;
			}

		property str_specify
			{
				getter
					{
						return "label";
					}
			}
	}

class Kappa_application_label_image_producer extends Kappa_label_image_producer
	{
		var m_aobj_img_src;

		function Kappa_application_label_image_producer()
			{
				super.Kappa_label_image_producer();
				{
					au_text_color[0] = 0xffc0ffc0;
				}
			}

		function finalize()
			{
				super.finalize(*);
			}
	}

class Kappa_application_label extends Kappa_image_label
	{
		function Kappa_application_label(window, parent, b_notify = false)
			{
				super.Kappa_image_label(window, parent, b_notify, g_obj_kappa_share_image.obj_label_image_producer);
			}

		function finalize()
			{
				super.finalize(*);
			}
	}

class Kappa_image_static_label_interface extends Kappa_image_label_interface
	{
		function Kappa_image_static_label_interface(obj_super_layer, b_notify, obj_proucer)
			{
				Kappa_image_label_interface(obj_super_layer, b_notify, obj_proucer);
			}

		function finalize()
			{
				super.finalize(*);
			}
	}

class Kappa_image_static_label extends KAGLayer, Kappa_image_static_label_interface
	{
		function Kappa_image_static_label(window, parent, b_notify=false, obj_proucer)
			{
				KAGLayer(window, parent);
				Kappa_image_static_label_interface(global.KAGLayer, b_notify, obj_proucer);
			}

		function finalize()
			{
				global.Kappa_image_static_label_interface.finalize(*);
				global.KAGLayer.finalize(*);
			}

		function assign(obj_src)
			{
				global.KAGLayer.assign(*);
				global.Kappa_image_static_label_interface.assign(*);
			}
	}

class Kappa_static_label_image_producer extends Kappa_label_image_producer
	{
		function Kappa_static_label_image_producer()
			{
				super.Kappa_label_image_producer();
				m_u_draws = 1;
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_get_id(b_focused, b_enter, b_pushed, b_enabled, u_state=0)
			{
				return 0;
			}

		property str_specify
			{
				getter
					{
						return "static_label";
					}
			}
	}

class Kappa_application_static_label_image_producer extends Kappa_static_label_image_producer
	{
		var m_aobj_img_src;

		function Kappa_application_static_label_image_producer()
			{
				super.Kappa_static_label_image_producer();
				{
					au_text_color[0] = /*0xffc0ffc0*/0xffffffff;
				}
			}

		function finalize()
			{
				super.finalize(*);
			}
	}

class Kappa_application_static_label extends Kappa_image_static_label
	{
		function Kappa_application_static_label(window, parent, b_notify = false)
			{
				super.Kappa_image_static_label(window, parent, b_notify, g_obj_kappa_share_image.obj_static_label_image_producer);
			}

		function finalize()
			{
				super.finalize(*);
			}
	}

class Kappa_image_widget_label_interface extends Kappa_label_interface, Kappa_widget_draw_image_interface
	{
		var m_obj_ref_producer;
		var m_u_current_id = 0;

		function Kappa_image_widget_label_interface(obj_super_layer, b_notify = false, obj_proucer, obj_ref_producer)
			{
				Kappa_label_interface(obj_super_layer, b_notify);
				Kappa_widget_draw_image_interface(global.Kappa_label_interface, obj_proucer);
				m_obj_ref_producer = obj_ref_producer;
			}

		function finalize()
			{
				global.Kappa_label_interface.finalize(*);
				global.Kappa_widget_draw_image_interface.finalize(*);
			}

		function set_id(u_id)
			{
				if (m_u_current_id != u_id)
					{
						m_u_current_id = u_id;
						update();
					}
			}

		function on_set_option(elm)
			{
				global.Kappa_label_interface.on_set_option(*);
				global.Kappa_widget_draw_image_interface.on_set_option(*);
			}

		function on_serialize(b_out, str_spec, f)
			{
				global.Kappa_label_interface.on_serialize(*);
				global.Kappa_widget_draw_image_interface.on_serialize(*);
			}

		function on_get_id()
			{
				return m_u_current_id;
			}

		property obj_ref_producer
			{
				setter(param)
					{
						if (m_obj_ref_producer != param)
							{
								m_obj_ref_producer = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return m_obj_ref_producer;
					}
			}
	}

class Kappa_image_widget_label extends KAGLayer, Kappa_image_widget_label_interface
	{
		function Kappa_image_widget_label(window, parent, b_notify = false, obj_proucer, obj_ref_producer)
			{
				KAGLayer(window, parent);
				Kappa_image_widget_label_interface(global.KAGLayer, b_notify, obj_proucer, obj_ref_producer);
			}

		function finalize()
			{
				global.Kappa_image_widget_label_interface.finalize(*);
				global.KAGLayer.finalize(*);
			}

		function assign(obj_src)
			{
				global.KAGLayer.assign(*);
				global.Kappa_image_widget_label_interface.assign(*);
			}
	}

class Kappa_widget_label_image_producer extends Kappa_widget_image_producer
	{
		function Kappa_widget_label_image_producer()
			{
				super.Kappa_widget_image_producer();
				{
					var i;
					var u_images           = this.u_images;
					var aobj_virtual_frame = this.aobj_virtual_frame;

					for (i = 0; i < u_images; i++)
						aobj_virtual_frame[i].set(0.0, 0.0, 1.0, 1.0, 0.0, 0.0);
				}
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_paint_text(u_id, obj_img, i_left, i_top, u_width, u_height, obj_layer)
			{
				if (obj_layer.str_text != "")
					{
						i_left += Math.ceil((u_width  - obj_layer.font.getTextWidth(obj_layer.str_text))  / 2);
						i_top  += Math.ceil((u_height - obj_layer.font.getTextHeight(obj_layer.str_text)) / 2);

						obj_img.assign_font(obj_layer.font);
						obj_layer.obj_ref_producer.draw_text(u_id, obj_img, i_left, i_top, obj_layer.str_text);
					}
			}

		function on_get_image_cookie(obj_layer, u_width, u_height)
			{
				return super.on_get_image_cookie(*) + "_" +
					obj_layer.obj_ref_producer.str_specify;
			}

		property str_specify
			{
				getter
					{
						return "widget_label";
					}
			}
	}

class Kappa_application_widget_label_image_producer extends Kappa_widget_label_image_producer
	{
		var m_aobj_img_src;

		function Kappa_application_widget_label_image_producer()
			{
				super.Kappa_widget_label_image_producer();
				{
					au_text_color[0] = 0xffffffff;
				}
			}

		function finalize()
			{
				super.finalize(*);
			}
	}

class Kappa_application_widget_label extends Kappa_image_widget_label
	{
		function Kappa_application_widget_label(window, parent, b_notify = false, obj_ref_priducer)
			{
				super.Kappa_image_widget_label(window, parent, b_notify, g_obj_kappa_share_image.obj_widget_label_image_producer, obj_ref_priducer);
			}

		function finalize()
			{
				super.finalize(*);
			}
	}


@endscript


@return
