@iscript

function fnc_get_message_layer_no(str_spec)
	{
		return g_du_message_layer_no[str_spec];
	}

function fnc_get_message_layer_option_index_by_spec(str_spec)
	{
		return g_cdu_message_layer_option_index[str_spec];
	}

function fnc_get_message_layer_option_index(u_message_layer_no)
	{
		return g_cdu_message_layer_option_index[g_astr_message_layer_spec[u_message_layer_no]];
	}

function fnc_init_message_layer(obj_message_layer)
	{
		var d_config  = g_cdd_message_layer_config[g_astr_message_layer_spec[obj_message_layer.id]];
		var d_default = g_cd_message_layer_default_config;

		obj_message_layer.setPosition
			(%[
				"left"    => (d_config.i_left            !== void) ? (string)d_config.i_left            : (string)d_default.i_left,
				"top"     => (d_config.i_top             !== void) ? (string)d_config.i_top             : (string)d_default.i_top,
				"width"   => (d_config.u_width           !== void) ? (string)d_config.u_width           : (string)d_default.u_width,
				"height"  => (d_config.u_height          !== void) ? (string)d_config.u_height          : (string)d_default.u_height,
				"color"   => (d_config.u_color           !== void) ? (string)d_config.u_color           : (string)d_default.u_color,
				"opacity" => (d_config.u_opacity         !== void) ? (string)d_config.u_opacity         : (string)d_default.u_opacity,
				"frame"   => (d_config.str_image_storage !== void) ? (string)d_config.str_image_storage : (string)d_default.str_image_storage
			]);

		obj_message_layer.absolute = (d_config.u_absolute !== void) ? d_config.u_absolute : d_default.u_absolute;
	}

function fnc_overrride_message_layer_function(obj_message_layer)
	{
		var d_config  = g_cdd_message_layer_config[g_astr_message_layer_spec[obj_message_layer.id]];
		var d_default = g_cd_message_layer_default_config;

		obj_message_layer.showBreakGlyph = function(glyphobj, storage, key)
			{
				var d_config  = g_cdd_message_layer_config[g_astr_message_layer_spec[id]];
				var d_default = g_cd_message_layer_default_config;

				if ((d_config.b_show_glyph !== void) ? d_config.b_show_glyph : d_default.b_show_glyph)
					global.MessageLayer.showBreakGlyph(*);

			} incontextof obj_message_layer;

		obj_message_layer.onMouseDown = function(i_x, i_y, button, u_shift)
			{
				lastMouseDownX = i_x;
				lastMouseDownY = i_y;

				internalOnMouseDown(i_x - imageLeft, i_y - imageTop, button);

				if(button == mbRight)
					kag.onRightClickMenuItemClick();

				global.KAGLayer.onMouseDown(*);

			} incontextof obj_message_layer;

		obj_message_layer.setHiddenStateByUser = function(b)
			{
				var d_config  = g_cdd_message_layer_config[g_astr_message_layer_spec[id]];
				var d_default = g_cd_message_layer_default_config;

				if ((d_config.b_auto_hide !== void) ? d_config.b_auto_hide : d_default.b_auto_hide)
					global.MessageLayer.setHiddenStateByUser(*);

			} incontextof obj_message_layer;
	}

/*
{
	var i;
	var aobj_message;
	var u_messages;

	aobj_message = kag.fore.messages;
	u_messages = aobj_message.count;

	for (i = 0; i < u_messages; i++)
		{
			fnc_overrride_message_layer_function(aobj_message[i]);
			fnc_init_message_layer(aobj_message[i]);
		}

	aobj_message = kag.back.messages;
	u_messages = aobj_message.count;

	for (i = 0; i < u_messages; i++)
		{
			fnc_overrride_message_layer_function(aobj_message[i]);
			fnc_init_message_layer(aobj_message[i]);
		}
}
*/

function fnc_clear_message_layer(obj_message_layer)
	{
		obj_message_layer.clear();
		return;
	}


function __lfnc_init_message_layer_option(u_opt_idx)
	{
	}

function fnc_init_message_layers_option()
	{
		var i;

		for (i = 0; i < 4; i++)
			__lfnc_init_message_layer_option(i);
	}

function fnc_init_message_layer_option_by_spec(str_spec)
	{
		__lfnc_init_message_layer_option(fnc_get_message_layer_option_index_by_spec(str_spec));
	}

function fnc_copy_message_layer(obj_src_message_layer, obj_dst_message_layer)
	{
		kag.updateBeforeCh = 1;
		obj_dst_message_layer.assign(obj_src_message_layer);
	}

function fnc_store_message_layer(f, elm)
	{
		if (f.du_message_layer_no === void)
			f.du_message_layer_no = %[];

		(Dictionary.assign incontextof f.du_message_layer_no)(g_du_message_layer_no) if (f.du_message_layer_no);

		if (f.astr_message_layer_spec === void)
			f.astr_message_layer_spec = [];

		f.astr_message_layer_spec.assign(g_astr_message_layer_spec);
	}

function fnc_restore_message_layer(f, clear, elm)
	{
		var i;
		var u_message_layers = kag.numMessageLayers;
		var obj_fore_message_layer;
		var obj_back_message_layer;

		(Dictionary.assign incontextof g_du_message_layer_no)(f.du_message_layer_no);
		g_astr_message_layer_spec.assign(f.astr_message_layer_spec);

		with (kag)
			{
				for (i = 0; i < u_message_layers; i++)
					{
						obj_fore_message_layer = .fore.messages[i];
						obj_back_message_layer = .back.messages[i];
						fnc_overrride_message_layer_function(obj_fore_message_layer);
						fnc_overrride_message_layer_function(obj_back_message_layer);
						obj_fore_message_layer.clear();
						obj_back_message_layer.clear();
					}
			}
	}

function fnc_alloc_message_layer_by_spec(str_message_layer)
	{
		var u_message_layer_no = g_du_message_layer_no[str_message_layer];

		if (u_message_layer_no === void)
			{
				with (kag)
					{
						var obj_fore_message_layer;
						var obj_back_message_layer;

						u_message_layer_no = kag.numMessageLayers;
//dm("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
//dm("!!!!!!! APPEND message_layer[%d] = \"%s\" ---- %d -> %d".sprintf(u_message_layer_no, str_message_layer, kag.numMessageLayers, kag.numMessageLayers + 1));
//dm("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");

						obj_fore_message_layer = new MessageLayer(kag, .fore.base, "\bZ[WC" + u_message_layer_no, u_message_layer_no, true);
						obj_back_message_layer = new MessageLayer(kag, .back.base, "bZ[WC" + u_message_layer_no, u_message_layer_no, true);

						.fore.messages[u_message_layer_no] = obj_fore_message_layer;
						.back.messages[u_message_layer_no] = obj_back_message_layer;
						g_astr_message_layer_spec[u_message_layer_no] = str_message_layer;
						obj_fore_message_layer.setCompLayer(obj_back_message_layer);
						obj_back_message_layer.setCompLayer(obj_fore_message_layer);
						fnc_overrride_message_layer_function(obj_fore_message_layer);
						fnc_overrride_message_layer_function(obj_back_message_layer);
						fnc_init_message_layer(obj_fore_message_layer);
						fnc_init_message_layer(obj_back_message_layer);
						fnc_clear_message_layer(obj_fore_message_layer);
						fnc_clear_message_layer(obj_back_message_layer);
						g_du_message_layer_no[str_message_layer] = u_message_layer_no;
						kag.numMessageLayers++;
						.fore.messages.count = kag.numMessageLayers;
						.back.messages.count = kag.numMessageLayers;
//fnc_dump_message_layers_map();
					}
			}

		return u_message_layer_no;
	}

function __lfnc_remove_message_layer(u_message_layer_no, str_spec)
	{
		with (kag)
			{
				var i;
				var u_message_layers;

//dm("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
//dm("!!!!!!! REMOVE message_layer[%d] = \"%s\" ---- %d -> %d".sprintf(u_message_layer_no, str_spec, kag.numMessageLayers, kag.numMessageLayers - 1));
//dm("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
//dm(Scripts.getTraceString());
				fnc_clear_record_message_tag(str_spec);

				g_du_message_layer_no[str_spec] = void;

				if ((.current == .fore.messages[u_message_layer_no]) || (.current == .fore.messages[u_message_layer_no]))
					{
						if (u_message_layer_no)
							{
								.current = (.currentPage ? .back : .fore).messages[0];
								kag.currentNum = 0;
							}
						else
							{
								.current = (.currentPage ? .back : .fore).messages[1];
								kag.currentNum = 0;
							}
					}
				else
					{
						u_message_layers = kag.numMessageLayers;

						for (i = u_message_layer_no + 1; i < u_message_layers; i++)
							{
								if ((.current == .fore.messages[i]) || (.current == .back.messages[i]))
									{
										kag.currentNum--;
										break;
									}
							}
					}

				invalidate .fore.messages[u_message_layer_no];
				invalidate .back.messages[u_message_layer_no];
				.fore.messages.erase(u_message_layer_no);
				.back.messages.erase(u_message_layer_no);
				g_astr_message_layer_spec.erase(u_message_layer_no);

				kag.numMessageLayers--;
				u_message_layers = kag.numMessageLayers;

				for (i = u_message_layer_no; i < u_message_layers; i++)
					{
//dm("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
//dm("!!!!!!! MOVE message_layer[%d] -> [%d] = \"%s\"".sprintf(g_du_message_layer_no[g_astr_message_layer_spec[i]], i, g_astr_message_layer_spec[i]));
//dm("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
						g_du_message_layer_no[g_astr_message_layer_spec[i]] = i;
						.fore.messages[i].id = i;
						.fore.messages[i].name = "\bZ[WC" + i;
						.back.messages[i].id = i;
						.back.messages[i].name = "bZ[WC" + i;
					}

				.fore.messages.count = u_message_layers;
				.back.messages.count = u_message_layers;
//fnc_dump_message_layers_map();
			}
	}

function fnc_remove_message_layer_by_spec(str_spec)
	{
		if (kag.numMessageLayers == 1)
			return;
		else
			{
				var u_message_layer_no = g_du_message_layer_no[str_spec];

				if (u_message_layer_no === void)
					return;
				__lfnc_remove_message_layer(u_message_layer_no, str_spec);
			}
	}

function fnc_remove_message_layer(u_message_layer_no)
	{
		if (kag.numMessageLayers == 1)
			return;

		__lfnc_remove_message_layer(u_message_layer_no, g_astr_message_layer_spec[u_message_layer_no]);
	}

function fnc_shallow_cleanup_message_layer(u_message_layer_no)
	{
		if (kag.numMessageLayers == 1)
			return;

		with (kag)
			{
				var obj_fore_message_layer = .fore.messages[u_message_layer_no];
				var obj_back_message_layer = .back.messages[u_message_layer_no];
				var u_opt_idx = fnc_get_message_layer_option_index(u_message_layer_no);

				if (!obj_fore_message_layer.visible || !obj_back_message_layer.visible)
						fnc_remove_message_layer(u_message_layer_no);
			}
	}

function fnc_shallow_cleanup_message_layers()
	{
		if (kag.numMessageLayers == 1)
			return;
		with (kag)
			{
				var i;
				var obj_fore_message_layer;
				var obj_back_message_layer;

				for (i = 0; i < kag.numMessageLayers; i++)
					{
						obj_fore_message_layer = .fore.messages[i];
						obj_back_message_layer = .back.messages[i];

						if (!obj_fore_message_layer.visible || !obj_back_message_layer.visible)
							{
//dm("obj_fore_message_layer[%d].visible = %d".sprintf(i, obj_fore_message_layer.visible));
//dm("obj_back_message_layer[%d].visible = %d".sprintf(i, obj_back_message_layer.visible));
								fnc_remove_message_layer(i);
								if (kag.numMessageLayers == 1)
									break;
								i--;
							}
					}
			}
	}

function fnc_deep_cleanup_message_layers()
	{
		if (kag.numMessageLayers == 1)
			return;
		with (kag)
			{
				var i;
				var u_opt_idx;
				var obj_fore_message_layer;
				var obj_back_message_layer;
				var str_spec;

				for (i = 0; i < kag.numMessageLayers; i++)
					{
						str_spec = g_astr_message_layer_spec[i];
						obj_fore_message_layer = .fore.messages[i];
						obj_back_message_layer = .back.messages[i];
						u_opt_idx = fnc_get_message_layer_option_index_by_spec(str_spec);

						if (fnc_is_invisible(obj_fore_message_layer))
							{
								fnc_remove_message_layer(i);
								if (kag.numMessageLayers == 1)
									break;
								i--;
							}
						else
							{
								obj_back_message_layer.visible = false;
								fnc_clear_message_layer(obj_back_message_layer);
							}
					}
			}

		fnc_init_message_layers_option();
	}

function fnc_dump_message_layer_map(u_message_layer_no)
	{
		var obj_fore_message_layer = kag.fore.messages[u_message_layer_no];
		var obj_back_message_layer = kag.back.messages[u_message_layer_no];

		dm("message_layer[%d] = \"%s\" => fore id=%d name=%s; back id=%d name=%s;".sprintf(
			g_du_message_layer_no[g_astr_message_layer_spec[u_message_layer_no]],
			g_astr_message_layer_spec[u_message_layer_no],
			obj_fore_message_layer.id, obj_fore_message_layer.name,
			obj_back_message_layer.id, obj_back_message_layer.name));
	}

function fnc_dump_message_layers_map()
	{
		var i;
		var u_message_layers = kag.numMessageLayers;
		dm("MESSAGE LAYER MAP (Total = %d)================================================".sprintf(u_message_layers));
		for (i = 0; i < u_message_layers; i++)
			fnc_dump_message_layer_map(i);
		dm("======================================================================");
	}

function fnc_prepare_fi_message_layer(str_layer_spec)
	{
		var u_message_layer_no = fnc_alloc_message_layer_by_spec(str_layer_spec);
		kag.back.messages[u_message_layer_no].visible = true;
		return u_message_layer_no;
	}

function fnc_prepare_fo_message_layer(str_layer_spec)
	{
		var u_message_layer_no = g_du_message_layer_no[str_layer_spec];

		if (u_message_layer_no === void)
			return;

		kag.back.messages[u_message_layer_no].visible = false;
	}

function fnc_ci_message_layer(str_layer_spec)
	{
		var u_message_layer_no = fnc_prepare_fi_message_layer(str_layer_spec);
		kag.fore.messages[u_message_layer_no].assign(kag.back.messages[u_message_layer_no]);
	}

function fnc_co_message_layer(str_layer_spec)
	{
		var u_message_layer_no = g_du_message_layer_no[str_layer_spec];

		if (u_message_layer_no === void)
			return;

		if (kag.numMessageLayers == 1)
			{
				kag.fore.message[u_message_layer_no].visible = false;
				kag.back.message[u_message_layer_no].visible = false;
			}
		else
			{
				fnc_remove_message_layer_by_spec(str_layer_spec);
			}
	}

kag.tagHandlers.setMessageLayerHiddenState = function(b)
	{
		var i;
		var aobj_layers;
		var u_layers;

		u_layers = kag.numMessageLayers;
		aobj_layers = fore.messages;

		for(i = 0; i < u_layers; i++)
			{
//g_astr_message_layer_spec[obj_message_layer.id]
				aobj_layers[i].setHiddenStateByUser(b);
			}

		u_layers = kag.numCharacterLayers;
		aobj_layers = fore.layers;

		for(i = 0; i < u_layers; i++)
			aobj_layers[i].setHiddenStateByUser(b);

		kag.forEachEventHook(
			"onMessageHiddenStateChanged",
			function(handler, f) {handler(f.hidden);} incontextof kag,
			%["hidden" => b]);
	} incontextof kag;

kag.tagHandlers.prepare_fi_message_layer = function(elm)
	{
		fnc_prepare_fi_message_layer(elm.layer_spec);
		return 0;
	} incontextof kag;

kag.tagHandlers.prepare_fo_message_layer = function(elm)
	{
		fnc_prepare_fo_message_layer(elm.layer_spec);
		return 0;
	} incontextof kag;

kag.tagHandlers.ci_message_layer = function(elm)
	{
		fnc_ci_message_layer(elm.layer_spec);
		return 0;
	} incontextof kag;

kag.tagHandlers.co_message_layer = function(elm)
	{
		fnc_co_message_layer(elm.layer_spec);
		return 0;
	} incontextof kag;


kag.tagHandlers.current_ex = function(elm)
	{
		var u_message_layer_no = g_du_message_layer_no[elm.layer_spec];

		if (u_message_layer_no === void)
			{
				dm("WARNMG : Message Layer is None -> " + elm.layer_spec);
				return 0;
			}

		elm.layer = "message" + g_du_message_layer_no[elm.layer_spec];
		return tagHandlers.current(*);
	} incontextof kag;

kag.tagHandlers.position_ex = function(elm)
	{
		var u_message_layer_no = g_du_message_layer_no[elm.layer_spec];

		if (u_message_layer_no === void)
			{
				dm("WARNMG : Message Layer is None -> " + elm.layer_spec);
				return 0;
			}

		elm.layer = "message" + g_du_message_layer_no[elm.layer_spec];
		return tagHandlers.position(*);
	} incontextof kag;

kag.tagHandlers.move_message_layer = function(elm)
	{
		var u_message_layer_no = g_du_message_layer_no[elm.layer_spec];

		if (u_message_layer_no === void)
			{
				dm("WARNMG : Message Layer is None -> " + elm.layer_spec);
				return 0;
			}

		elm.layer = "message" + g_du_message_layer_no[elm.layer_spec];
		return tagHandlers.move(*);
	} incontextof kag;

function fnc_get_fore_message_layer_by_spec(str_spec)
	{
		var u_message_layer_no = g_du_message_layer_no[str_spec];

		if (u_message_layer_no === void)
			return void;

		return kag.fore.messages[u_message_layer_no];
	}

function fnc_get_back_message_layer_by_spec(str_spec)
	{
		var u_message_layer_no = g_du_message_layer_no[str_spec];

		if (u_message_layer_no === void)
			return void;

		return kag.back.messages[u_message_layer_no];
	}

@endscript


@return
