@iscript


class Kappa_operation_procedure extends Kappa_object_interface
	{
		var m_b_ask;
		var m_dstr_show_elm;
		var m_dstr_hide_elm;
		var m_d_param;
		var m_obj_dialog;
		var m_obj_trigger;

		function Kappa_operation_procedure(b_ask=false, d_param)
			{
				super.Kappa_object_interface();

				if (d_param !== void)
					{
						m_d_param = %[];

						(Dictionary.assign incontextof m_d_param)(d_param);

						if (d_param.dstr_show_elm !== void)
							{
								m_dstr_show_elm = %[];
								(Dictionary.assign incontextof m_dstr_show_elm)(d_param.dstr_show_elm) if (d_param.dstr_show_elm !== void);
							}

						if (d_param.dstr_hide_elm !== void)
							{
								m_dstr_hide_elm = %[];
								(Dictionary.assign incontextof m_dstr_hide_elm)(d_param.dstr_hide_elm) if (d_param.dstr_hide_elm !== void);
							}
					}

				m_b_ask = b_ask;
			}

		function finalize()
			{
				invalidate m_dstr_show_elm if (m_dstr_show_elm !== void);
				invalidate m_dstr_hide_elm if (m_dstr_hide_elm !== void);
				invalidate m_d_param if (m_d_param !== void);
				super.finalize(*);
			}

		function begin_procedure()
			{
				var b_confirm;
				var b_warning;
				var d_param;

				if (!m_b_ask)
					{
						skip_procedure();
						return;
					}

				b_confirm = on_is_confirm();
				b_warning = on_is_warning();

				if (!b_confirm && !b_warning)
					{
						skip_procedure();
						return;
					}

				d_param = %[];
				d_param.f_on_ok = on_ok;
				d_param.f_on_cancel = on_cancel;
				d_param.f_on_end_show_transition = on_end_show_transition;
				d_param.f_on_end_hide_transition = on_end_hide_transition;
				d_param.u_bookmark_num_1 = on_get_bookmark_num_1();
				d_param.u_bookmark_num_2 = on_get_bookmark_num_2();
				d_param.str_bookmark_delimiter = on_get_bookmark_delimiter();

				if (b_confirm)
					d_param.str_message = on_get_confirm_message();

				if (b_warning)
					{
						if (b_confirm)
							d_param.str_message += "\n\n";
						d_param.str_message += "yxz" + on_get_warning_message();
					}

				m_obj_dialog = new Kappa_message_dialog(kag, kag.fore.base, false, d_param);
				invalidate d_param;
				m_obj_dialog.show(m_dstr_show_elm, void);
			}

		function skip_procedure()
			{
				on_end_show_transition(void);
				on_ok(void, void);
				on_end_hide_transition(void) if (this isvalid);
			}

		function on_ok(obj_dialog, cookie)
			{
				on_commit();

				if ((m_d_param !== void) && (m_d_param.f_on_ok !== void) && !m_d_param.f_on_ok(obj_dialog, m_d_param.cookie))
					{
						invalidate this;
						return false;
					}
				else
					{
						return true;
					}
			}

		function on_cancel(obj_dialog, cookie)
			{
				if ((m_d_param !== void) && (m_d_param.f_on_cancel !== void) && !m_d_param.f_on_cancel(obj_dialog, m_d_param.cookie))
					{
						invalidate this;
						return false;
					}
				else
					{
						return true;
					}
			}

		function on_end_show_transition(obj_dialog, cookie)
			{
				if (m_d_param !== void)
					m_d_param.f_on_end_show_transition(m_obj_dialog, m_d_param.cookie) if (m_d_param.f_on_end_show_transition !== void);
			}

		function on_end_hide_transition(obj_dialog, cookie)
			{
				if (!(this isvalid))
					return;

				if (m_d_param !== void)
					m_d_param.f_on_end_hide_transition(m_obj_dialog, m_d_param.cookie) if (m_d_param.f_on_end_hide_transition !== void);
				m_obj_trigger = new AsyncTrigger(__destroy, "");
				m_obj_trigger.trigger();
			}

		function __destroy()
			{
				if (!(this isvalid))
					return;

				var str_trigger = on_get_trigger();
				invalidate m_obj_trigger if ((m_obj_trigger !== void) && (m_obj_trigger isvalid));
				m_obj_trigger = void;
				kag.trigger(str_trigger) if (str_trigger !== void);
				invalidate this;
			}

		function on_get_trigger()
			{
				return void;
			}

		function on_is_confirm()
			{
				return false;
			}

		function on_is_warning()
			{
				return false;
			}

		function on_get_confirm_message()
			{
				return void;
			}

		function on_get_warning_message()
			{
				return void;
			}

		function on_get_bookmark_num_1()
			{
				return void;
			}

		function on_get_bookmark_num_2()
			{
				return void;
			}

		function on_get_bookmark_delimiter()
			{
				return void;
			}

		function on_commit()
			{
			}
	}


class Kappa_bookmark_load_procedure extends Kappa_operation_procedure
	{
		var m_u_num;

		function Kappa_bookmark_load_procedure(u_num=0, b_ask=false, d_param)
			{
				super.Kappa_operation_procedure(b_ask, d_param);
				m_u_num = u_num;
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_get_trigger()
			{
				return "release_modal_load";
			}

		function on_is_confirm()
			{
				if (!m_u_num)
					return sf.b_confirm_operation_qload;
				else if (m_u_num == 997)
					return sf.b_confirm_operation_back_to_title;
				else
					return sf.b_confirm_operation_load;
			}

		function on_get_confirm_message()
			{
				if (m_u_num == 997)
					return "^Cgɂǂ܂B";
				else
					return "%s ̂Ân߂܂B".sprintf(fnc_get_bookmark_item_name(m_u_num, 1));
			}

		function on_get_bookmark_num_1()
			{
				return m_u_num;
			}

		function on_commit()
			{
				fnc_load_bookmark_item_by_num(m_u_num);
			}
	}

class Kappa_bookmark_save_procedure extends Kappa_operation_procedure
	{
		var m_u_num;

		function Kappa_bookmark_save_procedure(u_num=0, b_ask=false, d_param)
			{
				super.Kappa_operation_procedure(b_ask, d_param);
				m_u_num = u_num;
				{
					var b_is_modal = g_obj_kappa_system.b_system_menu_is_modal;
					var obj_layer = g_obj_kappa_system.obj_system_menu_layer;

					if (b_is_modal)
						obj_layer.visible = false;

					kag.tagHandlers.locksnapshot(%[]);

					if (b_is_modal)
						obj_layer.visible = true;
				}
			}

		function finalize()
			{
				kag.tagHandlers.unlocksnapshot(%[]);
				super.finalize(*);
			}

		function on_get_trigger()
			{
				return "release_modal_save";
			}

		function on_is_confirm()
			{
				if (!m_u_num)
					return sf.b_confirm_operation_qsave;
				else
					return sf.b_confirm_operation_save;
			}

		function on_is_warning()
			{
				if (!m_u_num)
					return (sf.b_confirm_overwrite_qsave && fnc_is_existed_bookmark_item_by_num(m_u_num));
				else
					return (sf.b_confirm_overwrite_save && fnc_is_existed_bookmark_item_by_num(m_u_num));
			}

		function on_get_confirm_message()
			{
				return "%s ɁA܂ł̓eۑ܂B".sprintf(fnc_get_bookmark_item_name(m_u_num, 2));
			}

		function on_get_warning_message()
			{
				return "%s ɂ́AȑOɕۑe݂܂BۑƏ㏑܂B".sprintf(fnc_get_bookmark_item_name(m_u_num, 2));
			}

		function on_get_bookmark_num_1()
			{
				return m_u_num;
			}

		function on_get_bookmark_num_2()
			{
				return 0xffffffff;
			}

		function on_get_bookmark_delimiter()
			{
				return "";
			}

		function on_commit()
			{
				fnc_save_bookmark_item_by_num(m_u_num);
			}
	}

class Kappa_bookmark_remove_procedure extends Kappa_operation_procedure
	{
		var m_u_num;

		function Kappa_bookmark_remove_procedure(u_num=0, b_ask=false, d_param)
			{
				super.Kappa_operation_procedure(b_ask, d_param);
				m_u_num = u_num;
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_get_trigger()
			{
				return "release_modal_remove";
			}

		function on_is_confirm()
			{
				return sf.b_confirm_operation_remove;
			}

		function on_get_confirm_message()
			{
				return "%s ɕۑĂe폜܂B".sprintf(fnc_get_bookmark_item_name(m_u_num, 2));
			}

		function on_get_bookmark_num_1()
			{
				return m_u_num;
			}

		function on_commit()
			{
				fnc_remove_bookmark_item_by_num(m_u_num);
			}
	}

class Kappa_bookmark_move_procedure extends Kappa_operation_procedure
	{
		var m_u_src_num;
		var m_u_dst_num;

		function Kappa_bookmark_move_procedure(u_src_num, u_dst_num, b_ask=false, d_param)
			{
				super.Kappa_operation_procedure(b_ask, d_param);
				m_u_src_num = u_src_num;
				m_u_dst_num = u_dst_num;
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_get_trigger()
			{
				return "release_modal_move";
			}

		function on_is_confirm()
			{
				return sf.b_confirm_operation_move;
			}

		function on_is_warning()
			{
				return (sf.b_confirm_overwrite_move && fnc_is_existed_bookmark_item_by_num(m_u_dst_num));
			}

		function on_get_confirm_message()
			{
				return "%s  %s ؂ē\t܂B".sprintf(
					fnc_get_bookmark_item_name(m_u_dst_num, 2),
					fnc_get_bookmark_item_name(m_u_src_num, 2));
			}

		function on_get_warning_message()
			{
				return "%s ɂ́AȑOɕۑe݂܂B\tƏ㏑܂B".sprintf(
					fnc_get_bookmark_item_name(m_u_dst_num, 2));
			}

		function on_get_bookmark_num_1()
			{
				return m_u_dst_num;
			}

		function on_get_bookmark_num_2()
			{
				return m_u_src_num;
			}

		function on_get_bookmark_delimiter()
			{
				return "";
			}

		function on_commit()
			{
				fnc_move_bookmark_item_by_num(m_u_src_num, m_u_dst_num);
			}
	}


class Kappa_bookmark_copy_procedure extends Kappa_operation_procedure
	{
		var m_u_src_num;
		var m_u_dst_num;

		function Kappa_bookmark_copy_procedure(u_src_num, u_dst_num, b_ask=false, d_param)
			{
				super.Kappa_operation_procedure(b_ask, d_param);
				m_u_src_num = u_src_num;
				m_u_dst_num = u_dst_num;
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_get_trigger()
			{
				return "release_modal_copy";
			}

		function on_is_confirm()
			{
				return sf.b_confirm_operation_copy;
			}

		function on_is_warning()
			{
				return (sf.b_confirm_overwrite_copy && fnc_is_existed_bookmark_item_by_num(m_u_dst_num));
			}

		function on_get_confirm_message()
			{
				return "%s  %s ̃Rs[ \t܂B".sprintf(
					fnc_get_bookmark_item_name(m_u_dst_num, 2),
					fnc_get_bookmark_item_name(m_u_src_num, 2));
			}

		function on_get_warning_message()
			{
				return "%s ɂ́AȑOɕۑe݂܂B\tƏ㏑܂B".sprintf(
					fnc_get_bookmark_item_name(m_u_dst_num, 2));
			}

		function on_get_bookmark_num_1()
			{
				return m_u_dst_num;
			}

		function on_get_bookmark_num_2()
			{
				return m_u_src_num;
			}

		function on_get_bookmark_delimiter()
			{
				return "";
			}

		function on_commit()
			{
				fnc_copy_bookmark_item_by_num(m_u_src_num, m_u_dst_num);
			}
	}


class Kappa_bookmark_swap_procedure extends Kappa_operation_procedure
	{
		var m_u_num_1;
		var m_u_num_2;

		function Kappa_bookmark_swap_procedure(u_num_1, u_num_2, b_ask=false, d_param)
			{
				super.Kappa_operation_procedure(b_ask, d_param);
				m_u_num_1 = u_num_1;
				m_u_num_2 = u_num_2;
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_get_trigger()
			{
				return "release_modal_swap";
			}

		function on_is_confirm()
			{
				return sf.b_confirm_operation_swap;
			}

		function on_get_confirm_message()
			{
				return "%s  %s ̓eւ܂B".sprintf(
					fnc_get_bookmark_item_name(u_num_1, 2),
					fnc_get_bookmark_item_name(u_num_2, 2));
			}

		function on_get_bookmark_num_1()
			{
				return m_u_num_1;
			}

		function on_get_bookmark_num_2()
			{
				return m_u_num_2;
			}

		function on_get_bookmark_delimiter()
			{
				return "";
			}

		function on_commit()
			{
				fnc_swap_bookmark_item_by_num(m_u_num_1, m_u_num_2);
			}
	}

class Kappa_exit_procedure extends Kappa_operation_procedure
	{
		var m_u_num;
		var b_state = false;

		function Kappa_exit_procedure(b_ask=false, d_param)
			{
				super.Kappa_operation_procedure(b_ask, d_param);
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_ok(obj_dialog, cookie)
			{
				var i;
				var obj_trans;
				kag.fore.base.piledCopy(0, 0, kag.fore.base, 0, 0, kag.scWidth, kag.scHeight);
				kag.back.base.loadImages(%["storage" => "logo_000.jpg"]);


				for (i = kag.fore.layers.count - 1; i >= 0; i--)
					{
						kag.fore.layers[i].visible = false;
						kag.back.layers[i].visible = false;
					}

				for (i = kag.fore.messages.count - 1; i >= 0; i--)
					{
						kag.fore.messages[i].visible = false;
						kag.back.messages[i].visible = false;
					}

				for (i = g_aobj_dialog.count - 1; i >= 0; i--)
					{
						g_aobj_dialog[i].visible = false;
					}

				fnc_deep_cleanup_layers();
				fnc_deep_cleanup_message_layers();

				g_obj_kappa_tray.obj_form_fore_tray.visible = false;
				g_obj_kappa_tray.obj_form_back_tray.visible = false;
				kag.tagHandlers.fo_se(%["buf" => "0"]);
				kag.tagHandlers.fo_se(%["buf" => "1"]);
				kag.tagHandlers.fo_se(%["buf" => "3"]);
				kag.tagHandlers.fo_bgm(%[]);

				g_obj_kappa_system.obj_system_menu_layer.visible = false if (g_obj_kappa_system.b_system_menu_is_modal);
				kag.historyLayer.visible = false;
				kag.historyLayer.m_obj_sht.visible = false if (kag.historyLayer.m_obj_sht !== void);

				obj_trans = new Kappa_transition(
					%["method" => "rotateswap", "time" => "0x400"],
					%["f_on_end_transition" => __lfnc_kappa_exit_procedure_on_end_transition_1]);
				obj_trans.begin_transition();

				invalidate this;
				return false;

			}

		function on_get_trigger()
			{
				return "release_modal_exit";
			}

		function on_is_confirm()
			{
				return sf.b_confirm_operation_exit;
			}

		function on_get_confirm_message()
			{
				return g_cstr_application_name + "I܂B";
			}

		function on_get_bookmark_num_1()
			{
				return 0xfffffffe;
			}
	}

function __lfnc_kappa_exit_procedure_on_end_transition_1(cookie)
	{
		var obj_trans;
		kag.back.base.loadImages(%["storage" => "logo_002.jpg"]);
		obj_trans = new Kappa_transition(
			%["method" => "crossfade", "time" => "0x400"],
			%["f_on_end_transition" => __lfnc_kappa_exit_procedure_on_end_transition_2]);
		obj_trans.begin_transition();
	}

function __lfnc_kappa_exit_procedure_on_end_transition_2(cookie)
	{
		var obj_trans;
		kag.back.base.loadImages(%["storage" => "scene_000.jpg"]);
		obj_trans = new Kappa_transition(
			%["method" => "crossfade", "time" => "0x400"],
			%["f_on_end_transition" => __lfnc_kappa_exit_procedure_on_end_transition_3]);
		obj_trans.begin_transition();
	}

function __lfnc_kappa_exit_procedure_on_end_transition_3(cookie)
	{
		fnc_exit();
	}




@endscript


@return

