@iscript

class Kappa_radio_group extends Kappa_object_interface
	{
		var m_u_index = -1;
		var m_aobj_radio_button = [];
		var m_b_lock = false;

		function Kappa_radio_group(elm)
			{
				super.Kappa_object_interface(*);
			}

		function finalize()
			{
				invalidate m_aobj_radio_button;
				super.finalize(*);
			}

		function __add_button(obj_radio_button)
			{
				m_aobj_radio_button.add(obj_radio_button);

				if (obj_radio_button.u_state)
					{
						if (m_u_index < 0)
							m_u_index = m_aobj_radio_button.count - 1;
						else
							obj_radio_button.u_state = 0;
					}
			}

		function __notify_update_state(obj_sender_radio_button)
			{
				var u_index = m_aobj_radio_button.find(obj_sender_radio_button);

				if ((m_u_index >= 0) && (m_u_index != u_index))
					{
						m_aobj_radio_button[m_u_index].u_state = 0;
					}

				m_u_index = u_index;
			}

		property u_index
			{
				setter(param)
					{
						if (m_b_lock)
							return;

						m_b_lock = true;

						if (m_u_index >= 0)
							m_aobj_radio_button[m_u_index].u_state = 0;

						m_u_index = (int)param;

						if (m_u_index >= 0)
							m_aobj_radio_button[m_u_index].u_state = 1;

						m_b_lock = false;
					}

				getter
					{
						return m_u_index;
					}
			}

		property obj_radio_button
			{
				setter(param)
					{
						if (m_b_lock)
							return;

						m_b_lock = true;

						__notify_update_state(param);

						if (m_u_index >= 0)
							m_aobj_radio_button[m_u_index].u_state = 1;

						m_b_lock = false;
					}

				getter
					{
						if (m_u_index < 0)
							return void;
						else
							return m_aobj_radio_button[m_u_index];
					}
			}
	}

class Kappa_base_radio_button_interface extends Kappa_state_button_interface
	{
		var m_aobj_radio_group = [];

		function Kappa_base_radio_button_interface(elm)
			{
				super.Kappa_state_button_interface(*);
			}

		function finalize()
			{
				invalidate m_aobj_radio_group;
				super.finalize(*);
			}

		function add_group(obj_radio_group)
			{
				m_aobj_radio_group.add(obj_radio_group);
				obj_radio_group.__add_button(this);
			}

		function commit()
			{
				var u_next_state = m_u_state + 1;

				if (u_next_state >= m_u_states)
					u_next_state = 1;

				u_state = u_next_state;
				global.Kappa_button_interface.commit();
			}

		property u_state
			{
				setter(param)
					{
						super.u_state = param;

						if (super.u_state)
							{
								var i;
								var u_radio_groups = m_aobj_radio_group.count;

								for (i = 0; i < u_radio_groups; i++)
									m_aobj_radio_group[i].__notify_update_state(this);
							}

						update();
					}
				getter
					{
						return super.u_state;
					}
			}
	}

class Kappa_image_base_radio_button_interface extends Kappa_base_radio_button_interface, Kappa_widget_draw_image_interface
	{
		function Kappa_image_base_radio_button_interface(obj_super_layer, b_notify, obj_proucer)
			{
				Kappa_base_radio_button_interface(obj_super_layer, b_notify);
				Kappa_widget_draw_image_interface(global.Kappa_base_radio_button_interface, obj_proucer);
			}

		function finalize()
			{
				global.Kappa_base_radio_button_interface.finalize(*);
				global.Kappa_widget_draw_image_interface.finalize(*);
			}

		function on_set_option(elm)
			{
				global.Kappa_base_radio_button_interface.on_set_option(*);
				global.Kappa_widget_draw_image_interface.on_set_option(*);
			}

		function on_serialize(b_out, str_spec, f)
			{
				global.Kappa_base_radio_button_interface.on_serialize(*);
				global.Kappa_widget_draw_image_interface.on_serialize(*);
			}

		function on_get_id()
			{
				return obj_producer.get_id(focused, b_enter, b_commit_down, enabled && nodeEnabled, u_state);
			}
	}

class Kappa_image_base_radio_button extends KAGLayer, Kappa_image_base_radio_button_interface
	{
		function Kappa_image_base_radio_button(window, parent, b_notify=true, obj_proucer)
			{
				KAGLayer(window, parent);
				Kappa_image_base_radio_button_interface(global.KAGLayer, b_notify, obj_proucer);
			}

		function finalize()
			{
				global.Kappa_image_base_radio_button_interface.finalize(*);
				global.KAGLayer.finalize(*);
			}

		function assign(obj_src)
			{
				global.KAGLayer.assign(*);
				global.Kappa_image_base_radio_button_interface.assign(*);
			}
	}

class Kappa_application_2state_base_radio_button extends Kappa_image_base_radio_button
	{
		function Kappa_application_2state_base_radio_button(window, parent, b_notify)
			{
				super.Kappa_image_base_radio_button(window, parent, b_notify, g_obj_kappa_share_image.obj_2state_toggle_button_image_producer);
			}

		function finalize()
			{
				super.finalize(*);
			}

		property height
			{
				setter(param)
					{
						super.height = param;
						u_left_inner_pad = super.height \ 5;
						u_right_inner_pad = super.height \ 5;
					}
				getter
					{
						return super.height;
					}
			}
	}

class Kappa_radio_button_interface extends Kappa_base_radio_button_interface
	{
		function Kappa_radio_button_interface(elm)
			{
				super.Kappa_base_radio_button_interface(*);
			}

		function finalize()
			{
				super.finalize(*);
			}

		function commit()
			{
				if ((u_states <= 2) && u_state)
					return;

				super.commit();
			}

		property u_state
			{
				setter(param)
					{
						super.u_state = param;

						if (u_states <= 2)
							{
								if (super.u_state)
									{
										b_se_off = true;
										cursor = crArrow;
										hitThreshold = 0x100;
									}
								else
									{
										b_se_off = false;
										cursor = crHandPoint;
										hitThreshold = 0x10;
									}
							}
					}
				getter
					{
						return super.u_state;
					}
			}
	}

class Kappa_image_radio_button_interface extends Kappa_radio_button_interface, Kappa_widget_draw_image_interface
	{
		function Kappa_image_radio_button_interface(obj_super_layer, b_notify, obj_proucer)
			{
				Kappa_radio_button_interface(obj_super_layer, b_notify);
				Kappa_widget_draw_image_interface(global.Kappa_radio_button_interface, obj_proucer);
			}

		function finalize()
			{
				global.Kappa_radio_button_interface.finalize(*);
				global.Kappa_widget_draw_image_interface.finalize(*);
			}

		function on_set_option(elm)
			{
				global.Kappa_radio_button_interface.on_set_option(*);
				global.Kappa_widget_draw_image_interface.on_set_option(*);
			}

		function on_serialize(b_out, str_spec, f)
			{
				global.Kappa_radio_button_interface.on_serialize(*);
				global.Kappa_widget_draw_image_interface.on_serialize(*);
			}

		function on_get_id()
			{
				return obj_producer.get_id(focused, b_enter, b_commit_down, enabled && nodeEnabled, u_state);
			}
	}

class Kappa_image_radio_button extends KAGLayer, Kappa_image_radio_button_interface
	{
		function Kappa_image_radio_button(window, parent, b_notify=true, obj_proucer)
			{
				KAGLayer(window, parent);
				Kappa_image_radio_button_interface(global.KAGLayer, b_notify, obj_proucer);
			}

		function finalize()
			{
				global.Kappa_image_radio_button_interface.finalize(*);
				global.KAGLayer.finalize(*);
			}

		function assign(obj_src)
			{
				global.KAGLayer.assign(*);
				global.Kappa_image_radio_button_interface.assign(*);
			}
	}

class Kappa_application_2state_radio_button_image_producer extends Kappa_widget_image_producer
	{
		var m_aobj_img_src;

		function Kappa_application_2state_radio_button_image_producer()
			{
				super.Kappa_widget_image_producer();
				{
					var i;
					var u_images           = this.u_images;
					var aobj_virtual_frame = this.aobj_virtual_frame;

					for (i = 0; i < u_images; i++)
						aobj_virtual_frame[i].set(2 / 256, 0 / 128, 240 / 256, 98 / 128, 0, 0.100);

					aobj_virtual_frame[4].r_left += 12 / 256;
					aobj_virtual_frame[4].r_top  += 12 / 128;

					_set_states(2);

					m_au_text_color[u_draws] = 0xff404000;
					m_au_text_color[u_draws + 1] = 0xffffffb0;
					m_au_text_color[u_draws + 2] = -1 - u_draws;
					m_au_text_color[u_draws + 3] = -2 - u_draws;
					m_au_text_color[u_draws + 4] = -2 - u_draws;
					m_au_image_color[u_draws] = 0xffa0a020;
//					m_au_image_color[0] = 0xff20a020;
					m_au_image_color[4] = -5 - u_draws;
					m_au_text_color[4] = -5 - u_draws;
					fnc_set_array_value(m_au_image_color, -1 - u_draws, u_draws + 1, u_draws - 2);
					fnc_set_object_array_value(aobj_virtual_frame, "r_left", aobj_virtual_frame[4].r_left, u_draws, u_draws);
					fnc_set_object_array_value(aobj_virtual_frame, "r_top", aobj_virtual_frame[4].r_top, u_draws, u_draws);
				}
			}

		function finalize()
			{
				super.finalize(*);
				on_cache_unload();
			}

		function on_cache_load()
			{
				if (m_aobj_img_src === void)
					{
						m_aobj_img_src = [];

						m_aobj_img_src[0] = new Kappa_image();
						m_aobj_img_src[0].load_image("button_00.tlg");

						m_aobj_img_src[1] = new Kappa_image();
						m_aobj_img_src[1].load_image("button_01.tlg");
					}
			}

		function on_cache_unload()
			{
				if (m_aobj_img_src !== void)
					{
						fnc_object_array_free(m_aobj_img_src);
						invalidate m_aobj_img_src;
						m_aobj_img_src = void;
					}
			}

		function on_paint_image(u_id, obj_img, i_left, i_top, u_width, u_height, obj_layer)
			{
				switch (u_id)
					{
						case 4:  // id = 4, push
						case 10: // id = 10, push
						case 6:  // id = 6, normal, focus = false
						case 7:  // id = 7, normal, focus = true
						case 8:  // id = 8, enter, focus = false
						case 9:  // id = 9, enter, focus = true
						case 11: // id = 11, disable
							colored_strech_src_copy(u_id, obj_img, i_left, i_top, u_width, u_height, m_aobj_img_src[1]);
							break;
						case 0:	// id = 0, normal, focus = false
						case 1: // id = 1, normal, focus = true
						case 2: // id = 2, enter, focus = false
						case 3: // id = 3, enter, focus = true
						case 5: // id = 5, disable
							colored_strech_src_copy(u_id, obj_img, i_left, i_top, u_width, u_height, m_aobj_img_src[0]);
							break;
					}

			}

		property aobj_img_src
			{
				getter
					{
						return m_aobj_img_src;
					}
			}

		property str_specify
			{
				getter
					{
						return "radio";
					}
			}
	}


class Kappa_application_2state_radio_button extends Kappa_image_radio_button
	{
		function Kappa_application_2state_radio_button(window, parent, b_notify)
			{
				super.Kappa_image_radio_button(window, parent, b_notify, g_obj_kappa_share_image.obj_2state_radio_button_image_producer);
			}

		function finalize()
			{
				super.finalize(*);
			}

		property height
			{
				setter(param)
					{
						super.height = param;
						u_left_inner_pad = super.height \ 5;
						u_right_inner_pad = super.height \ 5;
					}
				getter
					{
						return super.height;
					}
			}
	}

@endscript

@return

