@iscript

class Kappa_sheet_interface extends Kappa_form_interface
	{
		function Kappa_sheet_interface(obj_super_layer, b_notify=false)
			{
				super.Kappa_form_interface(obj_super_layer, b_notify);
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_hit_test(i_x, i_y, b_hit)
				{
					if(b_hit && (!enabled || !nodeEnabled || System.getKeyState(VK_RBUTTON) || System.getKeyState(VK_MBUTTON)))
						{
							super_hit_test(i_x, i_y, false);
							return false;
						}

					return super.on_hit_test(*);
				}

	}

class Kappa_sheet extends KAGLayer, Kappa_sheet_interface
	{
		function Kappa_sheet(window, parent, b_notify=false)
			{
				KAGLayer(window, parent);
				Kappa_sheet_interface(global.KAGLayer, b_notify);
			}

		function finalize()
			{
				global.Kappa_sheet_interface.finalize(*);
				global.KAGLayer.finalize(*);
			}

		function assign(obj_src)
			{
				global.KAGLayer.assign(*);
				global.Kappa_sheet_interface.assign(*);
			}
	}

class Kappa_image_sheet_interface extends Kappa_sheet_interface
	{
		var m_obj_producer;

		function Kappa_image_sheet_interface(obj_super_layer, b_notify=false, obj_proucer, u_width, u_height)
			{
				super.Kappa_sheet_interface(obj_super_layer, b_notify);
				{
					m_obj_producer = obj_proucer;
					m_obj_producer.checkin(this, u_width, u_height);
					setSizeToImageSize();
				}
			}

		function finalize()
			{
				m_obj_producer.checkout(this) if ((m_obj_producer !== void) && (m_obj_producer isvalid));
				super.finalize(*);
			}
	}

class Kappa_image_sheet extends KAGLayer, Kappa_image_sheet_interface
	{
		function Kappa_image_sheet(window, parent, b_notify=false, obj_proucer, u_width, u_height)
			{
				KAGLayer(window, parent);
				Kappa_image_sheet_interface(global.KAGLayer, b_notify, obj_proucer, u_width, u_height);
			}

		function finalize()
			{
				global.Kappa_image_sheet_interface.finalize(*);
				global.KAGLayer.finalize(*);
			}

		function assign(obj_src)
			{
				global.KAGLayer.assign(*);
				global.Kappa_image_sheet_interface.assign(*);
			}
	}


class Kappa_application_sheet_image_producer extends Kappa_widget_image_producer
	{
		var m_aobj_img_src;

		function Kappa_application_sheet_image_producer()
			{
				super.Kappa_widget_image_producer();
				{
					var i;
					var u_images           = this.u_images;
					var aobj_virtual_frame = this.aobj_virtual_frame;

					m_u_draws = 1;

					for (i = 0; i < u_images; i++)
						aobj_virtual_frame[i].set(0 / 567, 0 / 580, 567 / 567, 580 / 580, 0, 0);
				}
			}

		function finalize()
			{
				super.finalize(*);
				on_cache_unload();
			}

		function on_paint_items(obj_img, u_width, u_height, obj_layer)
			{
				var obj_img_src = new Kappa_image();
				obj_img_src.load_image("sheet_01.tlg");
				obj_img.set_image_size(572, 580);
				colored_strech_src_copy(0, obj_img, 5, 0, 572 - 5, 580, obj_img_src);
				invalidate obj_img_src;
			}

		function on_get_id(b_focused, b_enter, b_pushed, b_enabled, u_state=0)
			{
				return 0;
			}

		function on_get_image_cookie(obj_layer, u_width, u_height)
			{
				return "%s_%dx%d".sprintf(str_specify, u_width, u_height);
			}

		property str_specify
			{
				getter
					{
						return "sheet";
					}
			}

		property aobj_img_src
			{
				getter
					{
						return m_aobj_img_src;
					}
			}
	}


class Kappa_application_tab_sheet_image_producer extends Kappa_widget_image_producer
	{
		function Kappa_application_tab_sheet_image_producer()
			{
				super.Kappa_widget_image_producer();
				{
					var i;
					var u_images           = this.u_images;
					var aobj_virtual_frame = this.aobj_virtual_frame;

					m_u_draws = 1;

					for (i = 0; i < u_images; i++)
						aobj_virtual_frame[i].set(0 / 567, 0 / 580, 567 / 567, 580 / 580, 0, 0);
				}
			}

		function finalize()
			{
				super.finalize(*);
				on_cache_unload();
			}

		function on_paint_items(obj_img, u_width, u_height, obj_layer)
			{
				var obj_img_src = new Kappa_image();
				obj_img_src.load_image("sheet_00.tlg");
				obj_img.set_image_size(572, 580);
				colored_strech_src_copy(0, obj_img, 36, 0, 572 - 36, 580, obj_img_src);
				invalidate obj_img_src;
			}

		function on_get_id(b_focused, b_enter, b_pushed, b_enabled, u_state=0)
			{
				return 0;
			}

		function on_get_image_cookie(obj_layer, u_width, u_height)
			{
				return "%s_%dx%d".sprintf(str_specify, u_width, u_height);
			}

		property str_specify
			{
				getter
					{
						return "tab_sheet";
					}
			}

		property aobj_img_src
			{
				getter
					{
						return m_aobj_img_src;
					}
			}
	}

class Kappa_application_sheet extends Kappa_image_sheet
	{
		function Kappa_application_sheet(window, parent, b_notify=false)
			{
				super.Kappa_image_sheet(window, parent, b_notify,
					g_obj_kappa_share_image.obj_sheet_image_producer, 572, 580);
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_notify_commit(obj_sender_layer)
			{
				if (obj_sender_layer.d_cookie.f_on_commit !== void)
					obj_sender_layer.d_cookie.f_on_commit(obj_sender_layer);

				super.on_notify_commit(obj_sender_layer);
			}

		function on_notify_spin(obj_sender_layer, key, u_delta)
			{
				if (obj_sender_layer.d_cookie.f_on_spin !== void)
					obj_sender_layer.d_cookie.f_on_spin(*);

				super.on_notify_spin(*);
			}

	}

class Kappa_application_tab_sheet extends Kappa_image_sheet
	{
		function Kappa_application_tab_sheet(window, parent, b_notify=false)
			{
				super.Kappa_image_sheet(window, parent, b_notify,
					g_obj_kappa_share_image.obj_tab_sheet_image_producer, 572, 580);
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_notify_commit(obj_sender_layer)
			{
				if (obj_sender_layer.d_cookie.f_on_commit !== void)
					obj_sender_layer.d_cookie.f_on_commit(obj_sender_layer);

				super.on_notify_commit(obj_sender_layer);
			}

		function on_notify_spin(obj_sender_layer, key, u_delta)
			{
				if (obj_sender_layer.d_cookie.f_on_spin !== void)
					obj_sender_layer.d_cookie.f_on_spin(*);

				super.on_notify_spin(*);
			}
	}




@endscript

@return
