@iscript


class Kappa_thumb_interface extends Kappa_widget_ctrl_interface
	{
		function Kappa_thumb_interface(obj_super_layer, b_notify_parent)
			{
				Kappa_widget_ctrl_interface(obj_super_layer, b_notify_parent);
				cursor = kag.cursorPointed;
				focusable = false;
				b_transparent_parent_update = true;
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_key_down(key, u_shift, b_process)
			{
				if (parent.key_down(*))
					{
						super_key_down(key, u_shift, false);
						return false;
					}

				return super.on_key_down(*);
			}

		function on_key_up(key, u_shift, b_process)
			{
				if (parent.key_up(*))
					{
						super_key_up(key, u_shift, false);
						return false;
					}

				return super.on_key_up(*);
			}

		function on_mouse_left_down(i_x, i_y, u_shift)
			{
				parent.mouse_left_down(i_x + left, i_y + top, u_shift);
				return super.on_mouse_left_down(*);
			}

		function on_cursor_move(i_x, i_y, u_shift)
			{
				parent.cursor_move(i_x + left, i_y + top, u_shift);
				return super.on_cursor_move(*);
			}

		function on_mouse_left_up(i_x, i_y, u_shift)
			{
				parent.mouse_left_up(i_x + left, i_y + top, u_shift);
				return super.on_mouse_left_up(*);
			}

		function on_mouse_wheel(u_shift, i_delta, i_x, i_y)
			{
				parent.mouse_wheel(u_shift, i_delta, i_x + left, i_y + top);
				return false;
			}

		function on_draw_image(u_id, i_left, i_top, u_width, u_height)
			{
				if (u_id == 1 || u_id == 3)
					fillRect(i_left, i_top, u_width, u_height, 0xffffffff);
				else if (b_enter)
					fillRect(i_left, i_top, u_width, u_height, 0xff808080);
				else
					fillRect(i_left, i_top, u_width, u_height, 0xff000000);
			}
	}

class Kappa_slider_interface extends Kappa_spin_widget_ctrl_interface
	{
		var m_i_min_value = 0;
		var m_i_max_value = 100;
		var m_i_value = 0;
		var m_u_page_size = 10;
		var m_i_drag_x_offset;
		var m_i_drag_y_offset;
		var m_i_drag_offset;
		var m_obj_tmb;
		var m_b_vertical = false;
		var m_b_inverted = false;

		function Kappa_slider_interface(obj_super_layer, b_notify_parent)
			{
				Kappa_spin_widget_ctrl_interface(obj_super_layer, b_notify_parent);

				cursor  = kag.cursorPointed;

				m_obj_tmb = on_create_thumb();
				register_child(m_obj_tmb);

				m_obj_tmb.visible = true;
				recalc_layout();
				update_thumb_position();
				m_str_commit_down_se_storage = "se_999.wav";
				m_u_commit_down_se_stream_seq = 2;
			}

		function finalize()
			{
				super.finalize(*);
			}

		function get_position_to_value(u_pos)
			{
				return on_get_position_to_value(*);
			}

		function get_value_to_position(i_val)
			{
				return on_get_value_to_position(*);
			}

		function commit_value(i_val)
			{
				i_val = norm_value(i_val);

				if (i_val != m_i_value)
					{
						on_set_value(i_val);
						update_thumb_position();
						commit();
					}
			}

		function commit_next_value()
			{
				commit_value(m_i_value + 1);
			}

		function commit_prev_value()
			{
				commit_value(m_i_value - 1);
			}

		function next_page_value()
			{
				commit_value(m_i_value + m_u_page_size);
			}

		function prev_page_value()
			{
				commit_value(m_i_value - m_u_page_size);
			}

		function update_thumb_position()
			{
				if (m_b_vertical)
					{
						m_obj_tmb.top = get_value_to_position(m_i_value);
						m_obj_tmb.left = m_u_left_outer_pad;
					}
				else
					{
						m_obj_tmb.top = m_u_top_outer_pad;
						m_obj_tmb.left = get_value_to_position(m_i_value);
					}
			}

		function recalc_layout()
			{
				if (m_b_vertical)
					{
						var u_height = (int)(m_u_page_size * u_outer_height / (m_u_page_size + m_i_max_value - m_i_min_value));

						if (u_height < u_outer_width \ 2)
							u_height = u_outer_width \ 2;

						if (u_height > height \ 4)
							u_height = height \ 4;

						if ((m_obj_tmb.width != u_outer_width) || (m_obj_tmb.height != u_height))
							{
								m_obj_tmb.width = u_outer_width;
								m_obj_tmb.height = u_height;
								update_thumb_position();
								return true;
							}
					}
				else
					{
						var u_width = (int)(m_u_page_size * u_outer_width / (m_u_page_size + m_i_max_value - m_i_min_value));

						if (u_width < u_outer_height \ 2)
							u_width = u_outer_height \ 2;

						if (u_width > width \ 4)
							u_width = width \ 4;

						if ((m_obj_tmb.width != u_width) || (m_obj_tmb.height != u_outer_height))
							{
								m_obj_tmb.width = u_width;
								m_obj_tmb.height = u_outer_height;
								update_thumb_position();
								return true;
							}
					}

				return false;
			}

		function norm_value(i_val)
			{
				i_val = (int)i_val;

				if (i_val < m_i_min_value)
					i_val = m_i_min_value;
				else if (i_val > m_i_max_value)
					i_val = m_i_max_value;

				return i_val;
			}

		function commit_position(u_pos)
			{
				var i_val;

				if (m_b_vertical)
					{
						if (u_pos < m_u_top_outer_pad)
							u_pos = m_u_top_outer_pad;
						else if (u_pos > height - m_u_bottom_outer_pad - m_obj_tmb.height)
							u_pos = height - m_u_bottom_outer_pad - m_obj_tmb.height;

						m_obj_tmb.top = u_pos;
						i_val = norm_value(get_position_to_value(u_pos));

						if (m_i_value != i_val)
							{
								on_set_value(i_val);
								commit();
							}
					}
				else
					{
						if (u_pos < m_u_left_outer_pad)
							u_pos = m_u_left_outer_pad;
						else if (u_pos > width - m_u_right_outer_pad - m_obj_tmb.width)
							u_pos = width - m_u_right_outer_pad - m_obj_tmb.width;

						m_obj_tmb.left = u_pos;
						i_val = norm_value(get_position_to_value(u_pos));

						if (m_i_value != i_val)
							{
								on_set_value(i_val);
								commit();
							}
					}
			}

		function is_drag()
			{
				return (m_i_drag_offset != void);
			}

		function mouse_left_spin(u_delta)
			{
				var u_size;
				var u_half_size;
				var i_offset;
				var i_pos;

				if (m_b_vertical)
					{
						i_offset = m_obj_tmb.top;
						u_size   = m_obj_tmb.height;
						i_pos    = cursorY;
					}
				else
					{
						i_offset = m_obj_tmb.left;
						u_size   = m_obj_tmb.width;
						i_pos    = cursorX;
					}

				u_half_size = u_size \ 2;

				if (i_pos < (i_offset + u_half_size))
					{
						var i_prev_value = m_i_value - u_delta;
						var i_prev_pos = get_value_to_position(i_prev_value);

						if (i_pos >= (i_prev_pos + u_half_size))
							{
								commit_position(i_pos - u_half_size);
								m_i_drag_offset = -u_size \ 2;
								end_spin(VK_LBUTTON);
							}
						else
							{
								commit_value(i_prev_value);
							}
					}
				else
					{
						var i_next_value = m_i_value + u_delta;
						var i_next_pos = get_value_to_position(i_next_value);

						if (i_pos <= (i_next_pos + u_half_size))
							{
								commit_position(i_pos - u_half_size);
								m_i_drag_offset = -u_size \ 2;
								end_spin(VK_LBUTTON);
							}
						else
							{
								commit_value(i_next_value);
							}
					}
			}

		function key_spin(key, u_delta)
			{
				if (m_b_vertical)
					{
						switch (key)
							{
								case VK_PRIOR:
								case VK_LEFT:
									commit_value(m_i_value - u_delta * u_page_size);
									return true;

								case VK_NEXT:
								case VK_RIGHT:
									commit_value(m_i_value + u_delta * u_page_size);
									return true;

								case VK_UP:
									commit_value(m_i_value - u_delta);
									return true;

								case VK_DOWN:
									commit_value(m_i_value + u_delta);
									return true;
							}
					}
				else
					{
						switch (key)
							{
								case VK_LEFT:
									commit_value(m_i_value - u_delta);
									return true;

								case VK_RIGHT:
									commit_value(m_i_value + u_delta);
									return true;

								case VK_PRIOR:
								case VK_UP:
									commit_value(m_i_value - u_delta * u_page_size);
									return true;

								case VK_NEXT:
								case VK_DOWN:
									commit_value(m_i_value + u_delta * u_page_size);
									return true;
							}
					}
			}

		function mouse_left_down(i_x, i_y, u_shift)
			{
				if (is_valid_region(i_x, i_y))
					{
						var u_size;
						var i_offset;
						var i_pos;

						if (focusable)
							focus();

						if (m_b_vertical)
							{
								i_offset = m_obj_tmb.top;
								u_size   = m_obj_tmb.height;
								i_pos    = i_y;
							}
						else
							{
								i_offset = m_obj_tmb.left;
								u_size   = m_obj_tmb.width;
								i_pos    = i_x;
							}

						if ((i_pos >= i_offset) && (i_pos <= (i_offset + u_size)))
							{
								if ((m_str_commit_down_se_storage != "") && !m_b_se_off)
									fnc_ci_se(m_u_commit_down_se_stream_seq, m_str_commit_down_se_storage, false);
								m_i_drag_offset = i_offset - i_pos;
								m_obj_tmb.update();
							}
						else
							{
								begin_spin(VK_LBUTTON, m_i_max_value - m_i_min_value);
							}
					}
			}

		function mouse_left_up(i_x, i_y, u_shift)
			{
				m_i_drag_offset = void;
				m_obj_tmb.update();
				end_spin(VK_LBUTTON);
			}

		function cursor_move(i_x, i_y, u_shift)
			{
				if(m_i_drag_offset !== void)
					{
						if (m_b_vertical)
							commit_position(i_y + m_i_drag_offset);
						else
							commit_position(i_x + m_i_drag_offset);
					}
			}

		function key_down(key, u_shift, b_process)
			{
				if (b_process)
					{
						if (m_b_vertical)
							{
								switch (key)
									{
										case VK_PRIOR:
										case VK_NEXT:
										case VK_LEFT:
										case VK_RIGHT:
											begin_spin(key, (m_i_max_value - m_i_min_value) / u_page_size);
											return true;

										case VK_UP:
										case VK_DOWN:
											begin_spin(key, m_i_max_value - m_i_min_value);
											return true;
									}
							}
						else
							{
								switch (key)
									{
										case VK_LEFT:
										case VK_RIGHT:
											begin_spin(key, m_i_max_value - m_i_min_value);
											return true;

										case VK_PRIOR:
										case VK_NEXT:
										case VK_UP:
										case VK_DOWN:
											begin_spin(key, (m_i_max_value - m_i_min_value) / u_page_size);
											return true;
									}
							}
					}

				return false;
			}

		function key_up(key, u_shift, b_process)
			{
				if (b_process)
					{
						switch (key)
							{
								case VK_LEFT:
								case VK_RIGHT:
								case VK_UP:
								case VK_DOWN:
									end_spin(key);
									return true;
							}
					}

				return false;
			}

		function mouse_wheel(u_shift, i_delta, i_x, i_y)
			{
				commit_value(m_i_value - (int)(i_delta / 120));
				return true;
			}

		function on_spin(key, u_delta)
			{
				if (this isvalid)
					{
						switch (key)
							{
								case VK_LBUTTON:
									mouse_left_spin(u_delta);
									break;

								default:
									key_spin(key, u_delta);
									break;
							}
					}

				return super.on_spin(*);
			}

		function on_mouse_left_down(i_x, i_y, u_shift)
			{
				mouse_left_down(*);
				return super.on_mouse_left_down(*);
			}

		function on_mouse_left_up(i_x, i_y, u_shift)
			{
				mouse_left_up(*);
				return super.on_mouse_left_up(*);
			}

		function on_cursor_move(i_x, i_y, u_shift)
			{
				cursor_move(*);
				return super.on_cursor_move(*);
			}

		function on_key_down(key, u_shift, b_process)
			{
				if (key_down(*))
					{
						super_key_down(key, u_shift, false);
						return false;
					}

				return super.on_key_down(*);
			}

		function on_key_up(key, u_shift, b_process)
			{
				if (key_up(*))
					{
						super_key_up(key, u_shift, false);
						return false;
					}

				return super.on_key_up(*);
			}

		function on_mouse_wheel(u_shift, i_delta, i_x, i_y)
			{
				mouse_wheel(*);
				return false;
			}

		function on_paint()
			{
				return super.on_paint();
			}


		function on_set_value(i_val)
			{
				m_i_value = i_val;
			}

		function on_create_thumb()
			{
				return new Kappa_thumb(window, this);
			}

		function on_get_position_to_value(u_pos)
			{
				if (m_b_vertical)
					return (int)((u_pos - m_u_top_outer_pad) / (u_outer_height - m_obj_tmb.height) * (m_i_max_value - m_i_min_value) + m_i_min_value);
				else
					return (int)((u_pos - m_u_left_outer_pad) / (u_outer_width - m_obj_tmb.width) * (m_i_max_value - m_i_min_value) + m_i_min_value);
			}

		function on_get_value_to_position(i_val)
			{
				if (m_b_vertical)
					return (int)(m_u_top_outer_pad + (i_val - m_i_min_value) * (u_outer_height - m_obj_tmb.height) / (m_i_max_value - m_i_min_value));
				else
					return (int)(m_u_left_outer_pad + (i_val - m_i_min_value) * (u_outer_width - m_obj_tmb.width) / (m_i_max_value - m_i_min_value));
			}

		function on_begin_spin(key, u_range_size)
			{
				m_obj_tmb.update();
				if ((m_str_commit_down_se_storage != "") && !m_b_se_off)
					fnc_ci_se(m_u_commit_down_se_stream_seq, m_str_commit_down_se_storage, false);
				return super.on_begin_spin(*);
			}

		function on_end_spin(key)
			{
				m_obj_tmb.update();
				return super.on_end_spin(*);
			}

		function on_blur(obj_focused_layer)
			{
				m_obj_tmb.update();
				return super.on_blur(*);
			}

		function on_focus(obj_focused_layer, b_direction)
			{
				m_obj_tmb.update();
				return super.on_focus(*);
			}

		property b_enter
			{
				setter(param)
					{
						var b_param = (+param) ? true : false;

						if (super.b_enter != b_param)
							{
								m_obj_tmb.update();
								super.b_enter = b_param;
							}
					}
				getter
					{
						return super.b_enter;
					}
			}

		property i_max_value
			{
				setter(param)
					{
						var i_param =  (int)param;

						if (i_param != i_max_value)
							m_i_max_value = i_param;
					}
				getter
					{
						return m_i_max_value;
					}
			}
		
		property i_min_value
			{
				setter(param)
					{
						var i_param =  (int)param;

						if (i_param != m_i_min_value)
							m_i_min_value = i_param;
					}
				getter
					{
						return m_i_min_value;
					}
			}
		
		property u_page_size
			{
				setter(param)
					{
						var u_param =  (int)param;

						if (u_param != m_u_page_size)
							m_u_page_size = u_param;
					}
				getter
					{
						return m_u_page_size;
					}
			}

		property i_value
			{
				setter(param)
					{
						var i_param = (int)param;

						i_param = norm_value(i_param);

						if (m_b_inverted)
							i_param = m_i_max_value + m_i_min_value - i_param;

						if (i_param != m_i_value)
							{
								on_set_value(i_param);
								update_thumb_position();
							}
					}
				getter
					{
						if (m_b_inverted)
							return m_i_max_value + m_i_min_value - m_i_value;
						else
							return m_i_value;
					}
			}

		property b_vertical
			{
				setter(param)
					{
						var b_param = ((int)param != 0);

						if (b_param != m_b_vertical)
							m_b_vertical = b_param;
					}
				getter
					{
						return m_b_vertical;
					}
			}

		property b_inverted
			{
				setter(param)
					{
						var b_param = ((int)param != 0);

						if (b_param != m_b_inverted)
							m_b_inverted = b_param;
					}
				getter
					{
						return m_b_inverted;
					}
			}

		property obj_tmb
			{
				getter
					{
						return m_obj_tmb;
					}
			}
	}

class Kappa_slider extends KAGLayer, Kappa_slider_interface
	{
		function Kappa_slider(window, parent, b_notify=true)
			{
				KAGLayer(window, parent);
				Kappa_slider_interface(global.KAGLayer, b_notify);
			}

		function finalize()
			{
				global.Kappa_slider_interface.finalize(*);
				global.KAGLayer.finalize(*);
			}

		function assign(obj_src)
			{
				global.KAGLayer.assign(*);
				global.Kappa_slider_interface.assign(*);
			}
	}

class Kappa_image_thumb_interface extends Kappa_thumb_interface, Kappa_widget_draw_image_interface
	{
		function Kappa_image_thumb_interface(obj_super_layer, b_notify, obj_proucer)
			{
				Kappa_thumb_interface(obj_super_layer, b_notify);
				Kappa_widget_draw_image_interface(global.Kappa_thumb_interface, obj_proucer);
			}

		function finalize()
			{
				global.Kappa_thumb_interface.finalize(*);
				global.Kappa_widget_draw_image_interface.finalize(*);
			}

		function on_set_option(elm)
			{
				global.Kappa_thumb_interface.on_set_option(*);
				global.Kappa_widget_draw_image_interface.on_set_option(*);
			}

		function on_serialize(b_out, str_spec, f)
			{
				global.Kappa_thumb_interface.on_serialize(*);
				global.Kappa_widget_draw_image_interface.on_serialize(*);
			}

		function on_get_id()
			{
				var b_v_enabled = enabled && nodeEnabled;
				var b_v_focused = focused || parent.focused;
				var b_v_enter   = b_enter || parent.b_enter;
				var b_v_commit_down = parent.is_spin() || parent.is_drag();
				return m_obj_producer.get_id(b_v_focused, b_v_enter, b_v_commit_down, b_v_enabled, 0);
			}

		function on_is_must_update_cache_image(u_width, u_height)
			{
				if (parent.recalc_layout())
					{
						m_u_draw_id = 0xffffffff;
						update();
					}
				return global.Kappa_widget_draw_image_interface.on_is_must_update_cache_image(*);
			}
	}

class Kappa_image_slider_interface extends Kappa_slider_interface, Kappa_widget_draw_image_interface
	{
		function Kappa_image_slider_interface(obj_super_layer, b_notify, obj_proucer)
			{
				Kappa_slider_interface(obj_super_layer, b_notify);
				Kappa_widget_draw_image_interface(global.Kappa_slider_interface, obj_proucer);
			}

		function finalize()
			{
				global.Kappa_slider_interface.finalize(*);
				global.Kappa_widget_draw_image_interface.finalize(*);
			}

		function on_set_option(elm)
			{
				global.Kappa_slider_interface.on_set_option(*);
				global.Kappa_widget_draw_image_interface.on_set_option(*);
			}

		function on_serialize(b_out, str_spec, f)
			{
				global.Kappa_slider_interface.on_serialize(*);
				global.Kappa_widget_draw_image_interface.on_serialize(*);
			}

		function on_get_id()
			{
				var b_v_enabled = enabled && nodeEnabled;
				var b_v_focused = focused || m_obj_tmb.focused;
				var b_v_enter   = b_enter || m_obj_tmb.b_enter;
				return m_obj_producer.get_id(b_v_focused, b_v_enter, b_commit_down, b_v_enabled, 0);
			}

		function on_is_must_update_cache_image(u_width, u_height)
			{
				if (recalc_layout())
					{
						m_obj_tmb.m_u_draw_id = 0xffffffff;
						m_obj_tmb.update();
					}
				return global.Kappa_widget_draw_image_interface.on_is_must_update_cache_image(*);
			}
	}

class Kappa_image_thumb extends KAGLayer, Kappa_image_thumb_interface
	{
		function Kappa_image_thumb(window, parent, b_notify=true, obj_proucer)
			{
				KAGLayer(window, parent);
				Kappa_image_thumb_interface(global.KAGLayer, b_notify, obj_proucer);
			}

		function finalize()
			{
				global.Kappa_image_thumb_interface.finalize(*);
				global.KAGLayer.finalize(*);
			}

		function assign(obj_src)
			{
				global.KAGLayer.assign(*);
				global.Kappa_image_thumb_interface.assign(*);
			}
	}

class Kappa_image_slider extends KAGLayer, Kappa_image_slider_interface
	{
		function Kappa_image_slider(window, parent, b_notify=true, obj_proucer)
			{
				KAGLayer(window, parent);
				Kappa_image_slider_interface(global.KAGLayer, b_notify, obj_proucer);
			}

		function finalize()
			{
				global.Kappa_image_slider_interface.finalize(*);
				global.KAGLayer.finalize(*);
			}

		function assign(obj_src)
			{
				global.KAGLayer.assign(*);
				global.Kappa_image_slider_interface.assign(*);
			}
	}

class Kappa_thumb extends KAGLayer, Kappa_thumb_interface
	{
		function Kappa_thumb(window, parent, b_notify=true)
			{
				KAGLayer(window, parent);
				Kappa_thumb_interface(global.KAGLayer, b_notify);
			}

		function finalize()
			{
				global.Kappa_thumb_interface.finalize(*);
				global.KAGLayer.finalize(*);
			}

		function assign(obj_src)
			{
				global.KAGLayer.assign(*);
				global.Kappa_thumb_interface.assign(*);
			}
	}

class Kappa_application_h_thumb_image_producer extends Kappa_widget_image_producer
	{
		var m_aobj_img_src;

		function Kappa_application_h_thumb_image_producer()
			{
				super.Kappa_widget_image_producer();
				{
					var i;
					var u_images           = this.u_images;
					var aobj_virtual_frame = this.aobj_virtual_frame;
/*
					for (i = 0; i < u_images; i++)
						aobj_virtual_frame[i].set(0 / 256, 0 / 256, 256 / 256, 256 / 256, 0.0, 0.0);
*/
					for (i = 0; i < u_images; i++)
						aobj_virtual_frame[i].set(2 / 286, 2 / 286, 255 / 286, 255 / 286, 0.0, 0.0);

					aobj_virtual_frame[4].r_left += 16 / 286;
					aobj_virtual_frame[4].r_top  += 16 / 286;
				}
				fnc_set_all_array_value(au_image_opacity, 0x90);
			}

		function finalize()
			{
				super.finalize(*);
				on_cache_unload();
			}

		function on_cache_load()
			{
				if (m_aobj_img_src === void)
					{
						m_aobj_img_src = [];

						m_aobj_img_src[0] = new Kappa_image();
						m_aobj_img_src[0].load_image("h_thumb_00.tlg");

						m_aobj_img_src[1] = new Kappa_image();
						m_aobj_img_src[1].load_image("h_thumb_01.tlg");
					}
			}

		function on_cache_unload()
			{
				if (m_aobj_img_src !== void)
					{
						fnc_object_array_free(m_aobj_img_src);
						invalidate m_aobj_img_src;
						m_aobj_img_src = void;
					}
			}

		function on_paint_image(u_id, obj_img, i_left, i_top, u_width, u_height, obj_layer)
			{
				switch (u_id)
					{
						case 4:// id = 4, push
							colored_strech_src_copy(u_id, obj_img, i_left, i_top, u_width, u_height, m_aobj_img_src[1]);
							break;
						case 0:	// id = 0, normal, focus = false
						case 1: // id = 1, normal, focus = true
						case 2: // id = 2, enter, focus = false
						case 3: // id = 3, enter, focus = true
						case 5: // id = 5, disable
							colored_strech_src_copy(u_id, obj_img, i_left, i_top, u_width, u_height, m_aobj_img_src[0]);
							break;
					}

			}

		property str_specify
			{
				getter
					{
						return "h_thumb";
					}
			}

		property aobj_img_src
			{
				getter
					{
						return m_aobj_img_src;
					}
			}
	}

class Kappa_application_h_slider_image_producer extends Kappa_widget_image_producer
	{
		var m_aobj_img_src;

		function Kappa_application_h_slider_image_producer()
			{
				super.Kappa_widget_image_producer();
				{
					var i;
					var u_images           = this.u_images;
					var aobj_virtual_frame = this.aobj_virtual_frame;

					for (i = 0; i < u_images; i++)
						aobj_virtual_frame[i].set(0 / 512, 0 / 256, 512 / 512, 256 / 256, 0.0, 0.0);

					m_au_image_color.assign(m_au_text_color);
					m_au_image_color_strong.assign(m_au_text_color_strong);
					m_au_image_light.assign(m_au_text_light);
					m_au_image_light_strong.assign(m_au_text_light_strong);
					m_au_image_opacity.assign(m_au_text_opacity);
				}
				fnc_set_all_array_value(au_image_opacity, 0x60);
			}

		function finalize()
			{
				super.finalize(*);
				on_cache_unload();
			}

		function on_cache_load()
			{
				if (m_aobj_img_src === void)
					{
						m_aobj_img_src = [];

						m_aobj_img_src[0] = new Kappa_image();
						m_aobj_img_src[0].load_image("h_slider.tlg");
					}
			}

		function on_cache_unload()
			{
				if (m_aobj_img_src !== void)
					{
						fnc_object_array_free(m_aobj_img_src);
						invalidate m_aobj_img_src;
						m_aobj_img_src = void;
					}
			}

		function on_paint_image(u_id, obj_img, i_left, i_top, u_width, u_height, obj_layer)
			{
				var u_edge_width;

//				if (obj_layer.obj_tmb.width > obj_layer.height)
//					u_edge_width = obj_layer.obj_tmb.height \ 3;
//				else
					u_edge_width = obj_layer.obj_tmb.width \ 3;

				switch (u_id)
					{
						case 0:	// id = 0, normal, focus = false
						case 1: // id = 1, normal, focus = true
						case 2: // id = 2, enter, focus = false
						case 3: // id = 3, enter, focus = true
						case 4: // id = 4, push
						case 5: // id = 5, disable
							colored_strech_src_copy(u_id, obj_img, i_left + u_edge_width, i_top, u_width - u_edge_width * 2, u_height, m_aobj_img_src[0]);
							break;
					}

			}

		function on_get_image_cookie(obj_layer, u_width, u_height)
			{
				var u_edge_width;

//				if (obj_layer.obj_tmb.width > obj_layer.height)
//					u_edge_width = obj_layer.obj_tmb.height \ 3;
//				else
					u_edge_width = obj_layer.obj_tmb.width \ 3;

				return super.on_get_image_cookie(*) + "_%X".sprintf(u_edge_width);
			}

		property str_specify
			{
				getter
					{
						return "h_slider";
					}
			}

		property aobj_img_src
			{
				getter
					{
						return m_aobj_img_src;
					}
			}
	}

class Kappa_application_h_thumb extends Kappa_image_thumb
	{
		function Kappa_application_h_thumb(window, parent, b_notify)
			{
				super.Kappa_image_thumb(window, parent, b_notify, g_obj_kappa_share_image.obj_h_thumb_image_producer);
			}

		function finalize()
			{
				super.finalize(*);
			}
	}

class Kappa_application_h_slider extends Kappa_image_slider
	{
		function Kappa_application_h_slider(window, parent, b_notify)
			{
				super.Kappa_image_slider(window, parent, b_notify, g_obj_kappa_share_image.obj_h_slider_image_producer);
				hitThreshold = 0x00;
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_create_thumb()
			{
				return new Kappa_application_h_thumb(window, this);
			}
	}

class Kappa_application_v_thumb_image_producer extends Kappa_widget_image_producer
	{
		var m_aobj_img_src;

		function Kappa_application_v_thumb_image_producer()
			{
				super.Kappa_widget_image_producer();
				{
					var i;
					var u_images           = this.u_images;
					var aobj_virtual_frame = this.aobj_virtual_frame;
/*
					for (i = 0; i < u_images; i++)
						aobj_virtual_frame[i].set(0 / 256, 0 / 256, 256 / 256, 256 / 256, 0.0, 0.0);
*/
					for (i = 0; i < u_images; i++)
						aobj_virtual_frame[i].set(2 / 286, 2 / 286, 255 / 286, 255 / 286, 0.0, 0.0);

					aobj_virtual_frame[4].r_left += 16 / 286;
					aobj_virtual_frame[4].r_top  += 16 / 286;
				}
				fnc_set_all_array_value(au_image_opacity, 0x90);
			}

		function finalize()
			{
				super.finalize(*);
				on_cache_unload();
			}

		function on_cache_load()
			{
				if (m_aobj_img_src === void)
					{
						m_aobj_img_src = [];

						m_aobj_img_src[0] = new Kappa_image();
						m_aobj_img_src[0].load_image("v_thumb_00.tlg");

						m_aobj_img_src[1] = new Kappa_image();
						m_aobj_img_src[1].load_image("v_thumb_01.tlg");
					}
			}

		function on_cache_unload()
			{
				if (m_aobj_img_src !== void)
					{
						fnc_object_array_free(m_aobj_img_src);
						invalidate m_aobj_img_src;
						m_aobj_img_src = void;
					}
			}

		function on_paint_image(u_id, obj_img, i_left, i_top, u_width, u_height, obj_layer)
			{
				switch (u_id)
					{
						case 4:// id = 4, push
							colored_strech_src_copy(u_id, obj_img, i_left, i_top, u_width, u_height, m_aobj_img_src[1]);
							break;
						case 0:	// id = 0, normal, focus = false
						case 1: // id = 1, normal, focus = true
						case 2: // id = 2, enter, focus = false
						case 3: // id = 3, enter, focus = true
						case 5: // id = 5, disable
							colored_strech_src_copy(u_id, obj_img, i_left, i_top, u_width, u_height, m_aobj_img_src[0]);
							break;
					}

			}

		property str_specify
			{
				getter
					{
						return "v_thumb";
					}
			}

		property aobj_img_src
			{
				getter
					{
						return m_aobj_img_src;
					}
			}
	}


class Kappa_application_v_slider_image_producer extends Kappa_widget_image_producer
	{
		var m_aobj_img_src;

		function Kappa_application_v_slider_image_producer()
			{
				super.Kappa_widget_image_producer();
				{
					var i;
					var u_images           = this.u_images;
					var aobj_virtual_frame = this.aobj_virtual_frame;

					for (i = 0; i < u_images; i++)
						aobj_virtual_frame[i].set(0 / 256, 0 / 512, 256 / 256, 512 / 512, 0.0, 0.0);

					m_au_image_color.assign(m_au_text_color);
					m_au_image_color_strong.assign(m_au_text_color_strong);
					m_au_image_light.assign(m_au_text_light);
					m_au_image_light_strong.assign(m_au_text_light_strong);
					m_au_image_opacity.assign(m_au_text_opacity);

				}
				fnc_set_all_array_value(au_image_opacity, 0x60);
			}

		function finalize()
			{
				super.finalize(*);
				on_cache_unload();
			}

		function on_cache_load()
			{
				if (m_aobj_img_src === void)
					{
						m_aobj_img_src = [];

						m_aobj_img_src[0] = new Kappa_image();
						m_aobj_img_src[0].load_image("v_slider.tlg");
					}
			}

		function on_cache_unload()
			{
				if (m_aobj_img_src !== void)
					{
						fnc_object_array_free(m_aobj_img_src);
						invalidate m_aobj_img_src;
						m_aobj_img_src = void;
					}
			}

		function on_paint_image(u_id, obj_img, i_left, i_top, u_width, u_height, obj_layer)
			{
				var u_edge_height;

//				if (obj_layer.obj_tmb.height > obj_layer.width)
//					u_edge_height = obj_layer.obj_tmb.width \ 3;
//				else
					u_edge_height = obj_layer.obj_tmb.height \ 3;

				switch (u_id)
					{
						case 0:	// id = 0, normal, focus = false
						case 1: // id = 1, normal, focus = true
						case 2: // id = 2, enter, focus = false
						case 3: // id = 3, enter, focus = true
						case 4: // id = 4, push
						case 5: // id = 5, disable
							colored_strech_src_copy(u_id, obj_img, i_left, i_top + u_edge_height, u_width, u_height - u_edge_height * 2, m_aobj_img_src[0]);
							break;
					}

			}

		function on_get_image_cookie(obj_layer, u_width, u_height)
			{
				var u_edge_height;

//				if (obj_layer.obj_tmb.height > obj_layer.width)
//					u_edge_height = obj_layer.obj_tmb.width \ 3;
//				else
					u_edge_height = obj_layer.obj_tmb.height \ 3;

				return super.on_get_image_cookie(*) + "_%X".sprintf(u_edge_height);
			}

		property str_specify
			{
				getter
					{
						return "v_slider";
					}
			}

		property aobj_img_src
			{
				getter
					{
						return m_aobj_img_src;
					}
			}
	}


class Kappa_application_v_thumb extends Kappa_image_thumb
	{
		function Kappa_application_v_thumb(window, parent, b_notify)
			{
				super.Kappa_image_thumb(window, parent, b_notify, g_obj_kappa_share_image.obj_v_thumb_image_producer);
			}

		function finalize()
			{
				super.finalize(*);
			}
	}

class Kappa_application_v_slider extends Kappa_image_slider
	{
		function Kappa_application_v_slider(window, parent, b_notify)
			{
				m_b_vertical = true;
				super.Kappa_image_slider(window, parent, b_notify, g_obj_kappa_share_image.obj_v_slider_image_producer);
				hitThreshold = 0x00;
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_create_thumb()
			{
				return new Kappa_application_v_thumb(window, this);
			}
	}


class Kappa_decorated_h_slider extends Kappa_application_h_slider
	{
		var m_str_format;
		var m_r_ratio = 1;
		var m_u_floor = 0;
		var m_obj_lbl_prefix;
		var m_obj_lbl_infix;
		var m_obj_lbl_suffix;
		var m_obj_lbl_left;
		var m_obj_lbl_right;
		var m_str_caption;

		function Kappa_decorated_h_slider(window, parent, b_notify, r_ratio = 1, u_floor = 0)
			{
				super.Kappa_application_h_slider(window, parent, b_notify);
				m_r_ratio = r_ratio;
				m_u_floor = u_floor;

				m_obj_lbl_prefix = new Kappa_application_widget_label(window, this, false, m_obj_producer);
				register_child(m_obj_lbl_prefix);
				m_obj_lbl_infix = new Kappa_application_static_label(window, this);
				register_child(m_obj_lbl_infix);
				m_obj_lbl_suffix = new Kappa_application_widget_label(window, this, false, m_obj_producer);
				register_child(m_obj_lbl_suffix);

				m_obj_lbl_infix.font.face = "lr SVbN";
				m_obj_lbl_infix.b_no_cache_image = true;

				m_obj_lbl_left = new Kappa_application_label(window, this);
				register_child(m_obj_lbl_left);
				m_obj_lbl_right = new Kappa_application_label(window, this);
				register_child(m_obj_lbl_right);

				m_obj_tmb.bringToFront();

				update_format();
			}

		function finalize()
			{
				super.finalize(*);
			}

		function layout_all_label()
			{
				layout_prefix_label();
				layout_infix_label();
				layout_suffix_label();
				layout_label();

				layout_left_label();
				layout_right_label();
			}

		function layout_label()
			{
				var u_width = 0;
				var i_left;

				if (m_obj_lbl_prefix.visible)
					u_width += m_obj_lbl_prefix.width;

				if (m_obj_lbl_infix.visible)
					u_width += m_obj_lbl_infix.width;

				if (m_obj_lbl_suffix.visible)
					u_width += m_obj_lbl_suffix.width;

				i_left = (width - u_width) \ 2;

				if (m_obj_lbl_prefix.visible)
					{
						m_obj_lbl_prefix.left = i_left;
						i_left += m_obj_lbl_prefix.width;
					}

				if (m_obj_lbl_infix.visible)
					{
						m_obj_lbl_infix.left = i_left;
						i_left += m_obj_lbl_infix.width;
					}

				if (m_obj_lbl_suffix.visible)
					{
						m_obj_lbl_suffix.left = i_left;
						i_left += m_obj_lbl_suffix.width;
					}
			}

		function layout_prefix_label()
			{
				if (m_obj_lbl_prefix.str_text != "")
					{
						m_obj_lbl_prefix.font.height = (int)Math.ceil(height / 1.75);
						m_obj_lbl_prefix.fit_size();
						m_obj_lbl_prefix.top = (height - m_obj_lbl_prefix.height) \ 2;
						m_obj_lbl_prefix.visible = true;
					}
				else
					{
						m_obj_lbl_prefix.visible = false;
					}
			}

		function layout_infix_label()
			{
				if (m_obj_lbl_infix.str_text != "")
					{
						m_obj_lbl_infix.font.height = (int)Math.ceil(height / 1.75);
						m_obj_lbl_infix.fit_size();

						m_obj_lbl_infix.top = (height - m_obj_lbl_infix.height) \ 2;
						m_obj_lbl_infix.visible = true;
					}
				else
					{
						m_obj_lbl_infix.visible = false;
						m_obj_lbl_infix.callPaint = false;
					}
			}

		function layout_suffix_label()
			{
				if (m_obj_lbl_suffix.str_text != "")
					{
						m_obj_lbl_suffix.font.height = (int)Math.ceil(height / 1.75);
						m_obj_lbl_suffix.fit_size();
						m_obj_lbl_suffix.top = (height - m_obj_lbl_suffix.height) \ 2;
						m_obj_lbl_suffix.visible = true;
					}
				else
					{
						m_obj_lbl_suffix.visible = false;
					}
			}

		function layout_left_label()
			{
				if (m_obj_lbl_left.str_text != "")
					{
						m_obj_lbl_left.font.height = height;
						m_obj_lbl_left.font.face = "symbol_00_" + (string)height;
						m_obj_lbl_left.fit_size();
						m_obj_lbl_left.left = 0;
//						m_obj_lbl_left.top = (height - m_obj_lbl_left.height) \ 2;
						m_obj_lbl_left.top = -height * 0.05;
						m_obj_lbl_left.visible = true;
						u_left_outer_pad = m_obj_lbl_left.width;
					}
				else
					{
						m_obj_lbl_left.visible = false;
						u_left_outer_pad = 0;
					}
			}

		function layout_right_label()
			{
				if (m_obj_lbl_right.str_text != "")
					{
						m_obj_lbl_right.font.height = height;
						m_obj_lbl_right.font.face = "symbol_00_" + (string)height;
						m_obj_lbl_right.fit_size();
						m_obj_lbl_right.left = width - m_obj_lbl_right.width;
//						m_obj_lbl_right.top = (height - m_obj_lbl_right.height) \ 2;
						m_obj_lbl_right.top = -height * 0.05;
						m_obj_lbl_right.visible = true;
						u_right_outer_pad = m_obj_lbl_right.width;
					}
				else
					{
						m_obj_lbl_right.visible = false;
						u_right_outer_pad = 0;
				}
			}

		function update_infix_label()
			{
				m_obj_lbl_infix.apply_producer_draw(m_obj_producer, m_u_draw_id);
				m_obj_lbl_infix.str_text = m_str_format.sprintf(i_value * m_r_ratio);
				layout_infix_label();
				layout_label();
			}

		function update_format()
			{
				m_str_format = fnc_get_min_max_format_string(i_min_value, i_max_value, m_r_ratio, m_u_floor);
				update_infix_label();
			}

		function on_draw_image(u_id, i_left, i_top, u_width, u_height)
			{
				m_obj_lbl_infix.apply_producer_draw(m_obj_producer, u_id);
				m_obj_lbl_prefix.set_id(u_id);
				m_obj_lbl_suffix.set_id(u_id);
				super.on_draw_image();
			}

		function on_set_value(i_val)
			{
				super.on_set_value(*);
				update_infix_label();
			}

		property height
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != super.height)
							{
								super.height = param;
								layout_all_label();
							}
					}
				getter
					{
						return super.height;
					}
			}

		property width
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != super.width)
							{
								super.width = param;
								layout_all_label();
							}
					}
				getter
					{
						return super.width;
					}
			}

		property str_prefix
			{
				setter(param)
					{
						var str_param = (string)param;

						if (m_obj_lbl_prefix.str_text != str_param)
							{
								m_obj_lbl_prefix.str_text = str_param;
								layout_prefix_label();
								layout_label();
							}
					}
				getter
					{
						return m_obj_lbl_prefix.str_text;
					}
			}

		property str_suffix
			{
				setter(param)
					{
						var str_param = (string)param;

						if (m_obj_lbl_suffix.str_text != str_param)
							{
								m_obj_lbl_suffix.str_text = str_param;
								layout_suffix_label();
								layout_label();
							}
					}
				getter
					{
						return m_str_suffix;
					}
			}

		property str_left
			{
				setter(param)
					{
						var str_param = (string)param;

						if (m_obj_lbl_left.str_text != str_param)
							{
								m_obj_lbl_left.str_text = str_param;
								layout_left_label();
							}
					}
				getter
					{
						return m_obj_lbl_left.str_text;
					}
			}

		property str_right
			{
				setter(param)
					{
						var str_param = (string)param;

						if (m_obj_lbl_right.str_text != str_param)
							{
								m_obj_lbl_right.str_text = str_param;
								layout_right_label();
							}
					}
				getter
					{
						return m_obj_lbl_right.str_text;
					}
			}

		property u_left_color
			{
				setter(param)
					{
						var u_param = (int)param;

						if (m_obj_lbl_left.u_color != u_param)
							{
								m_obj_lbl_left.u_color = u_param;
								m_obj_lbl_left.update();
							}
					}
				getter
					{
						return m_obj_lbl_left.u_color;
					}
			}

		property u_right_color
			{
				setter(param)
					{
						var u_param = (int)param;

						if (m_obj_lbl_right.u_color != u_param)
							{
								m_obj_lbl_right.u_color = u_param;
								m_obj_lbl_right.update();
							}
					}
				getter
					{
						return m_obj_lbl_right.u_color;
					}
			}

		property i_min_value
			{
				setter(param)
					{
						var i_param = (int)param;

						if (super.i_min_value != i_param)
							{
								super.i_min_value = i_param;
								update_format();
							}
					}
				getter
					{
						return super.i_min_value;
					}
			}

		property i_max_value
			{
				setter(param)
					{
						var i_param = (int)param;

						if (super.i_max_value != i_param)
							{
								super.i_max_value = i_param;
								update_format();
							}
					}
				getter
					{
						return super.i_max_value;
					}
			}

		property r_ratio
			{
				setter(param)
					{
						var r_param = (real)param;

						if (m_r_ratio != r_param)
							{
								m_r_ratio = r_param;
								update_format();
							}
					}
				getter
					{
						return m_r_ratio;
					}
			}

		property u_floor
			{
				setter(param)
					{
						var u_param = (int)param;

						if (m_u_floor != u_param)
							{
								m_u_floor = u_param;
								update_format();
							}
					}
				getter
					{
						return m_u_floor;
					}
			}
	}


@endscript

@return

