@iscript


class Kappa_state_button_interface extends Kappa_button_interface
	{
		var m_u_states = 2;
		var m_u_state  = 0;

		function Kappa_state_button_interface(obj_super_layer, b_notify_parent)
			{
				super.Kappa_button_interface(obj_super_layer, b_notify_parent);
			}

		function finalize()
			{
				super.finalize(*);
			}

		function commit()
			{
				var u_next_state = m_u_state + 1;

				if (u_next_state >= m_u_states)
					u_next_state = 0;

				u_state = u_next_state;
				super.commit();
			}

		function on_set_option(elm)
			{
				if (elm.states !== void)
					m_u_states = elm.states;

				if (elm.state !== void)
					u_state = elm.state;

				super.on_set_option(*);
			}

		function on_serialize(b_out, str_spec, f)
			{
				serialize_atom(b_out, str_spec, f, "m_u_states");
				serialize_atom(b_out, str_spec, f, "m_u_state");
				super.on_serialize(*);
			}

		property u_states
			{
				setter(param)
					{
						m_u_states = (int)param;
					}
				getter
					{
						return m_u_states;
					}
			}

		property u_state
			{
				setter(param)
					{
						if (m_u_state !== (int)param)
							{
								m_u_state = (int)param;
								update();
							}
					}
				getter
					{
						return m_u_state;
					}
			}
	}

class Kappa_image_state_button_interface extends Kappa_state_button_interface, Kappa_widget_draw_image_interface
	{
		function Kappa_image_state_button_interface(obj_super_layer, b_notify, obj_proucer)
			{
				Kappa_state_button_interface(obj_super_layer, b_notify);
				Kappa_widget_draw_image_interface(global.Kappa_state_button_interface, obj_proucer);
			}

		function finalize()
			{
				global.Kappa_state_button_interface.finalize(*);
				global.Kappa_widget_draw_image_interface.finalize(*);
			}

		function on_set_option(elm)
			{
				global.Kappa_state_button_interface.on_set_option(*);
				global.Kappa_widget_draw_image_interface.on_set_option(*);
			}

		function on_serialize(b_out, str_spec, f)
			{
				global.Kappa_state_button_interface.on_serialize(*);
				global.Kappa_widget_draw_image_interface.on_serialize(*);
			}

		function on_get_id()
			{
				return obj_producer.get_id(focused, b_enter, b_commit_down, enabled && nodeEnabled, u_state);
			}
	}

class Kappa_image_state_button extends KAGLayer, Kappa_image_state_button_interface
	{
		function Kappa_image_state_button(window, parent, b_notify=true, obj_proucer)
			{
				KAGLayer(window, parent);
				Kappa_image_state_button_interface(global.KAGLayer, b_notify, obj_proucer);
			}

		function finalize()
			{
				global.Kappa_image_state_button_interface.finalize(*);
				global.KAGLayer.finalize(*);
			}

		function assign(obj_src)
			{
				global.KAGLayer.assign(*);
				global.Kappa_image_state_button_interface.assign(*);
			}
	}

class Kappa_application_2state_toggle_button_image_producer extends Kappa_widget_image_producer
	{
		var m_aobj_img_src;

		function Kappa_application_2state_toggle_button_image_producer()
			{
				super.Kappa_widget_image_producer();
				{
					var i;
					var u_images           = this.u_images;
					var aobj_virtual_frame = this.aobj_virtual_frame;

					for (i = 0; i < u_images; i++)
						aobj_virtual_frame[i].set(2 / 256, 0 / 128, 240 / 256, 98 / 128, 0, 0.100);

					aobj_virtual_frame[4].r_left += 12 / 256;
					aobj_virtual_frame[4].r_top  += 12 / 128;

					_set_states(2);

					m_au_text_color[u_draws] = 0xff404000;
					m_au_text_color[u_draws + 1] = 0xffffffb0;
					m_au_text_color[u_draws + 2] = -1 - u_draws;
					m_au_text_color[u_draws + 3] = -2 - u_draws;
					m_au_text_color[u_draws + 4] = -2 - u_draws;
					m_au_image_color[u_draws] = 0xffa0a020;
//					m_au_image_color[0] = 0xff20a020;
					m_au_image_color[4] = -5 - u_draws;
					m_au_text_color[4] = -5 - u_draws;
					fnc_set_array_value(m_au_image_color, -1 - u_draws, u_draws + 1, u_draws - 2);
				}
			}

		function finalize()
			{
				super.finalize(*);
				on_cache_unload();
			}

		function on_cache_load()
			{
				if (m_aobj_img_src === void)
					{
						m_aobj_img_src = [];

						m_aobj_img_src[0] = new Kappa_image();
						m_aobj_img_src[0].load_image("button_00.tlg");

						m_aobj_img_src[1] = new Kappa_image();
						m_aobj_img_src[1].load_image("button_01.tlg");
					}
			}

		function on_cache_unload()
			{
				if (m_aobj_img_src !== void)
					{
						fnc_object_array_free(m_aobj_img_src);
						invalidate m_aobj_img_src;
						m_aobj_img_src = void;
					}
			}

		function on_paint_image(u_id, obj_img, i_left, i_top, u_width, u_height, obj_layer)
			{
				switch (u_id)
					{
						case 4:  // id = 4, push
						case 10: // id = 10, push
							colored_strech_src_copy(u_id, obj_img, i_left, i_top, u_width, u_height, m_aobj_img_src[1]);
							break;
						case 0:	 // id = 0, normal, focus = false
						case 1:  // id = 1, normal, focus = true
						case 2:  // id = 2, enter, focus = false
						case 3:  // id = 3, enter, focus = true
						case 5:  // id = 5, disable
						case 6:  // id = 6, normal, focus = false
						case 7:  // id = 7, normal, focus = true
						case 8:  // id = 8, enter, focus = false
						case 9:  // id = 9, enter, focus = true
						case 11: // id = 11, disable
							colored_strech_src_copy(u_id, obj_img, i_left, i_top, u_width, u_height, m_aobj_img_src[0]);
							break;
					}

			}

		property str_specify
			{
				getter
					{
						return "toggle";
					}
			}

		property aobj_img_src
			{
				getter
					{
						return m_aobj_img_src;
					}
			}
	}

class Kappa_application_2state_button extends Kappa_image_state_button
	{
		function Kappa_application_2state_button(window, parent, b_notify)
			{
				super.Kappa_image_state_button(window, parent, b_notify, g_obj_kappa_share_image.obj_2state_toggle_button_image_producer);
			}

		function finalize()
			{
				super.finalize(*);
			}

		property height
			{
				setter(param)
					{
						super.height = param;
						u_left_inner_pad = super.height \ 5;
						u_right_inner_pad = super.height \ 5;
					}
				getter
					{
						return super.height;
					}
			}
	}

class Kappa_application_call_2state_button extends Kappa_application_2state_button
	{
		var m_str_callback_storage;
		var m_str_callback_target;
		var m_str_callback_script;
		var m_str_enabled_flag;
		var m_str_state_flag;
		var m_b_wait_cursor = true;
		var m_b_enabled_flag = true;

		function Kappa_application_call_2state_button(window, parent, b_notify)
			{
				super.Kappa_application_2state_button(window, parent, b_notify);
			}

		function finalize()
			{
				super.finalize(*);
			}

		function update_enabled()
			{
				if (m_str_enabled_flag != "")
					{
						m_b_enabled_flag = Scripts.eval(m_str_enabled_flag);
						enabled = m_b_enabled_flag;
					}

				if (m_str_state_flag != "")
					u_state = Scripts.eval(m_str_state_flag);
			}

		function on_set_option(elm)
			{
				if (elm.callback_storage !== void)
					m_str_callback_storage = elm.callback_storage;

				if (elm.callback_target !== void)
					m_str_callback_target = elm.callback_target;

				if (elm.callback_script !== void)
					m_str_callback_script = elm.callback_script;

				if (elm.enabled_flag !== void)
					m_str_enabled_flag = elm.enabled_flag;

				if (elm.state_flag !== void)
					m_str_state_flag = elm.state_flag;

				if (elm.wait_cursor !== void)
					m_b_wait_cursor = +elm.wait_cursor;

				super.on_set_option(*);
			}

		function on_serialize(b_out, str_spec, f)
			{
				serialize_atom(b_out, str_spec, f, "m_str_callback_storage");
				serialize_atom(b_out, str_spec, f, "m_str_callback_target");
				serialize_atom(b_out, str_spec, f, "m_str_callback_script");
				serialize_atom(b_out, str_spec, f, "m_str_state_flag");
				serialize_atom(b_out, str_spec, f, "m_str_enabled_flag");
				serialize_atom(b_out, str_spec, f, "m_b_wait_cursor");
				serialize_atom(b_out, str_spec, f, "m_b_enabled_flag");
				super.on_serialize(*);
			}

		function commit()
			{
				f.b_run = m_b_wait_cursor;
				super.commit();
			}

		function on_commit()
			{
				if (m_str_callback_script != "")
					Scripts.exec(m_str_callback_script);
				if ((m_str_callback_storage != "") || (m_str_callback_target != ""))
					kag.callExtraConductor(m_str_callback_storage, m_str_callback_target);

				return super.on_commit();
			}

		function on_get_id()
			{
				return super.on_get_id();
			}

		property str_callback_storage
			{
				setter(param)
					{
						m_str_callback_storage = (string)param;
					}
				getter
					{
						return m_str_callback_storage;
					}
			}

		property str_callback_target
			{
				setter(param)
					{
						m_str_callback_target = (string)param;
					}
				getter
					{
						return m_str_callback_target;
					}
			}

		property str_callback_script
			{
				setter(param)
					{
						m_str_callback_script = (string)param;
					}
				getter
					{
						return m_str_callback_script;
					}
			}

		property str_enabled_flag
			{
				setter(param)
					{
						m_str_enabled_flag = (string)param;
						update();
					}
				getter
					{
						return m_str_enabled_flag;
					}
			}
	}


@endscript

@return
