@if exp="typeof(global.g_obj_kappa_system) == 'undefined'"

@iscript

kag.tagHandlers.system_menu = function(elm)
	{
		callExtraConductor("kappa_system.ks", "*system");
		return 0;
	} incontextof kag;

kag.tagHandlers.load_menu = function(elm)
	{
		callExtraConductor("kappa_system.ks", "*load");
		return  0;
	} incontextof kag;

kag.tagHandlers.save_menu = function(elm)
	{
		callExtraConductor("kappa_system.ks", "*save");
		return 0;
	} incontextof kag;

kag.tagHandlers.qload = function(elm)
	{
		callExtraConductor("kappa_system.ks", "*qload");
		return  0;
	} incontextof kag;

kag.tagHandlers.qsave = function(elm)
	{
		callExtraConductor("kappa_system.ks", "*qsave");
		return 0;
	} incontextof kag;

kag.tagHandlers.exit = function(elm)
	{
		callExtraConductor("kappa_system.ks", "*exit");
		return 0;
	} incontextof kag;

kag.tagHandlers.showhistory_ex = function(elm)
	{
		callExtraConductor("kappa_system.ks", "*history");
		return 0;
	} incontextof kag;

class Kappa_system extends Kappa_object_interface
	{
		var m_b_first_turn_of_bookmark_item_loaded = false;
		var m_obj_system_menu_layer;
		var m_obj_show_trigger;
		var m_obj_reload_trigger;
		var m_b_message_font_update = false;
		var m_b_message_image_update = false;

		var m_u_system_menu_cache_pahase = 0;
		var m_b_system_menu_is_cached = false;
		var m_b_history_is_cached = false;
		var m_b_message_dialog_is_cached = false;
		var m_b_color_dialog_is_cached = false;

		function Kappa_system()
			{
				super.Kappa_object_interface();
			}

		function finalize()
			{
				invalidate m_obj_system_menu_layer if ((m_obj_system_menu_layer !== void) && (m_obj_system_menu_layer isvalid));
				super.finalize(*);
			}

		function create_system_menu(elm)
			{
				if (m_obj_system_menu_layer === void)
					{
						var d_param = %[];

						kag.fore.base.cursor = crHourGlass;
						kag.back.base.cursor = crHourGlass;

						if (elm !== void)
							d_param.u_page = (int)elm.page if (elm.page !== void);

						m_obj_system_menu_layer = new Kappa_system_form(kag, kag.fore.base, false, d_param);
						invalidate d_param;
					}
				else
					{
						m_obj_system_menu_layer.refresh();

						if (elm !== void)
							m_obj_system_menu_layer.u_page = (int)elm.page if (elm.page !== void);
					}
			}

		function destroy_system_menu()
			{
				if (!sf.b_menu_on_memory && (m_obj_system_menu_layer !== void))
					{
						m_obj_system_menu_layer.destroy();
						m_obj_system_menu_layer = void;
					}

				kag.saveSystemVariables();
				g_obj_kappa_tray.unlock_widget();
				kag.trigger("release_modal");

				if (m_b_message_font_update || m_b_message_image_update)
					{
						var obj_message = fnc_get_fore_message_layer_by_spec("bZ[W");

						if (m_b_message_image_update)
							{
								g_obj_kappa_share_image.notify_message_image_update();
								m_b_message_image_update = false;
							}

						if (obj_message !== void)
							{
								m_obj_reload_trigger = new AsyncTrigger(__reload, "");
								m_obj_reload_trigger.trigger();
							}

						m_b_message_font_update = false;
					}
			}

		function __reload()
			{
				invalidate m_obj_reload_trigger if ((m_obj_reload_trigger !== void) && (m_obj_reload_trigger isvalid));
				m_obj_reload_trigger = void;

				fnc_save_bookmark_item_by_num(996);
				g_b_reload = true;
				fnc_load_bookmark_item_by_num(996);
				g_b_reload = false;
				kag.skipToClick();
			}

		function cache_system_menu()
			{
				g_obj_kappa_share_image.cache_lock_generic_source_image();

				create_system_menu(%[]);
				m_obj_system_menu_layer.cache_image();

				if (sf.b_menu_on_memory)
					{
						m_obj_system_menu_layer.visible = false;
					}
				else
					{
						invalidate m_obj_system_menu_layer if ((m_obj_system_menu_layer !== void) && (m_obj_system_menu_layer isvalid));
						m_obj_system_menu_layer = void;
					}

				g_obj_kappa_share_image.cache_unlock_generic_source_image();
				m_b_system_menu_is_cached = true;
			}

		function phase_cache()
			{
				if (!m_b_system_menu_is_cached)
					{
						phase_cache_system_menu();
						return false;
					}
				else if (!m_b_history_is_cached)
					{
						cache_history();
						return false;
					}
				else if (!m_b_message_dialog_is_cached)
					{
						cache_message_dialog();
						return false;
					}
				else if (!m_b_color_dialog_is_cached)
					{
						cache_color_dialog();
						return true;
					}

				return true;
			}

		function phase_cache_system_menu(u_phase_no)
			{
				if (!m_u_system_menu_cache_pahase)
					{
						g_obj_kappa_share_image.cache_lock_generic_source_image();
						create_system_menu(%[]);
						m_u_system_menu_cache_pahase++;
					}
				else if (m_obj_system_menu_layer.phase_cache_image(m_u_system_menu_cache_pahase - 1))
					{
						if (sf.b_menu_on_memory)
							{
								m_obj_system_menu_layer.visible = false;
							}
						else
							{
								invalidate m_obj_system_menu_layer if ((m_obj_system_menu_layer !== void) && (m_obj_system_menu_layer isvalid));
								m_obj_system_menu_layer = void;
							}

						g_obj_kappa_share_image.cache_unlock_generic_source_image();
						m_u_system_menu_cache_pahase = 0;
						m_b_system_menu_is_cached = true;
					}
				else
					{
						m_u_system_menu_cache_pahase++;
					}
			}

		function cache_history()
			{
				g_obj_kappa_share_image.cache_lock_generic_source_image();
				{
					var obj_form = new Kappa_history_form(kag, kag.fore.base, false, kag.historyLayer);
					obj_form.cache_image();
					if (sf.b_menu_on_memory)
						kag.historyLayer.m_obj_sht = obj_form;
					else
						invalidate obj_form;
				}
				g_obj_kappa_share_image.cache_unlock_generic_source_image();
				m_b_history_is_cached = true;
			}

		function cache_message_dialog()
			{
				g_obj_kappa_share_image.cache_lock_generic_source_image();
				{
					var obj_dlg = new Kappa_message_dialog(kag, kag.fore.base, false, %[]);
					obj_dlg.cache_image();
					invalidate obj_dlg;
				}
				g_obj_kappa_share_image.cache_unlock_generic_source_image();
				m_b_message_dialog_is_cached =true;
			}

		function cache_color_dialog()
			{
				g_obj_kappa_share_image.cache_lock_generic_source_image();
				{
					var obj_dlg = new Kappa_color_dialog(kag, kag.fore.base, false, %[]);
					obj_dlg.cache_image();
					invalidate obj_dlg;
				}
				g_obj_kappa_share_image.cache_unlock_generic_source_image();
				m_b_color_dialog_is_cached =true;
			}

		function notify_bookmark_item_changed(u_num)
			{
				m_obj_system_menu_layer.notify_bookmark_item_changed(*) if ((m_obj_system_menu_layer !== void) && (m_obj_system_menu_layer isvalid));
			}

		function notify_src_bookmark_item_changed(u_copy_num, u_move_num)
			{
				m_obj_system_menu_layer.notify_src_bookmark_item_changed(*) if ((m_obj_system_menu_layer !== void) && (m_obj_system_menu_layer isvalid));
			}

		function notify_bookmark_item_loaded(u_num)
			{
				m_b_first_turn_of_bookmark_item_loaded = true;
				g_obj_kappa_tray.lock_widget() if (b_system_menu_is_modal);
				m_obj_system_menu_layer.notify_bookmark_item_loaded(*) if ((m_obj_system_menu_layer !== void) && (m_obj_system_menu_layer isvalid));
			}

		function notify_system_menu_is_invisible()
			{
				destroy_system_menu();
			}

		function notify_message_font_update()
			{
				m_b_message_font_update = true;
			}

		function notify_message_image_update()
			{
				m_b_message_image_update = true;
			}

		function __show_menu(elm, f_trigger)
			{
				fnc_stop();

				if (kag.historyLayer.visible)
					return;

				kag.conductor.enqueueTag(%["tagname" => "waittrig", "name" => "release_modal"]);
				m_obj_show_trigger = new AsyncTrigger(f_trigger, "");
				m_obj_show_trigger.trigger();
			}

		function show_system_menu(elm)
			{
				__show_menu(elm, __show_system_menu_trigger);
			}

		function __show_system_menu_trigger()
			{
				invalidate m_obj_show_trigger if ((m_obj_show_trigger !== void) && (m_obj_show_trigger isvalid));
				m_obj_show_trigger = void;
				create_system_menu();
				m_obj_system_menu_layer.show(void, void);
			}

		function show_load_menu(elm)
			{
				__show_menu(elm, __show_load_menu_trigger);
			}

		function __show_load_menu_trigger()
			{
				invalidate m_obj_show_trigger if ((m_obj_show_trigger !== void) && (m_obj_show_trigger isvalid));
				m_obj_show_trigger = void;
				create_system_menu(%["page" => "1"]);
				m_obj_system_menu_layer.show(void, void);
			}

		function show_save_menu(elm)
			{
				__show_menu(elm, __show_save_menu_trigger);
			}

		function __show_save_menu_trigger()
			{
				invalidate m_obj_show_trigger if ((m_obj_show_trigger !== void) && (m_obj_show_trigger isvalid));
				m_obj_show_trigger = void;
				create_system_menu(%["page" => "0"]);
				m_obj_system_menu_layer.show(void, void);
			}

		function notify_prestable(elm)
			{
				if (m_b_first_turn_of_bookmark_item_loaded)
					{
						m_b_first_turn_of_bookmark_item_loaded = false;

						if (b_system_menu_is_modal)
							kag.conductor.enqueueTag(%["tagname" => "waittrig", "name" => "release_modal"]);
					}
			}

		function __on_exchange_fore_back()
			{
				if (m_obj_system_menu_layer !== void)
					{
						if (m_obj_system_menu_layer.parent == kag.fore.base)
							m_obj_system_menu_layer.parent = kag.back.base;
						else
							m_obj_system_menu_layer.parent = kag.fore.base;
					}
			}

		property b_first_turn_of_bookmark_item_loaded
			{
				getter
					{
						return m_b_first_turn_of_bookmark_item_loaded;
					}
			}

		property b_system_menu_is_modal
			{
				getter
					{
						return (m_obj_system_menu_layer !== void) && m_obj_system_menu_layer.visible;
					}
			}

		property b_system_menu_is_in_transition
			{
				getter
					{
						return (m_obj_system_menu_layer !== void) && m_obj_system_menu_layer.b_in_transition;
					}
			}

		property obj_system_menu_layer
			{
				getter
					{
						return m_obj_system_menu_layer;
					}
			}
	}

global.g_obj_kappa_system = new Kappa_system();

@endscript

@endif

@return

*system
@eval exp="g_obj_kappa_system.show_system_menu(%[])"
@return

*save
@eval exp="g_obj_kappa_system.show_save_menu(%[])"
@unlock_option_tray
@return

*load
@eval exp="g_obj_kappa_system.show_load_menu(%[])"
@unlock_option_tray
@return

*qsave
@eval exp="fnc_save_bookmark_item_by_num_with_ask(0, true, void)"
@waittrig name="release_modal_save"
@unlock_option_tray
@return

*qload
@eval exp="fnc_load_bookmark_item_by_num_with_ask(0, true, void)"
@waittrig name="release_modal_load"
@unlock_option_tray
@return

*history
@showhistory
@return

*exit
@eval exp="fnc_exit_with_ask(true, void)"
@waittrig name="release_modal_exit"
@unlock_option_tray
@return


