@iscript
/*
kag.m_aobj_transition_layers = [];
kag.m_af_end_of_transition = [];
kag.m_ad_on_end_of_transition_cookie = [];
*/
kag.__onLayerTransitionCompleted = kag.onLayerTransitionCompleted;
kag.onLayerTransitionCompleted = function(layer, dest, src)
	{
		__onLayerTransitionCompleted(*);

		g_obj_transition_manager.notify_end_transition(layer, dest) if (g_obj_transition_manager !== void);
	} incontextof kag;

class Kappa_transition_manager extends Kappa_object_interface
	{
		var m_aobj_transition = [];

		function Kappa_transition_manager()
			{
				super.Kappa_object_interface();
			}

		function finalize()
			{
				super.finalize(*);
			}

		function post(obj_transition)
			{
				m_aobj_transition.add(obj_transition);
			}

		function notify_end_transition(obj_src_layer, obj_dst_layer)
			{
				var i;
				var u_transitions = m_aobj_transition.count;
				var obj_trans_layer;

				for (i = 0; i < u_transitions; i++)
					{
						obj_trans_layer = m_aobj_transition[i].obj_trans_layer;

						if ((obj_src_layer === obj_trans_layer) || (obj_dst_layer === obj_trans_layer))
							{
//dm(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> transition completed " + obj_src_layer.name);
								m_aobj_transition[i].notify_end_transition() if (m_aobj_transition[i] isvalid);
								m_aobj_transition.erase(i);
								break;
							}
					}

				fnc_instant_clean_up_layer(obj_src_layer);
			}
	}

var g_obj_transition_manager = new Kappa_transition_manager();


function fnc_instant_clean_up_layer(obj_layer)
	{
		if (obj_layer instanceof "CharacterLayer")
			{
//dm(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> transition completed " + obj_layer.name);
//dm(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> transition completed " + g_astr_layer_spec[obj_layer.id]);
				kag.conductor.trigger("trans_" + (string)obj_layer.id); // 'trans' 𑗂
				fnc_shallow_cleanup_layer(obj_layer.id);
			}
		else if (obj_layer instanceof "BaseLayer" && g_b_initialized)
			{
				kag.conductor.trigger("trans_base"); // 'trans' 𑗂
				fnc_shallow_cleanup_layers();
				fnc_shallow_cleanup_message_layers();
//dm(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> base_layer ");
			}
		else if (obj_layer instanceof "MessageLayer")
			{
//dm(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> transition completed " + obj_layer.name);
//dm(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> transition completed " + g_astr_layer_spec[obj_layer.id]);
				kag.conductor.trigger("trans_message_" + (string)obj_layer.id); // 'trans' 𑗂
				fnc_shallow_cleanup_message_layer(obj_layer.id);
			}
	}

class Kappa_transition extends Kappa_object_interface
	{
		var m_obj_trans_layer;
		var m_dstr_elm = %[];
		var m_f_on_end_transition;
		var m_cookie;
		var m_obj_trigger;

		function Kappa_transition(elm, d_param)
			{
				super.Kappa_object_interface();
				{
					if (d_param !== void)
						{
							m_obj_trans_layer = d_param.obj_layer;
							m_f_on_end_transition = d_param.f_on_end_transition;
							m_cookie = d_param.cookie;
						}

					(Dictionary.assign incontextof m_dstr_elm)(elm) if (elm !== void);
					m_dstr_elm.time = (string)sf.cu_trans_time if (m_dstr_elm.time === void);
					m_dstr_elm.method = "crossfade" if (m_dstr_elm.method === void);

					if (m_obj_trans_layer === void)
						m_obj_trans_layer = kag.fore.base;
				}
			}

		function finalize()
			{
				invalidate m_dstr_elm;
				super.finalize(*);
			}

		function skip_transition()
			{
				on_skip_transition();
				notify_end_transition();
				fnc_instant_clean_up_layer(m_obj_trans_layer) if (m_obj_trans_layer !== void);
			}

		function on_skip_transition()
			{
				m_obj_trans_layer.assignImages(m_obj_trans_layer.comp) if (m_obj_trans_layer !== void);
			}

		function begin_transition()
			{
				if (m_obj_trans_layer !== void)
					{
						if (m_dstr_elm.time == 0)
							{
								skip_transition();
							}
						else
							{
								m_obj_trans_layer.stopTransition();
								g_obj_transition_manager.post(this);
								m_obj_trans_layer.beginTransition(m_dstr_elm);
							}
					}
			}

		function notify_end_transition()
			{
				on_end_transition();
				m_f_on_end_transition(m_cookie) if (m_f_on_end_transition !== void);
				m_obj_trigger = new AsyncTrigger(__destroy, "");
				m_obj_trigger.trigger();
			}

		function __destroy()
			{
				invalidate m_obj_trigger if ((m_obj_trigger !== void) && (m_obj_trigger isvalid));
				m_obj_trigger = void;
				invalidate this if (this isvalid);
			}

		function on_end_transition()
			{
			}

		property obj_trans_layer
			{
				getter
					{
						return m_obj_trans_layer;
					}
			}
	}

class Kappa_base_transition extends Kappa_transition
	{
		var m_aobj_pop_layer;
		var m_obj_org_focus_layer;

		function Kappa_base_transition(elm, d_param)
			{
				super.Kappa_transition(*);

				m_aobj_pop_layer = fnc_get_all_pop_layer();

				if (!m_aobj_pop_layer.count)
					{
						invalidate m_aobj_pop_layer;
						m_aobj_pop_layer = void;
					}
				else
					{
						var ab_visible = [];
						m_obj_org_focus_layer = m_aobj_pop_layer[0].window.focusedLayer;
						fnc_set_array_value(ab_visible, true, 0, m_aobj_pop_layer.count);
						fnc_piled_copy_layers_by_spec("pop_base", m_aobj_pop_layer, ab_visible, true, true, false);
						invalidate ab_visible;
					}
			}

		function finalize()
			{
				invalidate m_aobj_pop_layer if (m_aobj_pop_layer !== void);
				super.finalize(*);
			}

		function on_end_transition()
			{
				if (m_aobj_pop_layer !== void)
					{
						var i;
						var u_layers = m_aobj_pop_layer.count;
						var u_layer_no = fnc_get_layer_no("pop_base");
						var u_opt_idx = fnc_get_layer_option_index_by_spec("pop_base");

						for (i = 0; i < u_layers; i++)
							m_aobj_pop_layer[i].visible = true;

						m_aobj_pop_layer[0].window.focusedLayer = m_obj_org_focus_layer;

						if (u_layer_no !== void)
							{
								kag.fore.layers[u_layer_no].visible = false;
								kag.back.layers[u_layer_no].visible = false;
							}

						f.astr_layer_cookie_t[u_opt_idx] = void;
						f.astr_layer_storage[u_opt_idx] = void;
					}

				super.on_end_transition();
			}

	}

class Kappa_single_base_transition extends Kappa_transition
	{
		var m_str_spec;
		var m_obj_layer;
		var m_b_visible;
		var m_b_partial = true;

		function Kappa_single_base_transition(elm, d_param)
			{
				super.Kappa_transition(*);

				m_str_spec = d_param.str_spec;
				m_obj_layer = d_param.obj_layer;
				m_b_visible = d_param.b_visible;

				if (m_dstr_elm.time == 0)
					{
						m_obj_trans_layer = void;
						skip_transition();
					}
				else
					{
						var b_partial = true;
						var b_clip = true;
						var b_aspect_size = false;

						if (m_dstr_elm.method == "rotateswap")
							{
								b_partial = false;
								b_clip = false;
							}
						else if ((m_dstr_elm.method == "rotatezoom") || (m_dstr_elm.method == "rotatevanish"))
							{
								b_aspect_size = true;
								b_clip = false;
							}

						fnc_piled_copy_layer_by_spec(m_str_spec, m_obj_layer, m_b_visible, b_partial, b_clip, b_aspect_size);
						m_obj_trans_layer = kag.fore.layers[fnc_get_layer_no(m_str_spec)];
					}
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_end_transition()
			{
				var u_layer_no = fnc_get_layer_no(m_str_spec);
				var u_opt_idx = fnc_get_layer_option_index_by_spec(m_str_spec);

				m_obj_layer.visible = m_b_visible;

				if (u_layer_no !== void)
					{
						kag.fore.layers[u_layer_no].visible = false;
						kag.back.layers[u_layer_no].visible = false;
					}

				f.astr_layer_cookie_t[u_opt_idx] = void;
				f.astr_layer_storage[u_opt_idx] = void;
				super.on_end_transition();
			}
	}

class Kappa_singles_base_transition extends Kappa_transition
	{
		var m_str_spec;
		var m_aobj_layer = [];
		var m_ab_visible = [];
		var m_b_partial = true;

		function Kappa_singles_base_transition(elm, d_param)
			{
				super.Kappa_transition(*);

				m_str_spec = d_param.str_spec;
				m_aobj_layer.assign(d_param.aobj_layer);
				m_ab_visible.assign(d_param.ab_visible);

				if (m_dstr_elm.time == 0)
					{
						m_obj_trans_layer = void;
						skip_transition();
					}
				else
					{
						var b_partial = true;
						var b_clip = true;
						var b_aspect_size = false;

						if (m_dstr_elm.method == "rotateswap")
							{
								b_partial = false;
								b_clip = false;
							}
						else if ((m_dstr_elm.method == "rotatezoom") || (m_dstr_elm.method == "rotatevanish"))
							{
								b_aspect_size = true;
								b_clip = false;
							}

						fnc_piled_copy_layers_by_spec(m_str_spec, m_aobj_layer, m_ab_visible, b_partial, b_clip, b_aspect_size);
						m_obj_trans_layer = kag.fore.layers[fnc_get_layer_no(m_str_spec)];
					}
			}

		function finalize()
			{
				invalidate m_aobj_layer;
				invalidate m_ab_visible;
				super.finalize(*);
			}

		function on_end_transition()
			{
				var i;
				var u_layers = m_aobj_layer.count;
				var u_layer_no = fnc_get_layer_no(m_str_spec);
				var u_opt_idx = fnc_get_layer_option_index_by_spec(m_str_spec);

				for (i = 0; i < u_layers; i++)
					m_aobj_layer[i].visible = m_ab_visible[i];

				if (u_layer_no !== void)
					{
						kag.fore.layers[u_layer_no].visible = false;
						kag.back.layers[u_layer_no].visible = false;
					}

				f.astr_layer_cookie_t[u_opt_idx] = void;
				f.astr_layer_storage[u_opt_idx] = void;
				super.on_end_transition();
			}
	}

/*
function fnc_base_transition_ex(elm)
	{
		var obj_snapshot_layer = new Layer(kag, kag.fore.base);

		var u_layer_no;
		var u_opt_idx = fnc_get_layer_option_index_by_spec("extra_base");
		var u_bg_layer_no = fnc_get_layer_no("wiA");

		var obj_fore_message = kag.fore.messages[0];
		var obj_back_message = kag.back.messages[0];
		var b_message_visible = obj_back_message.visible;

		var u_label_layer_no = fnc_get_layer_no("x");
		var obj_fore_label;
		var obj_back_label;
		var b_label_visible;

		var obj_fore_tray = g_obj_kappa_tray.obj_form_fore_tray;
		var obj_back_tray = g_obj_kappa_tray.obj_form_back_tray;
		var b_tray_visible = obj_back_tray.visible;

		var obj_back_layer;
		var obj_fore_layer;
		var i;
		var aobj_message = kag.back.messages;

		obj_fore_message.visible = false;
		obj_back_message.visible = false;

		if (u_label_layer_no !== void)
			{
				obj_fore_label = kag.fore.layers[u_label_layer_no];
				obj_back_label = kag.back.layers[u_label_layer_no];
				b_label_visible = obj_back_label.visible;
				obj_fore_label.visible = false;
				obj_back_label.visible = false;
			}

		obj_fore_tray.visible = false;
		obj_back_tray.visible = false;

		obj_snapshot_layer.face = dfMain;
		obj_snapshot_layer.type = ltOpaque;
		obj_snapshot_layer.setImageSize(kag.fore.base.width, kag.fore.base.height);
		obj_snapshot_layer.setSizeToImageSize();

		for (i = aobj_message.count - 1; i >= 0; i--)
			aobj_message[i].assignComp();

		obj_snapshot_layer.piledCopy(0, 0, kag.fore.base, 0, 0, kag.fore.base.width, kag.fore.base.height);

		kag.tagHandlers.stop_quake_ex(%[]);

		if (u_bg_layer_no !== void)
			{
				kag.back.layers[u_bg_layer_no].setPos(0, 0);
				kag.fore.layers[u_bg_layer_no].setPos(0, 0);
			}

		kag.tagHandlers.forelay(%[]);

		u_layer_no = fnc_alloc_layer_by_spec("extra_base");
		obj_fore_layer = kag.fore.layers[u_layer_no];
		obj_back_layer = kag.back.layers[u_layer_no];

		obj_fore_layer.visible = false;
		obj_fore_layer.setPos(0, 0);
		obj_fore_layer.face = dfMain;
		obj_fore_layer.type = ltOpaque;
		obj_fore_layer.setImageSize(kag.fore.base.width, kag.fore.base.height);
		obj_fore_layer.setSizeToImageSize();
		obj_fore_layer.absolute = obj_back_label.absolute - 1;
		obj_fore_layer.opacity = 0xff;

		obj_back_layer.visible = false;
		obj_back_layer.setPos(0, 0);
		obj_back_layer.face = dfMain;
		obj_back_layer.type = ltOpaque;
		obj_back_layer.setImageSize(kag.fore.base.width, kag.fore.base.height);
		obj_back_layer.setSizeToImageSize();
		obj_back_layer.absolute = obj_back_label.absolute - 1;
		obj_back_layer.opacity = 0xff;

		obj_fore_layer.copyRect(0, 0, obj_snapshot_layer, 0, 0, obj_snapshot_layer.width, obj_snapshot_layer.height);
		invalidate obj_snapshot_layer;
		obj_back_layer.piledCopy(0, 0, kag.fore.base, 0, 0, kag.fore.base.width, kag.fore.base.height);

		obj_fore_message.visible = b_message_visible;
		obj_back_message.visible = b_message_visible;

		if (u_label_layer_no !== void)
			{
				obj_fore_label.visible = b_label_visible;
				obj_back_label.visible = b_label_visible;
			}

		obj_fore_tray.visible = b_tray_visible;
		obj_back_tray.visible = b_tray_visible;

		obj_fore_layer.visible = true;
		obj_back_layer.visible = true;

		f.astr_layer_cookie_t[u_opt_idx] = "(extra_base)";
		f.astr_layer_storage[u_opt_idx] = "(extra_base)";
		fnc_shallow_cleanup_layers();
		f.astr_layer_cookie_t[u_opt_idx] = void;
		f.astr_layer_storage[u_opt_idx] = void;
		elm.layer = (string)fnc_get_layer_no("extra_base");
		kag.tagHandlers.trans(elm);
	}
*/

function fnc_base_transition_ex(elm)
	{
		var u_opt_idx = fnc_get_layer_option_index_by_spec("extra_base");

		fnc_piled_copy_base_by_spec("extra_base");
		fnc_shallow_cleanup_layers();
		f.astr_layer_cookie_t[u_opt_idx] = void;
		f.astr_layer_storage[u_opt_idx] = void;
		elm.layer = (string)fnc_get_layer_no("extra_base");
		kag.tagHandlers.trans(elm);
	}


@endscript


@return
