@iscript

function fnc_hiragana_to_katakana(str_hiragana)
	{
		var str_katakana = "";
		var u_idx = 0;
		var str_ch;
		var str_ck;

		while ((str_ch = str_hiragana.charAt(u_idx)) != "")
			{
				if ((str_ck = g_cu_to_katakana[str_ch]) === void)
					str_katakana += str_ch;
				else
					str_katakana += str_ck;

				u_idx++;
			}

		return str_katakana;
	}

function fnc_hiragana_to_romaji(str_hiragana)
	{
		var str_romaji = "";
		var u_idx = 0;
		var str_ch;
		var str_cr;
		var str_ch2 = str_hiragana.charAt(u_idx);

		while (str_ch2 != "")
			{
				str_ch  = str_ch2;
				str_ch2 = str_hiragana.charAt(u_idx + 1);

				if ((str_ch2 == "") || (str_ch2 == "") || (str_ch2 ==""))
					{
						str_ch += str_ch2;
						u_idx++;
						str_ch2 = str_hiragana.charAt(u_idx + 1);
					}

				if ((str_cr = g_cu_to_romaji[str_ch]) === void)
					str_romaji += str_ch;
				else
					str_romaji += str_cr;

				u_idx++;
			}

		return str_romaji;
	}

function fnc_serialize_atom(b_out, str_spec, obj_storage, obj, str_member, atom_default)
	{
//dm("str_spec = " + str_spec + "." + str_member);
//dm("serialize_atom str_member = " + str_member);
//dm((typeof obj_storage) + (typeof obj));
//dm((typeof obj_storage[str_member]) + (typeof obj[str_member]));
		if (b_out)
			{
				var obj_out;

				if (str_spec === void)
					{
						obj_out = obj_storage;
					}
				else
					{
						obj_storage[str_spec] = %[] if (obj_storage[str_spec] === void);
						obj_out = obj_storage[str_spec];
					}

				if ((obj === void) || (obj[str_member] === void))
					obj_out[str_member] = atom_default;
				else
					obj_out[str_member] = obj[str_member];
			}
		else
			{
				var obj_in;

				if (str_spec === void)
					obj_in = obj_storage;
				else
					{
						if (obj_storage === void)
							obj_in = void;
						else
							obj_in = obj_storage[str_spec];
					}

				if ((obj_in === void) || (obj_in[str_member] === void))
					obj[str_member] = atom_default;
				else
					obj[str_member] = obj_in[str_member];
			}
	}

function fnc_serialize_object(b_out, str_spec, obj_storage, obj, str_member, obj_default)
	{
//dm("str_spec = " + str_spec);
//dm("serialize_object str_member = " + str_member);
		if (b_out)
			{
				var obj_out;
				var str_next_spec;

				if (str_spec === void)
					{
						obj_out = obj_storage[str_member];
						str_next_spec = void;
					}
				else
					{
						obj_storage[str_spec] = %[] if (obj_storage[str_spec] === void);
						obj_out = obj_storage[str_spec];
						str_next_spec = str_member;
					}

				if ((obj === void) || (obj[str_member] === void))
					{
						if (obj_default !== void)
							obj_default.serialize(true, str_next_spec, obj_out);
						else
							obj_out.serialize(false, str_next_spec, void);
					}
				else
					obj[str_member].serialize(b_out, str_next_spec, obj_out);
			}
		else
			{
				var obj_in;
				var str_next_spec;

//if (obj[str_member] instanceof "Kappa_virtual_position")
//dm("obj[str_member] is Kappa_virtual_position");
				if (str_spec === void)
					{
						obj_in = obj_storage[str_member];
						str_next_spec = void;
//dm("serialize_object str_member1 = " + str_member);
//if (obj_in instanceof "Kappa_virtual_position")
//dm("obj_in is Kappa_virtual_position");
					}
				else
					{
						if (obj_storage === void)
							obj_in = void;
						else
							obj_in = obj_storage[str_spec];

						str_next_spec = str_member;
					}

				if (obj_in === void)
					{
//dm("serialize_object str_member2 = " + str_member);
						if (obj_default !== void)
							obj_default.serialize(true, str_next_spec, obj_in);
						else
							obj[str_member].serialize(false, str_next_spec, void);
					}
				else
					obj[str_member].serialize(b_out, str_next_spec, obj_in);
			}
	}

function fnc_serialize_object_array(b_out, str_spec, obj_storage, obj, str_member, f_on_new_object, d_on_new_hint)
	{
		if (str_spec === void)
			{
				if (b_out)
					{
						fnc_serialize_object_array(false, str_spec, obj, obj_storage, str_member, f_on_new_object, d_on_new_hint);
					}
				else
					{
						var aobj_src;

						if (obj_storage === void)
							aobj_src = void;
						else
							aobj_src = obj_storage[str_member];

						if (aobj_src !== void)
							{
								var i;
								var aobj_dst;
								var u_srcs;
								var u_dsts;

								u_srcs = aobj_src.count;

								if (obj[str_member] === void)
									obj[str_member] = [];

								aobj_dst = obj[str_member];
								u_dsts = aobj_dst.count;

								if (u_srcs > u_dsts)
									{
										aobj_dst.count = u_srcs;
									}
								else if (u_srcs < u_dsts)
									{
										for (i = u_srcs; i < u_dsts; i++)
											invalidate aobj_dst[i] if ((aobj_dst[i] !== void) && aobj_dst[i] isvalid);
										aobj_dst.count = u_srcs;
									}

								for (i = 0; i < u_srcs; i++)
									{
										aobj_dst[i] = f_on_new_object(d_on_new_hint) if ((aobj_dst[i] === void) || !(aobj_dst[i] isvalid));
										aobj_dst[i].serialize(b_out, void, aobj_src[i]);
									}
							}
						else
							{
								if (obj[str_member] === void)
									obj[str_member] = [];
								else
									{
										fnc_object_array_free(obj[str_member]);
										obj[str_member].count = 0;
									}
							}
					}

			}
		else
			{
				if (b_out)
					{
						var i;
						var obj_dst;
						var aobj_src = obj[str_member];
						var u_srcs = aobj_src.count;

						obj_storage[str_spec] = %[] if (obj_storage[str_spec] === void);
						obj_dst = obj_storage[str_spec];
						fnc_serialize_atom(b_out, str_member + "_count", obj_dst, aobj_src, "count");

						for (i = 0; i < u_srcs; i++)
							{
								aobj_src[i].serialize(b_out, str_member + "_" + (string)i, obj_dst);
//								fnc_serialize_object(b_out, str_member + "_" + (string)i, obj_dst, aobj_src, (string)i);
							}
					}
				else
					{
						var obj_src;

						if (obj_storage === void)
							obj_src = void;
						else
							obj_src = obj_storage[str_spec];

						if (obj_src !== void)
							{
								var i;
								var aobj_dst = %["count" => void];
								var u_srcs;
								var u_dsts;

								fnc_serialize_atom(b_out, str_member + "_count", obj_src, aobj_dst, "count");

								u_srcs = aobj_dst.count;
								(Dictionary.clear incontextof aobj_dst)();

								if (obj[str_member] === void)
									obj[str_member] = [];

								aobj_dst = obj[str_member];
								u_dsts = aobj_dst.count;

								if (u_srcs > u_dsts)
									{
										aobj_dst.count = u_srcs;
									}
								else if (u_srcs < u_dsts)
									{
										for (i = u_srcs; i < u_dsts; i++)
											invalidate aobj_dst[i] if ((aobj_dst[i] !== void) && aobj_dst[i] isvalid);
										aobj_dst.count = u_srcs;
									}

								for (i = 0; i < u_srcs; i++)
									{
										aobj_dst[i] = f_on_new_object(d_on_new_hint) if ((aobj_dst[i] === void) || !(aobj_dst[i] isvalid));
										aobj_dst[i].serialize(b_out, str_member + "_" + (string)i, obj_src);
//										fnc_serialize_object(b_out, str_member + "_" + (string)i, obj_src, aobj_dst, (string)i);
									}
							}
						else
							{
								if (obj[str_member] === void)
									obj[str_member] = [];
								else
									{
										fnc_object_array_free(obj[str_member]);
										obj[str_member].count = 0;
									}
							}
					}
			}
	}

function fnc_object_array_free(aobj)
	{
		if ((aobj !== void) && (aobj isvalid))
			{
				var i;
				var u_aobjs = aobj.count;

				for(i = 0; i < u_aobjs; i++)
					{
						if ((aobj[i] !== void) && (aobj[i] isvalid))
							invalidate aobj[i];
					}
			}
	}

function fnc_set_array_value(obj_array, value, u_offset, u_size)
	{
		var i;
		var u_end_of_loop = u_offset + u_size;

		for(i = u_offset; i < u_end_of_loop; i++)
			obj_array[i] = value;
	}

function fnc_set_all_array_value(obj_array, value)
	{
		fnc_set_array_value(obj_array, value, 0, obj_array.count);
	}

function fnc_copy_array_value(obj_array_src, u_array_src_offset, obj_array_dst, u_array_dst_offset, u_size)
	{
		var i;

		for(i = 0; i < u_size; i++)
			obj_array_dst[i + u_array_dst_offset] = obj_array_src[i + u_array_src_offset];
	}

function fnc_set_object_array_value(obj_object_array, str_property, value, u_offset, u_size)
	{
		var i;
		var u_end_of_loop = u_offset + u_size;

		for(i = u_offset; i < u_end_of_loop; i++)
			obj_object_array[i][str_property] = value;
	}

function fnc_set_all_object_array_value(obj_object_array, str_property, value)
	{
		fnc_set_object_array_value(obj_object_array, str_property, value, 0, obj_object_array.count);
	}

function fnc_draw_screen_shot(obj_dst_layer, aobj_src_layer, obj_src_bg_layer)
	{
		var i;
		var j;
		var u_src_layers = aobj_src_layer.count;
		var obj_src_layer;

		var i_rel_x;
		var i_rel_y;
		var i_clip_x;
		var i_clip_y;

		var u_width;
		var u_height;

		var u_screen_width  = obj_src_bg_layer.width;
		var u_screen_height = obj_src_bg_layer.height;

		var d_z_index;
		var ad_z_index = [];
		var au_inv_z_index = [];
		var u_z_indexes;
		var u_key;

		obj_dst_layer.setImageSize(u_screen_width, u_screen_height);
		obj_dst_layer.setSizeToImageSize();
		obj_dst_layer.copyRect(0, 0, obj_src_bg_layer, 0, 0, u_screen_width, u_screen_height);

		for (i = 0; i < u_src_layers; i++)
			{
				obj_src_layer = aobj_src_layer[i];

				i_rel_x = obj_src_layer.top  - obj_src_bg_layer.top;
				i_rel_y = obj_src_layer.left - obj_src_bg_layer.left;

				if (!obj_src_layer.visible
						|| (i_rel_x <= -obj_dst_layer.width)
						|| (i_rel_x >= u_screen_width)
						|| (i_rel_y <= -obj_dst_layer.height)
						|| (i_rel_y >= u_screen_height)
						|| (obj_src_layer.opacity == 0))
					continue;

				d_z_index = %[];
				d_z_index.u_idx  = i;
				d_z_index.u_key  = obj_src_layer.absolute;
				d_z_index.b_done = false;

				ad_z_index.add(d_z_index);
				au_inv_z_index.add(d_z_index.u_key);
			}

		au_inv_z_index.sort();
		u_z_indexes = ad_z_index.count;

		for (i = 0; i < u_z_indexes; i++)
			{
				u_key = au_inv_z_index[i];

				for (j = 0; j < u_z_indexes; j++)
					{
						d_z_index = ad_z_index[j];

						if (!d_z_index.b_done && (d_z_index.u_key == u_key))
							break;
					}

				obj_src_layer = aobj_src_layer[d_z_index.u_idx];

				i_clip_x = 0;
				i_clip_y = 0;
				i_rel_x  = obj_src_layer.left - obj_src_bg_layer.left;
				i_rel_y  = obj_src_layer.top  - obj_src_bg_layer.top;
				u_width  = obj_src_layer.width;
				u_height = obj_src_layer.height;

				if (i_rel_x < 0)
					{
						u_width  += i_rel_x;
						i_clip_x -= i_rel_x;
						i_rel_x   = 0;
					}

				if (i_rel_y < 0)
					{
						u_height += i_rel_y;
						i_clip_y -= i_rel_y;
						i_rel_y   = 0;
					}

				if ((i_rel_x + u_width) > u_screen_width)
					u_width -= ((i_rel_x + u_width) - u_screen_width);

				if ((i_rel_y + u_height) > u_screen_height)
					u_height -= ((i_rel_y + u_height) - u_screen_height);

				obj_dst_layer.operateRect(i_rel_x, i_rel_y, obj_src_layer, i_clip_x, i_clip_y, u_width, u_height);
				d_z_index.b_done = true;
			}

		for (i = 0; i < u_z_indexes; i++)
			invalidate ad_z_index[i];

		invalidate ad_z_index;
		invalidate au_inv_z_index;
	}

function fnc_to_short_weekday_En(u_week_num)
	{
		switch(u_week_num)
			{
				case 0:
					return "Sun";
				case 1:
					return "Mon";
				case 2:
					return "Tue";
				case 3:
					return "Wed";
				case 4:
					return "Thu";
				case 5:
					return "Fri";
				case 6:
					return "Sat";
				default:
					return "(`)";
			}
	}


function fnc_set_volume(u_volume)
	{
		var u_vol;
		var i;
		var u_bgms = sf.au_bgm_volume.count;
		var u_ses  = sf.au_se_volume.count;

		if (u_volume === void)
			u_vol = sf.u_volume;
		else
			u_vol = (int)u_volume;

		if (u_vol > 100)
			sf.u_volume = 100;
		else if (u_vol < 0)
			sf.u_volume = 0;
		else
			sf.u_volume = u_vol;

		for (i = 0; i < u_bgms; i++)
			fnc_set_bgm_volume(i, void);

		for (i = 0; i < u_ses; i++)
			fnc_set_se_volume(i, void);
	}

function fnc_get_volume()
	{
		return sf.u_volume;
	}

function fnc_set_mute(b_mute_all)
	{
		var b_mute;
		var i;
		var u_bgms = sf.ab_bgm_mute.count;
		var u_ses  = sf.ab_se_mute.count;

		if (b_mute_all === void)
			b_mute = sf.u_mute;
		else
			b_mute = (int)b_mute_all;

		if (sf.b_mute !== b_mute)
			{
				sf.b_mute = b_mute;

				if (b_mute)
					{
						for (i = 0; i < u_bgms; i++)
							__fnc_co_bgm(i);

						for (i = 0; i < u_ses; i++)
							__fnc_co_se(i);
					}
				else
					{
						for (i = 0; i < u_bgms; i++)
							{
								if (!sf.ab_bgm_mute[i])
									{
										if (f.astr_bgm_storage[i] !== void)
											__fnc_ci_bgm(i, f.astr_bgm_storage[i], true);
									}
							}

						for (i = 0; i < u_ses; i++)
							{
								if (!sf.ab_se_mute[i])
									{
										if (f.astr_se_storage[i] !== void)
											__fnc_ci_se(i, f.astr_se_storage[i], true);
									}
							}
					}
			}


	}

function fnc_is_mute()
	{
		return sf.b_mute;
	}

function fnc_set_bgm_volume(u_stream_seq, u_volume)
	{
		var u_seq = 0;
		var u_vol;

		if (u_stream_seq !== void)
			u_seq = (int)u_stream_seq;

		if (u_volume === void)
			u_vol = sf.au_bgm_volume[u_seq];
		else
			u_vol = (int)u_volume;

		if (u_vol > 100)
			sf.au_bgm_volume[u_seq] = 100;
		else if (u_vol < 0)
			sf.au_bgm_volume[u_seq] = 0;
		else
			sf.au_bgm_volume[u_seq] = u_vol;

		u_vol = (int)(sf.au_bgm_volume[u_seq] * sf.u_volume \ 100);

		if (u_vol != kag.bgm.buf1.volume2)
			kag.tagHandlers.bgmopt(%["gvolume" => (string)u_vol]);
	}

function fnc_get_bgm_volume(u_stream_seq)
	{
		var u_seq = 0;

		if (u_stream_seq !== void)
			u_seq = (int)u_stream_seq;

		return sf.au_bgm_volume[u_seq];
	}

function fnc_set_bgm_mute(u_stream_seq, b_mute_bgm)
	{
		var u_seq = 0;
		var b_mute;

		if (u_seq !== void)
			u_seq = (int)u_stream_seq;

		if (b_mute_bgm !== void)
			b_mute = (int)b_mute_bgm;
		else
			b_mute = sf.ab_bgm_mute[u_seq];

		if (b_mute != sf.ab_bgm_mute[u_seq])
			{
				sf.ab_bgm_mute[u_seq] = b_mute;

				if (!sf.b_mute)
					{
						if (sf.ab_bgm_mute[u_seq])
							{
								__fnc_co_bgm(u_seq);
							}
						else
							{
								if (f.astr_bgm_storage[u_seq] !== void)
									__fnc_ci_bgm(u_seq, f.astr_bgm_storage[u_seq], true);
							}
					}
			}
	}

function fnc_bgm_is_mute(u_stream_seq)
	{
		var u_seq = 0;

		if (u_stream_seq !== void)
			u_seq = (int)u_stream_seq;

		return sf.ab_bgm_mute[u_seq];
	}

function fnc_restore_bgm(u_stream_seq)
	{
		if (sf.b_mute || sf.ab_bgm_mute[u_stream_seq])
			{
				if (f.ab_bgm_playing[u_stream_seq])
					__fnc_co_bgm(u_stream_seq);
			}
		else
			{
				if (!f.ab_bgm_playing[u_stream_seq] && (f.astr_bgm_storage[u_stream_seq] !== void))
					__fnc_ci_bgm(u_stream_seq, f.astr_bgm_storage[u_stream_seq], true);
				else
					{
						if (!f.ab_bgm_playing[u_stream_seq])
							__fnc_co_bgm(u_stream_seq);
					}
			}
	}

function fnc_restore_all_bgm(u_stream_seq)
	{
		var i;
		var u_bgms = sf.ab_bgm_mute.count;

		for (i = 0; i < u_bgms; i++)
			fnc_restore_bgm(i);
	}

function fnc_restore_se(u_stream_seq)
	{
		if (sf.b_mute || sf.ab_se_mute[u_stream_seq])
			{
				if (f.ab_se_playing[u_stream_seq])
					__fnc_co_se(u_stream_seq);
			}
		else
			{
				if (!f.ab_se_playing[u_stream_seq] && (f.astr_se_storage[u_stream_seq] !== void))
					__fnc_ci_se(u_stream_seq, f.astr_se_storage[u_stream_seq], true);
				else
					{
						if (!f.ab_se_playing[u_stream_seq])
							{
								if (kag.se[u_stream_seq].looping)
									__fnc_co_se(u_stream_seq);
							}
					}
			}
	}

function fnc_restore_all_se(u_stream_seq)
	{
		var i;
		var u_ses = sf.ab_se_mute.count;

		for (i = 0; i < u_ses; i++)
			fnc_restore_se(i);
	}

function fnc_ci_bgm(u_stream_seq, str_storage, b_bgm_loop)
	{
		var u_seq = 0;
		var b_loop = true;

		if (u_stream_seq !== void)
			u_seq = (int)u_stream_seq;
		if (b_bgm_loop !== void)
			b_loop = (int)b_bgm_loop;

		if (b_loop)
			f.astr_bgm_storage[u_seq] = (string)str_storage;
		else
			f.astr_bgm_storage[u_seq] = void;

		if (!sf.b_mute && !sf.ab_bgm_mute[u_seq])
			__fnc_ci_bgm(u_seq, str_storage, b_loop);
	}

function __fnc_ci_bgm(u_stream_seq, str_storage, b_bgm_loop)
	{
		kag.tagHandlers.playbgm(%["storage" => (string)str_storage, "loop" => b_bgm_loop ? "true" : "false"]);
		if (b_bgm_loop)
			f.ab_bgm_playing[u_stream_seq] = true;
		else
			f.ab_bgm_playing[u_stream_seq] = false;
	}

function fnc_switch_bgm(u_stream_seq, str_storage, b_bgm_loop, u_bgm_f_time, u_bgm_ol_time, u_bgm_volume)
	{
		var u_seq = 0;
		var b_loop = true;
		var u_f_time = sf.cu_bgm_f_time;
		var u_ol_time = sf.cu_bgm_ol_time;
		var u_volume = void;

		if (u_stream_seq !== void)
			u_seq = (int)u_stream_seq;
		if (b_bgm_loop !== void)
			b_loop = (int)b_bgm_loop;
		if (u_bgm_f_time !== void)
			u_f_time = (int)u_bgm_f_time;
		if (u_bgm_ol_time !== void)
			u_ol_time = (int)u_bgm_ol_time;
		if (u_bgm_volume !== void)
			u_volume = (int)u_bgm_volume;

		if (b_loop)
			f.astr_bgm_storage[u_seq] = (string)str_storage;
		else
			f.astr_bgm_storage[u_seq] = void;

		if (!sf.b_mute && !sf.ab_bgm_mute[u_seq])
			__fnc_switch_bgm(u_seq, str_storage, b_loop, u_f_time, u_ol_time, u_volume);
	}

function __fnc_switch_bgm(u_stream_seq, str_storage, b_bgm_loop, u_bgm_f_time, u_bgm_ol_time, u_bgm_volume)
	{
		if (u_bgm_f_time == 0 || kag.skipMode)
			{
				if (u_bgm_volume !== void)
					{
						kag.tagHandlers.bgmopt(%["volume" => (string)u_bgm_volume]);
					}

				kag.tagHandlers.playbgm(%["storage" => (string)str_storage, "loop" => b_bgm_loop ? "true" : "false"]);
			}
		else
			{
				if (u_bgm_volume === void)
					{
						kag.tagHandlers.xchgbgm(%["storage" => (string)str_storage, "loop" => b_bgm_loop ? "true" : "false",
							"time" => (string)u_bgm_f_time, "overlap" => (string)u_bgm_ol_time]);
					}
				else
					{
						kag.tagHandlers.xchgbgm(%["storage" => (string)str_storage, "loop" => b_bgm_loop ? "true" : "false",
							"time" => (string)u_bgm_f_time, "overlap" => (string)u_bgm_ol_time, "volume" => (string)u_bgm_volume]);
					}
			}

		if (b_bgm_loop)
			f.ab_bgm_playing[u_stream_seq] = true;
		else
			f.ab_bgm_playing[u_stream_seq] = false;
	}

function fnc_fo_bgm(u_stream_seq, u_fo_time)
	{
		var u_seq = 0;
		var u_time = sf.cu_bgm_fo_time;

		if (u_stream_seq !== void)
			u_seq = (int)u_stream_seq;
		if (u_fo_time !== void)
			u_time = (int)u_fo_time;

		f.astr_bgm_storage[u_seq] = void;
		__fnc_fo_bgm(u_seq, u_time);
	}

function __fnc_fo_bgm(u_stream_seq, u_fo_time)
	{
		if (u_fo_time == 0 || kag.skipMode)
			{
				__fnc_co_bgm(u_stream_seq);
			}
		else
			{
				kag.tagHandlers.fadeoutbgm(%["time" => (string)u_fo_time]);
				f.ab_bgm_playing[u_stream_seq] = false;
			}
	}

function fnc_co_bgm(u_stream_seq)
	{
		var u_seq = 0;

		if (u_stream_seq !== void)
			u_seq = (int)u_stream_seq;

		f.astr_bgm_storage[u_seq] = void;
		__fnc_co_bgm(u_seq);
	}

function __fnc_co_bgm(u_stream_seq)
	{
		kag.tagHandlers.stopbgm(%[]);
		f.ab_bgm_playing[u_stream_seq] = false;
	}

function fnc_set_se_volume(u_stream_seq, u_volume)
	{
		var u_vol;
		var u_seq = 0;

		if (u_stream_seq !== void)
			u_seq = (int)u_stream_seq;

		if (u_volume === void)
			u_vol = sf.au_se_volume[u_seq];
		else
			u_vol = (int)u_volume;

		if (u_vol > 100)
			sf.au_se_volume[u_seq] = 100;
		else if (u_vol < 0)
			sf.au_se_volume[u_seq] = 0;
		else
			sf.au_se_volume[u_seq] = u_vol;

		u_vol = (int)(sf.au_se_volume[u_seq] * sf.u_volume \ 100);

		if (u_vol != kag.se[u_seq].volume2)
			kag.tagHandlers.seopt(%["buf" => (string)u_seq, "gvolume" => (string)u_vol]);
	}

function fnc_get_se_volume(u_stream_seq)
	{
		var u_seq = 0;

		if (u_stream_seq !== void)
			u_seq = (int)u_stream_seq;

		return sf.au_se_volume[u_seq];
	}

function fnc_set_se_mute(u_stream_seq, b_mute_se)
	{
		var u_seq = 0;
		var b_mute;

		if (u_seq !== void)
			u_seq = (int)u_stream_seq;

		if (b_mute_se !== void)
			b_mute = (int)b_mute_se;
		else
			b_mute = sf.ab_se_mute[u_seq];

		if (b_mute != sf.ab_se_mute[u_seq])
			{
				sf.ab_se_mute[u_seq] = b_mute;

				if (!sf.b_mute)
					{
						if (sf.ab_se_mute[u_seq])
							{
								__fnc_co_se(u_seq);
							}
						else
							{
								if (f.astr_se_storage[u_seq] !== void)
									__fnc_ci_se(u_seq, f.astr_se_storage[u_seq], true);
							}
					}
			}
	}

function fnc_se_is_mute(u_stream_seq)
	{
		var u_seq = 0;

		if (u_stream_seq !== void)
			u_seq = (int)u_stream_seq;

		return sf.ab_se_mute[u_seq];
	}

function fnc_ci_se(u_stream_seq, str_storage, b_se_loop)
	{
		var u_seq = 0;
		var b_loop = false;

		if (u_stream_seq !== void)
			u_seq = (int)u_stream_seq;
		if (b_se_loop !== void)
			b_loop = (int)b_se_loop;

		if (b_loop)
			f.astr_se_storage[u_seq] = (string)str_storage;
		else
			f.astr_se_storage[u_seq] = void;

		if (!sf.b_mute && !sf.ab_se_mute[u_seq])
			__fnc_ci_se(u_seq, str_storage, b_loop);
	}

function __fnc_ci_se(u_stream_seq, str_storage, b_se_loop)
	{
		kag.tagHandlers.playse(%["buf" => (string)u_stream_seq, "storage" => (string)str_storage, "loop" => b_se_loop ? "true" : "false"]);
		f.ab_se_playing[u_stream_seq] = +b_se_loop ? true : false;
	}

function fnc_fi_se(u_stream_seq, str_storage, b_se_loop, u_fi_time)
	{
		var u_seq = 0;
		var u_time = sf.cu_se_fi_time;
		var b_loop = false;

		if (u_stream_seq !== void)
			u_seq = (int)u_stream_seq;
		if (b_se_loop !== void)
			b_loop = (int)b_se_loop;
		if (u_fi_time !== void)
			u_time = (int)u_fi_time;

		if (b_loop)
			f.astr_se_storage[u_seq] = (string)str_storage;
		else
			f.astr_se_storage[u_seq] = void;

		if (!sf.b_mute && !sf.ab_se_mute[u_seq])
			__fnc_fi_se(u_seq, str_storage, b_loop, u_time);
	}

function __fnc_fi_se(u_stream_seq, str_storage, b_se_loop, u_fi_time)
	{
		if (u_fi_time == 0 || kag.skipMode)
			{
				__fnc_ci_se(u_stream_seq, str_storage, b_se_loop);
			}
		else
			{
				__fnc_co_se(u_stream_seq);
				kag.tagHandlers.fadeinse(%["buf" => (string)u_stream_seq, "storage" => (string)str_storage, "time" => (string)u_fi_time, "loop" => b_se_loop ? "true" : "false"]);
				f.ab_se_playing[u_stream_seq] = +b_se_loop ? true : false;
			}
	}

function fnc_fo_se(u_stream_seq, u_fo_time)
	{
		var u_seq = 0;
		var u_time = sf.cu_se_fo_time;

		if (u_stream_seq !== void)
			u_seq = (int)u_stream_seq;
		if (u_fo_time !== void)
			u_time = (int)u_fo_time;

		f.astr_se_storage[u_seq] = void;

		if (!sf.b_mute && !sf.ab_se_mute[u_seq])
			__fnc_fo_se(u_seq, u_time);
	}

function __fnc_fo_se(u_stream_seq, u_fo_time)
	{
		if (u_fo_time == 0 || kag.skipMode)
			{
				__fnc_co_se(u_stream_seq);
			}
		else
			{
				kag.tagHandlers.fadeoutse(%["buf" => (string)u_stream_seq, "time" => (string)u_fo_time]);
				f.ab_se_playing[u_stream_seq] = false;
			}
	}

function fnc_co_se(u_stream_seq)
	{
		var u_seq = 0;

		if (u_stream_seq !== void)
			u_seq = (int)u_stream_seq;

		f.astr_se_storage[u_seq] = void;

		if (!sf.b_mute && !sf.ab_se_mute[u_seq])
			__fnc_co_se(u_seq);
	}

function __fnc_co_se(u_stream_seq)
	{
		kag.tagHandlers.stopse(%["buf" => (string)u_stream_seq]);
		f.ab_se_playing[u_stream_seq] = false;
	}


function fnc_cv_se(u_stream_seq, u_volume)
	{
		var u_seq  = 0;
		var u_vol  = 100;

		if (u_stream_seq !== void)
			u_seq = (int)u_stream_seq;
		if (u_volume !== void)
			u_vol = (int)u_volume;

		__fnc_cv_se(u_seq, u_vol);
	}

function __fnc_cv_se(u_stream_seq, u_volume)
	{
		kag.tagHandlers.seopt(%["buf" => (string)u_stream_seq, "volume" => (string)u_volume]);
	}

function fnc_fv_se(u_stream_seq, u_volume, u_fv_time)
	{
		var u_seq  = 0;
		var u_vol  = 100;
		var u_time = sf.cu_se_fv_time;

		if (u_stream_seq !== void)
			u_seq = (int)u_stream_seq;
		if (u_volume !== void)
			u_vol = (int)u_volume;
		if (u_fv_time !== void)
			u_time = (int)u_fv_time;

		__fnc_fv_se(u_seq, u_vol, u_time);
	}

function __fnc_fv_se(u_stream_seq, u_volume, u_fv_time)
	{
		if (u_fv_time == 0 || kag.skipMode)
			{
				__fnc_cv_se(u_stream_seq, u_volume);
			}
		else
			{
				kag.tagHandlers.fadese(%["buf" => (string)u_stream_seq, "volume" => (string)u_volume, "time" => (string)u_fv_time]);
			}
	}

function fnc_get_wait_time_char()
	{
		return (sf.u_wait_time_char = kag.userChSpeed);
	}

function fnc_set_wait_time_char(u_wait_time)
	{
		sf.u_wait_time_char = u_wait_time;
		kag.userChSpeed = sf.u_wait_time_char;
		kag.setUserSpeed();
	}

function fnc_is_no_wait_eol()
	{
		return (sf.b_no_wait_eol = kag.chNonStopToPageBreak);
	}

function fnc_set_no_wait_eol(b_no_wait)
	{
		sf.b_no_wait_eol = b_no_wait;
		kag.chNonStopToPageBreak = sf.b_no_wait_eol;
	}


function fnc_get_already_read_wait_time_char()
	{
		if (kag.userCh2ndSpeed < 0)
			return sf.u_already_read_wait_time_char;
		else
			return (sf.u_already_read_wait_time_char = kag.userCh2ndSpeed);
	}

function fnc_set_already_read_wait_time_char(u_wait_time)
	{
		sf.u_already_read_wait_time_char = u_wait_time;

		if (kag.userCh2ndSpeed >= 0)
			kag.userCh2ndSpeed = sf.u_already_read_wait_time_char;

		kag.setUserSpeed();
	}

function fnc_is_already_read_wait_time_char_equivalent()
	{
		if (kag.userCh2ndSpeed < 0)
			return (sf.b_already_read_wait_time_char_equivalent = 1);
		else
			return (sf.b_already_read_wait_time_char_equivalent = 0);
	}

function fnc_set_already_read_wait_time_char_equivalent(b_equivalent)
	{
		sf.b_already_read_wait_time_char_equivalent = b_equivalent;

		if (sf.b_already_read_wait_time_char_equivalent)
			kag.userCh2ndSpeed = -1;
		else
			kag.userCh2ndSpeed = sf.u_already_read_wait_time_char;

		kag.setUserSpeed();
	}

function fnc_is_already_read_no_wait_eol()
	{
		return (sf.b_already_read_no_wait_eol = kag.ch2ndNonStopToPageBreak);
	}

function fnc_set_already_read_no_wait_eol(b_no_wait)
	{
		sf.b_already_read_no_wait_eol = b_no_wait;
		kag.ch2ndNonStopToPageBreak = sf.b_already_read_no_wait_eol;
	}

function fnc_get_pause_time()
	{
		return sf.u_pause_time;
	}

function fnc_set_pause_time(u_pause_time)
	{
		sf.u_pause_time = u_pause_time;
	}

function fnc_get_auto_read_wait_time_eol()
	{
		return (sf.u_auto_read_wait_time_eol = kag.autoModeLineWait);
	}

function fnc_set_auto_read_wait_time_eol(u_wait_time)
	{
		sf.u_auto_read_wait_time_eol = u_wait_time;
		kag.autoModeLineWait = sf.u_auto_read_wait_time_eol;
	}

function fnc_get_auto_read_wait_time_eop()
	{
		return (sf.u_auto_read_wait_time_eop = kag.autoModePageWait);
	}

function fnc_set_auto_read_wait_time_eop(u_wait_time)
	{
		sf.u_auto_read_wait_time_eop = u_wait_time;
		kag.autoModePageWait = sf.u_auto_read_wait_time_eop;
	}

function fnc_is_full_screen()
	{
		return (sf.b_full_screen = kag.fullScreened);
	}

function fnc_set_full_screen(b_full_screen)
	{
		sf.b_full_screen = b_full_screen;

		if (b_full_screen)
			{
				if (!kag.fullScreened)
					{
						try
							{
								kag.fullScreen = true;
							}
						catch(e)
							{
								Debug.notice("tXN[[hɈڍsł܂ł : " + e.message);
							}

						kag.fullScreened = kag.fullScreen;
					}
			}
		else
			{
				if (kag.fullScreened)
					{
						try
							{
								kag.fullScreen = false;
							}
						catch(e)
							{
								Debug.notice("EBhE[hɈڍsł܂ł : " + e.message);
							}

						kag.fullScreened = kag.fullScreen;
					}
			}

		kag.saveSystemVariables();
	}

function fnc_alpha_to_add_alpha(u_color)
	{
		var u_opacity = u_color >> 24;
		return (u_opacity << 24) +
							((int)((((u_color & 0xff0000) >>16) * u_opacity) / 255) << 16) +
							((int)((((u_color & 0x00ff00) >> 8) * u_opacity) / 255) <<  8) +
							((int)((((u_color & 0x0000ff)     ) * u_opacity) / 255));
	}

function fnc_get_min_max_format_string(i_min_value, i_max_value, r_ratio, u_floor)
	{
		var u_max_nfloor = (int)(Math.log(Math.abs(i_max_value * r_ratio) + 0.1) / Math.log(10)) + 1;
		var u_min_nfloor = (int)(Math.log(Math.abs(i_min_value * r_ratio) + 0.1) / Math.log(10)) + 1;

		u_max_nfloor++ if (i_max_value < 0);
		u_min_nfloor++ if (i_min_value < 0);

		if (u_floor)
			{
				u_max_nfloor += (u_floor + 1);
				u_min_nfloor += (u_floor + 1);
			}

		if (!u_floor)
			return "%%%dd".sprintf((u_max_nfloor > u_min_nfloor) ? u_max_nfloor : u_min_nfloor);
		else
			return "%%%d.%df".sprintf(((u_max_nfloor > u_min_nfloor) ? u_max_nfloor : u_min_nfloor), u_floor);
	}

function fnc_select_color(f_on_ok, f_on_cancel, f_on_update, cookie, b_alpha, u_color)
	{
		var d_param = %[];
		var obj_dlg;

		d_param.f_on_ok = f_on_ok;
		d_param.f_on_cancel = f_on_cancel;
		d_param.f_on_update = f_on_update;
		d_param.u_color = u_color;
		d_param.b_alpha = b_alpha;
		d_param.cookie = cookie;

		obj_dlg = new Kappa_color_dialog(kag, kag.fore.base, false, d_param);
		invalidate d_param;
		obj_dlg.show(void, void);
	}

function fnc_stop()
	{
		kag.stopAllTransitions();
		kag.stopAllMoves();
		fnc_stop_cursor_move();
	}

function fnc_dump_omit_layers()
	{
		var i;
		var aobj_layer = g_obj_omit_layer.children;
		var u_layers = aobj_layer.count;

		dm("OMIT@LAYER MAP (Total = %d)================================================".sprintf(u_layers));
		for (i = 0; i < u_layers; i++)
			dm(aobj_layer[i]);
		dm("======================================================================");
	}

@endscript



@return
