@iscript


class Kappa_volume_sheet extends Kappa_application_sheet
	{
		function Kappa_volume_sheet(window, parent, b_notify, d_param)
			{
				super.Kappa_application_sheet(window, parent, b_notify, d_param);

				var i_left = 96;
				var i_top  = 96;
				var u_pad  = 6;

				i_top = create_volume_ctrl("all", i_left, i_top,
					"S", "S",
					fnc_get_volume(0), fnc_is_mute(0));

				i_top += u_pad * 2;

				i_top = create_volume_ctrl("bgm", i_left, i_top,
					"BGM", "BGM",
					fnc_get_bgm_volume(0), fnc_bgm_is_mute(0));

				i_top += u_pad * 2;

				i_top = create_volume_ctrl("voice", i_left, i_top,
					"", "",
					fnc_get_se_volume(g_cu_voice_offset), fnc_se_is_mute(g_cu_voice_offset));
				i_top += u_pad * 2;

				i_top = create_volume_ctrl("se", i_left, i_top,
					"ʉ", "ʉ",
					fnc_get_se_volume(0), fnc_se_is_mute(0));

				i_top += u_pad * 2;

				i_top = create_volume_ctrl("sys_se", i_left, i_top,
					"VXeʉ", "}EX̃NbNȂ",
					fnc_get_se_volume(2), fnc_se_is_mute(2));

				on_commit_all_mute(m_obj_chk_all_mute);
				m_obj_sld_all_volume.enabled = !(m_obj_chk_all_mute.u_state);

				do_v_center_children();
			}

		function finalize()
			{
				super.finalize(*);
			}

		function on_commit_all_volume(obj_sender_layer)
			{
				fnc_set_volume(obj_sender_layer.i_value);
			}

		function on_commit_all_mute(obj_sender_layer)
			{
				fnc_set_mute(obj_sender_layer.u_state);
				m_obj_sld_bgm_volume.enabled = !(m_obj_chk_bgm_mute.u_state || m_obj_chk_all_mute.u_state);
				m_obj_sld_se_volume.enabled = !(m_obj_chk_se_mute.u_state || m_obj_chk_all_mute.u_state);
				m_obj_sld_sys_se_volume.enabled = !(m_obj_chk_sys_se_mute.u_state || m_obj_chk_all_mute.u_state);
				m_obj_sld_voice_volume.enabled = !(m_obj_chk_voice_mute.u_state || m_obj_chk_all_mute.u_state);
				m_obj_chk_bgm_mute.enabled = !(m_obj_chk_all_mute.u_state);
				m_obj_chk_se_mute.enabled = !(m_obj_chk_all_mute.u_state);
				m_obj_chk_sys_se_mute.enabled = !(m_obj_chk_all_mute.u_state);
				m_obj_chk_voice_mute.enabled = !(m_obj_chk_all_mute.u_state);
			}

		function on_commit_bgm_volume(obj_sender_layer)
			{
				fnc_set_bgm_volume(0, obj_sender_layer.i_value);
			}

		function on_commit_bgm_mute(obj_sender_layer)
			{
				fnc_set_bgm_mute(0, obj_sender_layer.u_state);
			}

		function on_commit_se_volume(obj_sender_layer)
			{
				fnc_set_se_volume(0, obj_sender_layer.i_value);
				fnc_set_se_volume(1, obj_sender_layer.i_value);
			}

		function on_commit_se_mute(obj_sender_layer)
			{
				fnc_set_se_mute(0, obj_sender_layer.u_state);
				fnc_set_se_mute(1, obj_sender_layer.u_state);
			}

		function on_commit_sys_se_volume(obj_sender_layer)
			{
				fnc_set_se_volume(2, obj_sender_layer.i_value);
			}

		function on_commit_sys_se_mute(obj_sender_layer)
			{
				fnc_set_se_mute(2, obj_sender_layer.u_state);
			}

		function on_commit_voice_volume(obj_sender_layer)
			{
				fnc_set_se_volume(g_cu_voice_offset, obj_sender_layer.i_value);
			}

		function on_commit_voice_mute(obj_sender_layer)
			{
				fnc_set_se_mute(g_cu_voice_offset, obj_sender_layer.u_state);
			}

		function create_volume_ctrl(str_spec, i_left, i_top, str_text, str_hint, u_volume, b_mute)
			{
				var obj_lbl;
				var obj_chk;
				var obj_sld;
				var i_x_pos = i_left;
				var i_y_pos = i_top;
				var i_tab = 32;
				var u_pad  = 6;

				obj_lbl = create_static_label(i_x_pos, i_y_pos, str_text);

				i_y_pos += obj_lbl.height;
				i_y_pos += u_pad;
				i_x_pos = i_left;

				obj_sld = this["m_obj_sld_" + str_spec + "_volume"] = create_volume_h_slider(
					i_x_pos + i_tab, i_y_pos, width - (i_left + i_tab) * 2,
					str_hint + "̉ʂ𒲐܂",
					u_volume, this["on_commit_" + str_spec + "_volume"]);

				i_y_pos += obj_sld.height;
				i_y_pos += u_pad \ 2;
				i_x_pos = i_left;

				obj_chk = this["m_obj_chk_" + str_spec + "_mute"] = create_check_button(i_x_pos + i_tab, i_y_pos,
					"~[g", str_hint + "܂",
					b_mute, __on_commit_check);
				obj_chk.d_cookie.str_spec = str_spec;
				return (i_y_pos + obj_chk.height);
			}

		function __on_commit_check(obj_sender_layer)
			{
				this["m_obj_sld_" + obj_sender_layer.d_cookie.str_spec + "_volume"].enabled = !(obj_sender_layer.u_state || m_obj_chk_all_mute.u_state);
				this["on_commit_" + obj_sender_layer.d_cookie.str_spec + "_mute"](*);
			}
	}


@endscript

@return

