@iscript

class Kappa_widget_ctrl_interface extends Kappa_widget_interface
	{
		var m_u_left_outer_pad = 0;
		var m_u_right_outer_pad = 0;
		var m_u_top_outer_pad = 0;
		var m_u_bottom_outer_pad = 0;
		var m_u_left_inner_pad = 0;
		var m_u_right_inner_pad = 0;
		var m_u_top_inner_pad = 0;
		var m_u_bottom_inner_pad = 0;
		var m_u_draw_id = 0xffffffff;
		var m_b_transparent_parent_update = false;

		var m_obj_bind_widget;

		function Kappa_widget_ctrl_interface(obj_super_layer, b_notify_parent)
			{
				Kappa_widget_interface(obj_super_layer, b_notify_parent);

				focusable    = true;
				hitType      = htMask;

				str_cursor_enter_se_storage = "se_998.wav";
				u_cursor_enter_se_stream_seq = 2;
			}

		function finalize()
			{
				super.finalize(*);
			}

		function bind(obj_widget)
			{
				m_obj_bind_widget = obj_widget;
			}

		function get_id()
			{
				return on_get_id();
			}

		function fit_font_size()
			{
				on_fit_font_size();
			}

		function fit_height()
			{
				on_fit_height();
			}

		function fit_width()
			{
				on_fit_width();
			}

		function fit_size()
			{
				on_fit_size();
			}

		function cache_image()
			{
				if (on_is_must_update_cache_image(u_outer_width, u_outer_height))
					on_cache_image(u_outer_width, u_outer_height);

				super.cache_image();
			}

		function on_serialize(b_out, str_spec, f)
			{
				serialize_atom(b_out, str_spec, f, "m_u_left_outer_pad");
				serialize_atom(b_out, str_spec, f, "m_u_right_outer_pad");
				serialize_atom(b_out, str_spec, f, "m_u_top_outer_pad");
				serialize_atom(b_out, str_spec, f, "m_u_bottom_outer_pad");
				serialize_atom(b_out, str_spec, f, "m_u_left_inner_pad");
				serialize_atom(b_out, str_spec, f, "m_u_right_inner_pad");
				serialize_atom(b_out, str_spec, f, "m_u_top_inner_pad");
				serialize_atom(b_out, str_spec, f, "m_u_bottom_inner_pad");
				serialize_atom(b_out, str_spec, f, "m_u_draw_id");
				serialize_atom(b_out, str_spec, f, "m_b_transparent_parent_update");
				super.on_serialize(*);
			}

		function on_set_option(elm)
			{
				if (elm.left_outer_pad !== void)
					m_u_left_outer_pad = (int)elm.left_outer_pad;

				if (elm.right_outer_pad !== void)
					m_u_right_outer_pad = (int)elm.right_outer_pad;

				if (elm.top_outer_pad !== void)
					m_u_top_outer_pad = (int)elm.top_outer_pad;

				if (elm.bottom_outer_pad !== void)
					m_u_bottom_outer_pad = (int)elm.bottom_outer_pad;

				if (elm.left_inner_pad !== void)
					m_u_left_inner_pad = (int)elm.left_inner_pad;

				if (elm.right_inner_pad !== void)
					m_u_right_inner_pad = (int)elm.right_inner_pad;

				if (elm.top_inner_pad !== void)
					m_u_top_inner_pad = (int)elm.top_inner_pad;

				if (elm.bottom_inner_pad !== void)
					m_u_bottom_inner_pad = (int)elm.bottom_inner_pad;

				super.on_set_option(*);
			}

		function on_get_id()
			{
				var u_id = 0;

				if (!enabled || !nodeEnabled)
					u_id = 5;
				else if (b_commit_down)
					u_id = 4;
				else
					{
						if (focused && !b_enter)
							u_id = 1;
						else if (!focused && b_enter)
							u_id = 2;
						else if (focused && b_enter)
							u_id = 3;
					}

				 return u_id;
			}

		function on_fit_font_size()
			{
				font.height = height - m_u_top_outer_pad - m_u_bottom_outer_pad - m_u_top_inner_pad - m_u_bottom_inner_pad;
			}

		function on_fit_height()
			{
				height = font.height + m_u_top_outer_pad + m_u_bottom_outer_pad + m_u_top_inner_pad + m_u_bottom_inner_pad;
			}

		function on_fit_width()
			{
				width = font.getTextWidth(str_text) + m_u_left_outer_pad + m_u_right_outer_pad + m_u_left_inner_pad + m_u_right_inner_pad;
			}

		function on_fit_size()
			{
				on_fit_height();
				on_fit_width();
			}

		function on_is_must_update_cache_image(u_width, u_height)
			{
				return false;
			}

		function on_cache_image(u_width, u_height)
			{
			}

		function on_is_must_update_paint(u_id)
			{
				return m_u_draw_id != u_id;
			}

		function on_paint()
			{
				var u_id;

				cache_image();

				u_id = get_id();

				if (on_is_must_update_paint(u_id))
					{
						var i_left = 0;
						var i_top = 0;
						var u_width = width;
						var u_height = height;
/*
						fillRect(0, 0, u_width, u_height, 0x00000000);

*/						m_u_draw_id = u_id;

						i_left += m_u_left_outer_pad;
						i_top += m_u_top_outer_pad;
						u_width -= (m_u_left_outer_pad + m_u_right_outer_pad);
						u_height -= (m_u_top_outer_pad + m_u_bottom_outer_pad);

						on_draw_image(u_id, i_left, i_top, u_width, u_height);

						i_left += m_u_left_inner_pad;
						i_top += m_u_top_inner_pad;
						u_width -= (m_u_left_inner_pad + m_u_right_inner_pad);
						u_height -= (m_u_top_inner_pad + m_u_bottom_inner_pad);

						on_draw_text(u_id, i_left, i_top, u_width, u_height);
					}

				return false;
			}

		function on_draw_image(u_id, i_left, i_top, u_width, u_height)
			{
			}

		function on_draw_text(u_id, i_left, i_top, u_width, u_height)
			{
			}

		function on_hit_test(i_x, i_y, b_hit)
				{
					if(b_hit && (!enabled || !nodeEnabled || System.getKeyState(VK_RBUTTON) || System.getKeyState(VK_MBUTTON)))
						{
							super_hit_test(i_x, i_y, false);
							return false;
						}

					return super.on_hit_test(*);
				}

		function on_blur(obj_focused_layer)
			{
				update();

				if (m_b_transparent_parent_update)
					parent.update();

				return super.on_blur(*);
			}

		function on_focus(obj_focused_layer, b_direction)
			{
				update();

				if (m_b_transparent_parent_update)
					parent.update();

				return super.on_focus(*);
			}

		function on_cursor_move(i_x, i_y, u_shift)
			{
				if (is_valid_region(i_x, i_y))
					{
						if (!m_b_commit_button_down && (ssLeft & u_shift) && focused)
							{
								if (is_commit_button(mbLeft, u_shift))
									{
										m_b_commit_button_down = true;
										update();
									}
							}

						if (!m_b_commit_button_down && (ssMiddle & u_shift) && focused)
							{
								if (is_commit_button(mbMiddle, u_shift))
									{
										m_b_commit_button_down = true;
										update();
									}
							}

						if (!m_b_commit_button_down && (ssRight & u_shift) && focused)
							{
								if (is_commit_button(mbRight, u_shift))
									{
										m_b_commit_button_down = true;
										update();
									}
							}
					}
				else
					{
						if (m_b_commit_button_down)
							{
								m_b_commit_button_down = false;
								update();
							}
					}

				return super.on_cursor_move(*);
			}

		function on_key_down(key, u_shift, b_process)
			{
				if (m_obj_bind_widget !== void)
					{
						if (m_obj_bind_widget.key_down(*))
							{
								super_key_down(key, u_shift, false);
								return false;
							}
					}

				return super.on_key_down(*);
			}

		function on_key_up(key, u_shift, b_process)
			{
				if (m_obj_bind_widget !== void)
					{
						if (m_obj_bind_widget.key_up(*))
							{
								super_key_up(key, u_shift, false);
								return false;
							}
					}

				return super.on_key_up(*);
			}

		function on_mouse_wheel(u_shift, i_delta, i_x, i_y)
			{
				if (m_obj_bind_widget !== void)
					{
						if (m_obj_bind_widget.mouse_wheel(*))
							return false;
					}
				return super.on_mouse_wheel(*);
			}

		function on_cursor_enter()
			{
				update();
				return super.on_cursor_enter();
			}

		function on_cursor_leave()
			{
				update();
				return super.on_cursor_leave();
			}

		function on_node_disabled()
			{
				update();
				return super.on_node_disabled();
			}

		function on_node_enabled()
			{
				update();
				return super.on_node_enabled();
			}

		property u_left_outer_pad
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != m_u_left_outer_pad)
							{
								m_u_left_outer_pad = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return m_u_left_outer_pad;
					}
			}

		property u_right_outer_pad
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != m_u_right_outer_pad)
							{
								m_u_right_outer_pad = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return m_u_right_outer_pad;
					}
			}

		property u_top_outer_pad
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != m_u_top_outer_pad)
							{
								m_u_top_outer_pad = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return m_u_top_outer_pad;
					}
			}

		property u_bottom_outer_pad
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != m_u_bottom_outer_pad)
							{
								m_u_bottom_outer_pad = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return m_u_bottom_outer_pad;
					}
			}

		property u_left_inner_pad
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != m_u_left_inner_pad)
							{
								m_u_left_inner_pad = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return m_u_left_inner_pad;
					}
			}

		property u_right_inner_pad
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != m_u_right_inner_pad)
							{
								m_u_right_inner_pad = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return m_u_right_inner_pad;
					}
			}

		property u_top_inner_pad
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != m_u_top_inner_pad)
							{
								m_u_top_inner_pad = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return m_u_top_inner_pad;
					}
			}

		property u_bottom_inner_pad
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != m_u_bottom_inner_pad)
							{
								m_u_bottom_inner_pad = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return m_u_bottom_inner_pad;
					}
			}

		property u_outer_height
			{
				setter(param)
					{
						height = (int)param + m_u_top_outer_pad + m_u_bottom_outer_pad;
					}
				getter
					{
						return height - m_u_top_outer_pad - m_u_bottom_outer_pad;
					}
			}

		property u_outer_width
			{
				setter(param)
					{
						width = (int)param + m_u_left_outer_pad + m_u_right_outer_pad;
					}
				getter
					{
						return width - m_u_left_outer_pad - m_u_right_outer_pad;
					}
			}

		property i_outer_left
			{
				setter(param)
					{
						u_left_outer_pad = param;
					}
				getter
					{
						return u_left_outer_pad;
					}
			}

		property i_outer_right
			{
				setter(param)
					{
						u_right_outer_pad = width - (int)param;
					}
				getter
					{
						return width - u_right_outer_pad;
					}
			}

		property i_outer_top
			{
				setter(param)
					{
						u_top_outer_pad = param;
					}
				getter
					{
						return u_top_outer_pad;
					}
			}

		property i_outer_bottom
			{
				setter(param)
					{
						u_bottom_outer_pad = height - (int)param;
					}
				getter
					{
						return height - u_bottom_outer_pad;
					}
			}

		property u_inner_width
			{
				setter(param)
					{
						u_outer_width = (int)param + u_left_inner_pad + u_right_inner_pad;
					}
				getter
					{
						return u_outer_width - u_left_inner_pad - u_right_inner_pad;
					}
			}

		property u_inner_height
			{
				setter(param)
					{
						u_outer_height = (int)param + u_top_inner_pad + u_bottom_inner_pad;
					}
				getter
					{
						return u_outer_height - u_top_inner_pad - u_bottom_inner_pad;
					}
			}

		property i_inner_left
			{
				setter(param)
					{
						u_left_inner_pad = (int)param - i_outer_left;
					}
				getter
					{
						return i_outer_left + u_left_inner_pad;
					}
			}

		property i_inner_right
			{
				setter(param)
					{
						u_right_inner_pad = i_outer_right - (int)param;
					}
				getter
					{
						return i_outer_right - u_right_inner_pad;
					}
			}

		property i_inner_top
			{
				setter(param)
					{
						u_top_inner_pad = (int)param - i_outer_top;
					}
				getter
					{
						return i_outer_top + u_top_inner_pad;
					}
			}

		property i_inner_bottom
			{
				setter(param)
					{
						u_bottom_inner_pad = i_outer_bottom - (int)param;
					}
				getter
					{
						return i_outer_bottom - u_bottom_inner_pad;
					}
			}

		property width
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != super.width)
							{
								super.width = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return super.width;
					}
			}

		property height
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != super.height)
							{
								super.height = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return super.height;
					}
			}

		property b_enter
			{
				setter(param)
					{
						var b_param = (+param) ? true : false;

						if (super.b_enter != b_param)
							{
								super.b_enter = b_param;

								if (m_b_transparent_parent_update)
									parent.update();

								update();
							}
					}
				getter
					{
						return super.b_enter;
					}
			}

		property enabled
			{
				setter(param)
					{
						var b_param = (+param) ? true : false;

						if (super.enabled != b_param)
							{
								super.enabled = b_param;
								update();
							}
					}
				getter
					{
						return super.enabled;
					}
			}

		property imageWidth
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != super.imageWidth)
							{
								super.imageWidth = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return super.imageWidth;
					}
			}

		property imageHeight
			{
				setter(param)
					{
						var u_param = (int)param;

						if (u_param != super.imageHeight)
							{
								super.imageHeight = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return super.imageHeight;
					}
			}

		property str_text
			{
				setter(param)
					{
						if (param != str_text)
							{
								super.str_text = param;
								m_u_draw_id = 0xffffffff;
								update();
							}
					}
				getter
					{
						return super.str_text;
					}
			}

		property b_transparent_parent_update
			{
				setter(param)
					{
						m_b_transparent_parent_update = (+param != 0);
					}
				getter
					{
						return m_b_transparent_parent_update;
					}
			}
	}


class Kappa_spin_widget_ctrl_interface extends Kappa_widget_ctrl_interface
	{
		var m_u_spin_start_time = void;
		var m_u_spin_process = void;
		var m_spin_key = void;
		var m_u_range_size = 100;

		function Kappa_spin_widget_ctrl_interface(obj_super_layer, b_notify_parent)
			{
				Kappa_widget_ctrl_interface(obj_super_layer, b_notify_parent);
			}

		function finalize()
			{
				if (m_u_spin_start_time !== void)
					System.removeContinuousHandler(__on_spin);
				super.finalize(*);
			}

		function is_spin()
			{
				return (m_u_spin_start_time !== void);
			}

		function begin_spin(key, u_range_size = m_u_range_size)
			{
				if (is_spin())
					return;

				on_begin_spin(*);

				m_u_spin_start_time = System.getTickCount();
				m_spin_key = key;
				m_u_range_size = u_range_size;
				System.addContinuousHandler(__on_spin);
				m_u_spin_process = 0;
				spin(m_spin_key, 1);
				m_u_spin_process = 1;
			}

		function end_spin(key)
			{
				if ((m_u_spin_start_time === void) || (m_spin_key != key))
					return false;

				on_end_spin(*);

				System.removeContinuousHandler(__on_spin);
				m_u_spin_start_time = void;
				m_u_spin_process = void;
				return true;
			}

		function __on_spin(u_tick)
			{
				if (!get_key_state(m_spin_key))
					{
						end_spin(m_spin_key);
					}
				else
					{
						var u_process_time = u_tick - m_u_spin_start_time - 128;

						if (u_process_time > 0)
							{
								var u_process = (int)(Math.pow(u_process_time / 1536, 4) * m_u_range_size);
								spin(m_spin_key, u_process - m_u_spin_process) if (u_process > m_u_spin_process);
								m_u_spin_process = u_process;
							}
					}
			}

		function spin(key, u_delta)
			{
				if (on_spin(*))
					notify_spin(*) if (this isvalid);
			}

		function on_spin(key, u_delta)
			{
				return m_b_notify_parent;
			}

		function on_begin_spin(key, u_range_size)
			{
				return m_b_notify_parent;
			}

		function on_end_spin(key)
			{
				return m_b_notify_parent;
			}

		property enabled
			{
				setter(param)
					{
						var b_param = ((+param) != 0);

						if (super.enabled != b_param)
							{
								if (!b_param && (m_u_spin_start_time !== void))
									end_spin(m_spin_key);

								super.enabled = b_param;
							}
					}
				getter
					{
						return super.enabled;
					}
			}

		property u_range_size
			{
				setter(param)
					{
						var u_param = (int)param;

						if (m_u_range_size != u_param)
							{
								m_u_range_size = u_param;
							}
					}
				getter
					{
						return m_u_range_size;
					}
			}
	}

@endscript

@return


