;
; ViIN
;

@iscript

kag.tagHandlers.scenario_links = function(elm)
	{
		return tagHandlers.scenario_route_links(*);
	} incontextof kag;

kag.tagHandlers.scenario_detail_parent_links = function(elm)
	{
		if (f.u_selected_detail_episode_no !== void)
			tagHandlers.scenario_episode_detail_link(%[
				"show_detail"    => "false",
				"route_no"       => (string)f.u_selected_scenario_route_no,
				"episode_no"     => (string)f.u_selected_detail_episode_no,
				"return_storage" => elm.return_storage,
				"return_target"  => elm.return_target,
				"detail_storage" => elm.detail_storage,
				"detail_target"  => elm.detail_target]);
		else if (f.u_selected_scenario_route_no !== void)
			tagHandlers.scenario_route_detail_link(%[
				"show_detail"    => "false",
				"route_no"       => (string)f.u_selected_scenario_route_no,
				"return_storage" => elm.return_storage,
				"return_target"  => elm.return_target,
				"detail_storage" => elm.detail_storage,
				"detail_target"  => elm.detail_target]);
		return 0;
	} incontextof kag;

kag.tagHandlers.scenario_detail_links = function(elm)
	{
		if (f.u_selected_detail_episode_no !== void)
			return tagHandlers.scenario_scene_detail_links(%[
				"route_no"        => (string)f.u_selected_scenario_route_no,
				"episode_no"      => (string)f.u_selected_detail_episode_no,
				"return_storage"  => elm.return_storage,
				"return_target"   => elm.return_target,
				"detail_storage"  => elm.detail_storage,
				"detail_target"   => elm.detail_target]);
		else if (f.u_selected_scenario_route_no !== void)
			return tagHandlers.scenario_episode_detail_links(%[
				"route_no"        => (string)f.u_selected_scenario_route_no,
				"return_storage"  => elm.return_storage,
				"return_target"   => elm.return_target,
				"detail_storage"  => elm.detail_storage,
				"detail_target"   => elm.detail_target]);
		else
			return tagHandlers.scenario_route_detail_links(%[
				"return_storage"  => elm.return_storage,
				"return_target"   => elm.return_target,
				"detail_storage"  => elm.detail_storage,
				"detail_target"   => elm.detail_target]);

	} incontextof kag;

kag.tagHandlers.scenario_route_links = function(elm)
	{
		var u_route_no = 1;

		while (true)
			{
				if (!Storages.isExistentStorage("scenario_%03d.ks".sprintf(u_route_no)))
					break;

				if (u_route_no != 1)
					fnc_lf();

				tagHandlers.scenario_episode_links(%[
						"route_no"        => (string)u_route_no,
						"return_storage"  => elm.return_storage,
						"return_target"   => elm.return_target,
						"detail_storage"  => elm.detail_storage,
						"detail_target"   => elm.detail_target]);

				u_route_no++;
			}

		return 0;
	} incontextof kag;


kag.tagHandlers.scenario_route_link = function(elm)
	{
		var u_route_no  = (int)elm.route_no;
		var str_storage = "scenario_%03d.ks".sprintf(u_route_no);

		// detail
		fnc_open_scenario_detail_link(elm, str_storage, u_route_no, void);

		// snapshot
		fnc_play_scenario_link(elm, str_storage, "R%03d".sprintf(u_route_no));

		// extra
		fnc_play_scenario_extra_link(elm, str_storage);

		return 0;
	} incontextof kag;

kag.tagHandlers.scenario_episode_links = function(elm)
	{
		var u_episode_no = 0;

		tagHandlers.scenario_route_link(%[
				"route_no"       => elm.route_no,
				"return_storage" => elm.return_storage,
				"return_target"  => elm.return_target,
				"detail_storage" => elm.detail_storage,
				"detail_target"  => elm.detail_target]);

		fnc_pf();

		while (true)
			{
				if (!Storages.isExistentStorage("scenario_%03d_%03d.ks".sprintf((int)elm.route_no, u_episode_no)))
					break;

				if (u_episode_no)
					fnc_lf();

				tagHandlers.scenario_scene_links(%[
						"route_no"       => elm.route_no,
						"episode_no"     => (string)u_episode_no,
						"return_storage" => elm.return_storage,
						"return_target"  => elm.return_target,
						"detail_storage" => elm.detail_storage,
						"detail_target"  => elm.detail_target]);

				u_episode_no++;
			}

		return 0;
	} incontextof kag;

kag.tagHandlers.scenario_episode_link = function(elm)
	{
		var u_route_no   = (int)elm.route_no;
		var u_episode_no = (int)elm.episode_no;
		var str_storage  = "scenario_%03d_%03d.ks".sprintf(u_route_no, u_episode_no);

		// detail
		fnc_open_scenario_detail_link(elm, str_storage, u_route_no, u_episode_no);

		// snapshot
		fnc_play_scenario_link(elm, str_storage, "E%03d".sprintf(u_episode_no));

		// extra
		fnc_play_scenario_extra_link(elm, str_storage);

		return 0;
	} incontextof kag;

kag.tagHandlers.scenario_scene_links = function(elm)
	{
		var u_scene_no = 0;

		tagHandlers.scenario_episode_link(%[
				"route_no"       => elm.route_no,
				"episode_no"     => elm.episode_no,
				"return_storage" => elm.return_storage,
				"return_target"  => elm.return_target,
				"detail_storage" => elm.detail_storage,
				"detail_target"  => elm.detail_target]);

		conductor.enqueueTag(%["tagname" => "indent"]);

		while (true)
			{
				if (!Storages.isExistentStorage("scenario_%03d_%03d_%03d.ks".sprintf((int)elm.route_no, (int)elm.episode_no, u_scene_no + 1)))
					break;

				if (u_scene_no && !(u_scene_no % 4))
					fnc_lf();

				fnc_sp();

				tagHandlers.scenario_scene_link(%[
						"route_no"       => elm.route_no,
						"episode_no"     => elm.episode_no,
						"scene_no"       => (string)(u_scene_no + 1),
						"return_storage" => elm.return_storage,
						"return_target"  => elm.return_target,
						"detail_storage" => elm.detail_storage,
						"detail_target"  => elm.detail_target]);

				u_scene_no++;
			}

		conductor.enqueueTag(%["tagname" => "endindent"]);
		return 0;
	} incontextof kag;

kag.tagHandlers.scenario_scene_link = function(elm)
	{
		var u_route_no   = (int)elm.route_no;
		var u_episode_no = (int)elm.episode_no;
		var u_scene_no   = (int)elm.scene_no;
		var str_storage  = "scenario_%03d_%03d_%03d.ks".sprintf(u_route_no, u_episode_no, u_scene_no);

		// snapshot
		fnc_play_scenario_link(elm, str_storage, "%03d".sprintf(u_scene_no));

		// extra
		fnc_play_scenario_extra_link(elm, str_storage);

		return 0;
	} incontextof kag;

kag.tagHandlers.scenario_route_detail_links = function(elm)
	{
		var u_route_no = 1;

		while (true)
			{
				if (!Storages.isExistentStorage("scenario_%03d.ks".sprintf(u_route_no)))
					break;

				tagHandlers.scenario_route_detail_link(%[
						"route_no"       => (string)u_route_no,
						"return_storage" => elm.return_storage,
						"return_target"  => elm.return_target,
						"detail_storage" => elm.detail_storage,
						"detail_target"  => elm.detail_target]);
				fnc_lf();
				u_route_no++;
			}

		return 0;
	} incontextof kag;

kag.tagHandlers.scenario_route_detail_link = function(elm)
	{
		var u_route_no  = (int)elm.route_no;
		var str_storage = "scenario_%03d.ks".sprintf(u_route_no);

		if (elm.show_detail === void)
			elm.show_detail = "true";

		// detail
		if (+elm.show_detail)
			fnc_open_scenario_detail_link(elm, str_storage, u_route_no, void);
		else
			/*fnc_close_scenario_detail_link(elm, str_storage, void, void)*/;

		// snapshot
		fnc_play_scenario_link(elm, str_storage,
			"#%03d".sprintf(u_route_no) + " " + fnc_get_scenario_subject("%03d".sprintf(u_route_no)));

		// extra
		fnc_play_scenario_extra_link(elm, str_storage);

		return 0;
	} incontextof kag;

kag.tagHandlers.scenario_episode_detail_links = function(elm)
	{
		var u_episode_no = 0;

		while (true)
			{
				if (!Storages.isExistentStorage("scenario_%03d_%03d.ks".sprintf((int)elm.route_no, u_episode_no)))
					break;

				tagHandlers.scenario_episode_detail_link(%[
						"route_no"       => elm.route_no,
						"episode_no"     => (string)u_episode_no,
						"return_storage" => elm.return_storage,
						"return_target"  => elm.return_target,
						"detail_storage" => elm.detail_storage,
						"detail_target"  => elm.detail_target]);
				fnc_lf();
				u_episode_no++;
			}

		return 0;
	} incontextof kag;

kag.tagHandlers.scenario_episode_detail_link = function(elm)
	{
		var u_route_no   = (int)elm.route_no;
		var u_episode_no = (int)elm.episode_no;
		var str_storage  = "scenario_%03d_%03d.ks".sprintf(u_route_no, u_episode_no);

		if (elm.show_detail === void)
			elm.show_detail = "true";

		// detail
		if (+elm.show_detail)
			fnc_open_scenario_detail_link(elm, str_storage, u_route_no, u_episode_no);
		else
			fnc_close_scenario_detail_link(elm, str_storage, u_route_no, void);

		// snapshot
		if (u_episode_no === 0)
			{
				fnc_play_scenario_link(elm, str_storage,
					"#%03d-%03d".sprintf(u_route_no, u_episode_no) + " " +
					(+elm.show_detail ? "" : (fnc_get_scenario_subject("%03d".sprintf(u_route_no)) + "E")) +
					fnc_get_scenario_subject("%03d_%03d".sprintf(u_route_no, u_episode_no)));
			}
		else
			{
				fnc_play_scenario_link(elm, str_storage,
					"#%03d-%03d".sprintf(u_route_no, u_episode_no) + " " +
					(+elm.show_detail ? "" : (fnc_get_scenario_subject("%03d".sprintf(u_route_no)) + "E")) +
					"" + kansuuji(u_episode_no) + "b" + " "
					"w" + fnc_get_scenario_subject("%03d_%03d".sprintf(u_route_no, u_episode_no)) + "x");
			}

		// extra
		fnc_play_scenario_extra_link(elm, str_storage);

		return 0;
	} incontextof kag;

kag.tagHandlers.scenario_scene_detail_links = function(elm)
	{
		var u_scene_no   = 1;

		while (true)
			{
				if (!Storages.isExistentStorage("scenario_%03d_%03d_%03d.ks".sprintf((int)elm.route_no, (int)elm.episode_no, u_scene_no)))
					break;

				tagHandlers.scenario_scene_detail_link(%[
						"route_no"       => elm.route_no,
						"episode_no"     => elm.episode_no,
						"scene_no"       => (string)u_scene_no,
						"return_storage" => elm.return_storage,
						"return_target"  => elm.return_target,
						"detail_storage" => elm.detail_storage,
						"detail_target"  => elm.detail_target]);
				fnc_lf();
				u_scene_no++;
			}

		return 0;
	} incontextof kag;

kag.tagHandlers.scenario_scene_detail_link = function(elm)
	{
		var u_route_no   = (int)elm.route_no;
		var u_episode_no = (int)elm.episode_no;
		var u_scene_no   = (int)elm.scene_no;
		var str_storage  = "scenario_%03d_%03d_%03d.ks".sprintf(u_route_no, u_episode_no, u_scene_no);

		// snapshot
		fnc_play_scenario_link(elm, str_storage,
			"#%03d-%03d-%03d".sprintf(u_route_no, u_episode_no, u_scene_no) + " " +
			"" + kansuuji(u_scene_no) + "" + " "
			"w" + fnc_get_scenario_subject("%03d_%03d_%03d".sprintf(u_route_no, u_episode_no, u_scene_no)) + "x");

		// extra
		fnc_play_scenario_extra_link(elm, str_storage);

		return 0;
	} incontextof kag;

kag.tagHandlers.select_scenario_menu_link = function(elm)
	{
		tagHandlers.begin_menu_link(%[
			"hint" => "͂ȂmF܂",
			"exp" => "fnc_on_call_select_scenario_menu_link('%s','%s','%s')".sprintf(
				elm.return_hint, elm.return_storage, elm.return_target),
			"storage" => "macro_link_scenario.ks", "target" => "*__on_call_select_scenario_menu_link"]);

		fnc_text(" ");
		conductor.enqueueTag(%["tagname" => "locate", "x" => "282"]);
		fnc_text("͂Ȃ");
		conductor.enqueueTag(%["tagname" => "locate", "x" => "686"]);

		tagHandlers.end_menu_link(%[]);
		return 0;
	} incontextof kag;

function fnc_on_call_scenario_link(str_storage, str_target, str_return_storage, str_return_target)
	{
		f.str_selected_scenario_storage    = str_storage;
		f.str_scenario_link_return_storage = str_return_storage;
		f.str_scenario_link_return_target  = str_return_target;
	}

function fnc_on_call_detail(u_selected_scenario_route_no, u_selected_detail_episode_no)
	{
		f.u_selected_scenario_route_no = u_selected_scenario_route_no;
		f.u_selected_detail_episode_no = u_selected_detail_episode_no;
	}

function fnc_on_call_select_scenario_menu_link(str_return_hint, str_return_storage, str_return_target)
	{
		f.str_select_scenario_menu_link_return_hint    = str_return_hint;
		f.str_select_scenario_menu_link_return_storage = str_return_storage;
		f.str_select_scenario_menu_link_return_target  = str_return_target;
	}

function fnc_open_scenario_detail_link(elm, str_storage, u_route_no, u_episode_no)
	{
		kag.tagHandlers.begin_menu_link(%[
			"hint" => fnc_get_scenario_heading(str_storage) + "̉ʌo\܂",
			"exp" => "fnc_on_call_detail(%s,%s)".sprintf(
				u_route_no   !== void ? (string)u_route_no : "void",
				u_episode_no !== void ? (string)u_episode_no : "void"),
			"storage" => elm.detail_storage, "target" => elm.detail_target]);
		fnc_text("+");
		kag.tagHandlers.end_menu_link(%[]);
	}

function fnc_close_scenario_detail_link(elm, str_storage, u_route_no, u_episode_no)
	{
		kag.tagHandlers.begin_menu_link(%[
			"hint" => fnc_get_scenario_heading(str_storage) + "̉ʌo\ɂ܂",
			"exp" => "fnc_on_call_detail(%s,%s)".sprintf(
				u_route_no   !== void ? (string)u_route_no : "void",
				u_episode_no !== void ? (string)u_episode_no : "void"),
			"storage" => elm.detail_storage, "target" => elm.detail_target]);
		fnc_text("-");
		kag.tagHandlers.end_menu_link(%[]);
	}

function fnc_play_scenario_link(elm, str_storage, str_heading)
	{
		kag.tagHandlers.begin_menu_link(%[
			"hint" => fnc_get_scenario_heading(str_storage) + "Đ܂",
			"exp" => "fnc_on_call_scenario_link('%s','%s','%s','%s')".sprintf(
				str_storage, "", elm.return_storage, elm.return_target),
			"storage" => "macro_link_scenario.ks", "target" => "*__on_call_scenario_link"]);

		fnc_text(str_heading);

		kag.conductor.enqueueTag(%["tagname" => "locate", "x" => "614"]);
		kag.tagHandlers.end_menu_link(%[]);
	}

function fnc_play_scenario_extra_link(elm, str_storage)
	{
		var str_extra_storage = "__" + str_storage;

		kag.tagHandlers.begin_menu_link(%[
			"hint" => fnc_get_scenario_heading(str_extra_storage) + "Đ܂",
			"exp" => "fnc_on_call_scenario_link('%s','%s','%s','%s')".sprintf(
				str_extra_storage, "", elm.return_storage, elm.return_target),
			"storage" => "macro_link_scenario.ks", "target" => "*__on_call_scenario_link"]);

		fnc_text("extra");

		kag.tagHandlers.end_menu_link(%[]);
	}

@endscript

@return

*__on_call_scenario_link
@call storage="&f.str_selected_scenario_storage" countpage="true"
@jump storage="&f.str_scenario_link_return_storage" target="&f.str_scenario_link_return_target"

;
; ViII
;

*__on_call_select_scenario_menu_link|͂Ȃ̊mF

@begin_old_description

@back_to_menu_link hint="&f.str_select_scenario_menu_link_return_hint" storage="&f.str_select_scenario_menu_link_return_storage" target="&f.str_select_scenario_menu_link_return_target"
; @sp
; @adjust_scenario_link return_storage="macro_link_scenario.ks" return_target="*__on_call_select_scenario_menu_link"

@pf

@font face="lr oSVbN" size="24" edge="false" shadow="false" bold="false"
@scenario_detail_parent_links return_storage="macro_link_scenario.ks" return_target="*__on_call_select_scenario_menu_link" detail_storage="macro_link_scenario.ks" detail_target="*__on_call_select_scenario_menu_link"

@pf

@font face="lr oSVbN" size="20" edge="false" shadow="false" bold="false"
@scenario_detail_links return_storage="macro_link_scenario.ks" return_target="*__on_call_select_scenario_menu_link" detail_storage="macro_link_scenario.ks" detail_target="*__on_call_select_scenario_menu_link"

@prepare_fi_scene subject="&f.str_selected_scene_subject"
@prepare_fi_selected_appear_actors
@end_old_description
@sf
